/**
 * Copyright (c) 2010-2020 Contributors to the openHAB project
 *
 * See the NOTICE file(s) distributed with this work for additional
 * information.
 *
 * This program and the accompanying materials are made available under the
 * terms of the Eclipse Public License 2.0 which is available at
 * http://www.eclipse.org/legal/epl-2.0
 *
 * SPDX-License-Identifier: EPL-2.0
 */

/* ***********************************************************
* This file was automatically generated on 2020-04-08.      *
*                                                           *
* openHAB Bindings Version 2.0.0                            *
*                                                           *
* If you have a bugfix for this file and want to commit it, *
* please fix the bug in the generator. You can find a link  *
* to the generators git repository on tinkerforge.com       *
*************************************************************/

package org.openhab.binding.tinkerforge.internal.device;

import java.util.HashMap;
import java.util.Map;

import org.eclipse.jdt.annotation.NonNullByDefault;
import org.eclipse.jdt.annotation.Nullable;
import org.eclipse.smarthome.core.thing.binding.ThingActions;
import org.eclipse.smarthome.core.thing.binding.ThingActionsScope;
import org.eclipse.smarthome.core.thing.binding.ThingHandler;
import org.openhab.binding.tinkerforge.internal.handler.DeviceHandler;
import org.openhab.core.automation.annotation.ActionInput;
import org.openhab.core.automation.annotation.ActionOutput;
import org.openhab.core.automation.annotation.RuleAction;

import com.tinkerforge.BrickletIndustrialDual020mA;
import com.tinkerforge.TinkerforgeException;

/**
 * Passes through actions of the Industrial Dual 0-20mA Bricklet.
 * 
 * @author Erik Fleckstein - Initial contribution
 */
@ThingActionsScope(name = "tinkerforge")
@NonNullByDefault
public class BrickletIndustrialDual020mAActions implements ThingActions {

    private @Nullable DeviceHandler handler;

    @Override
    public void setThingHandler(@Nullable ThingHandler handler) {
        this.handler = (DeviceHandler) handler;
    }

    @Override
    public @Nullable ThingHandler getThingHandler() {
        return handler;
    }

    @RuleAction(label = "Get Current")
    public @ActionOutput(name = "current", type = "int") Map<String, Object> brickletIndustrialDual020mAGetCurrent(
            @ActionInput(name = "sensor") short sensor) throws TinkerforgeException {
        Map<String, Object> result = new HashMap<>();
        DeviceHandler h = handler;
        if (h == null) {
            return result;
        }

        @Nullable
        BrickletIndustrialDual020mAWrapper dev = ((@Nullable BrickletIndustrialDual020mAWrapper) h.getDevice());
        if (dev == null) {
            return result;
        }

        int value = dev.getCurrent(sensor);

        result.put("current", value);
        return result;
    }

    public static Map<String, Object> brickletIndustrialDual020mAGetCurrent(@Nullable ThingActions actions,
            short sensor) throws TinkerforgeException {
        if (actions instanceof BrickletIndustrialDual020mAActions) {
            return ((BrickletIndustrialDual020mAActions) actions).brickletIndustrialDual020mAGetCurrent(sensor);
        } else {
            throw new IllegalArgumentException("Instance is not an BrickletIndustrialDual020mAActions class.");
        }
    }

    @RuleAction(label = "Get Sample Rate")
    public @ActionOutput(name = "rate", type = "short") Map<String, Object> brickletIndustrialDual020mAGetSampleRate()
            throws TinkerforgeException {
        Map<String, Object> result = new HashMap<>();
        DeviceHandler h = handler;
        if (h == null) {
            return result;
        }

        @Nullable
        BrickletIndustrialDual020mAWrapper dev = ((@Nullable BrickletIndustrialDual020mAWrapper) h.getDevice());
        if (dev == null) {
            return result;
        }

        short value = dev.getSampleRate();

        result.put("rate", value);
        return result;
    }

    public static Map<String, Object> brickletIndustrialDual020mAGetSampleRate(@Nullable ThingActions actions)
            throws TinkerforgeException {
        if (actions instanceof BrickletIndustrialDual020mAActions) {
            return ((BrickletIndustrialDual020mAActions) actions).brickletIndustrialDual020mAGetSampleRate();
        } else {
            throw new IllegalArgumentException("Instance is not an BrickletIndustrialDual020mAActions class.");
        }
    }

    @RuleAction(label = "Get Identity")
    public @ActionOutput(name = "uid", type = "String") @ActionOutput(name = "connectedUid", type = "String") @ActionOutput(name = "position", type = "char") @ActionOutput(name = "hardwareVersion", type = "short[]") @ActionOutput(name = "firmwareVersion", type = "short[]") @ActionOutput(name = "deviceIdentifier", type = "int") Map<String, Object> brickletIndustrialDual020mAGetIdentity()
            throws TinkerforgeException {
        Map<String, Object> result = new HashMap<>();
        DeviceHandler h = handler;
        if (h == null) {
            return result;
        }

        @Nullable
        BrickletIndustrialDual020mAWrapper dev = ((@Nullable BrickletIndustrialDual020mAWrapper) h.getDevice());
        if (dev == null) {
            return result;
        }

        BrickletIndustrialDual020mA.Identity value = dev.getIdentity();

        result.put("uid", value.uid);
        result.put("connectedUid", value.connectedUid);
        result.put("position", value.position);
        result.put("hardwareVersion", value.hardwareVersion);
        result.put("firmwareVersion", value.firmwareVersion);
        result.put("deviceIdentifier", value.deviceIdentifier);
        return result;
    }

    public static Map<String, Object> brickletIndustrialDual020mAGetIdentity(@Nullable ThingActions actions)
            throws TinkerforgeException {
        if (actions instanceof BrickletIndustrialDual020mAActions) {
            return ((BrickletIndustrialDual020mAActions) actions).brickletIndustrialDual020mAGetIdentity();
        } else {
            throw new IllegalArgumentException("Instance is not an BrickletIndustrialDual020mAActions class.");
        }
    }
}
