/**
 * Copyright (c) 2010-2020 Contributors to the openHAB project
 *
 * See the NOTICE file(s) distributed with this work for additional
 * information.
 *
 * This program and the accompanying materials are made available under the
 * terms of the Eclipse Public License 2.0 which is available at
 * http://www.eclipse.org/legal/epl-2.0
 *
 * SPDX-License-Identifier: EPL-2.0
 */

/* ***********************************************************
 * This file was automatically generated on 2020-04-08.      *
 *                                                           *
 * openHAB Bindings Version 2.0.0                            *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generators git repository on tinkerforge.com       *
 *************************************************************/

package org.openhab.binding.tinkerforge.internal;

import java.net.URI;
import java.util.Arrays;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.eclipse.jdt.annotation.NonNullByDefault;
import org.eclipse.smarthome.core.thing.ThingTypeUID;
import org.eclipse.smarthome.core.thing.type.ChannelTypeUID;

/**
 * The {@link TinkerforgeBindingConstants} class defines common constants, which are
 * used across the whole binding.
 *
 * @author Erik Fleckstein - Initial contribution
 */
@NonNullByDefault
public class TinkerforgeBindingConstants {

    public static final String BINDING_ID = "tinkerforge";

    public static final String PROPERTY_MINIMUM_FIRMWARE_VERSION = "tinkerforge_minimum_firmware_version";
    public static final String PROPERTY_FIRMWARE_URL = "tinkerforge_firmware_url";
    public static final String NEEDS_FIRMWARE_UPDATE_LABEL = " - Firmware too old, please update with Brick Viewer!";

    // List of all Thing Type UIDs
    public static final ThingTypeUID THING_TYPE_BRICK_DAEMON = new ThingTypeUID(BINDING_ID, "brickd");
    public static final ThingTypeUID THING_TYPE_BRICK_DC = new ThingTypeUID(BINDING_ID, "brickdc");
    public static final ThingTypeUID THING_TYPE_BRICK_HAT = new ThingTypeUID(BINDING_ID, "brickhat");
    public static final ThingTypeUID THING_TYPE_BRICK_HAT_ZERO = new ThingTypeUID(BINDING_ID, "brickhatzero");
    public static final ThingTypeUID THING_TYPE_BRICK_IMU = new ThingTypeUID(BINDING_ID, "brickimu");
    public static final ThingTypeUID THING_TYPE_BRICK_IMU_V2 = new ThingTypeUID(BINDING_ID, "brickimuv2");
    public static final ThingTypeUID THING_TYPE_BRICK_MASTER = new ThingTypeUID(BINDING_ID, "brickmaster");
    public static final ThingTypeUID THING_TYPE_BRICK_RED = new ThingTypeUID(BINDING_ID, "brickred");
    public static final ThingTypeUID THING_TYPE_BRICK_SERVO = new ThingTypeUID(BINDING_ID, "brickservo");
    public static final ThingTypeUID THING_TYPE_BRICK_SILENT_STEPPER = new ThingTypeUID(BINDING_ID,
            "bricksilentstepper");
    public static final ThingTypeUID THING_TYPE_BRICK_STEPPER = new ThingTypeUID(BINDING_ID, "brickstepper");
    public static final ThingTypeUID THING_TYPE_BRICKLET_ACCELEROMETER = new ThingTypeUID(BINDING_ID,
            "brickletaccelerometer");
    public static final ThingTypeUID THING_TYPE_BRICKLET_ACCELEROMETER_V2 = new ThingTypeUID(BINDING_ID,
            "brickletaccelerometerv2");
    public static final ThingTypeUID THING_TYPE_BRICKLET_AIR_QUALITY = new ThingTypeUID(BINDING_ID,
            "brickletairquality");
    public static final ThingTypeUID THING_TYPE_BRICKLET_AMBIENT_LIGHT = new ThingTypeUID(BINDING_ID,
            "brickletambientlight");
    public static final ThingTypeUID THING_TYPE_BRICKLET_AMBIENT_LIGHT_V2 = new ThingTypeUID(BINDING_ID,
            "brickletambientlightv2");
    public static final ThingTypeUID THING_TYPE_BRICKLET_AMBIENT_LIGHT_V3 = new ThingTypeUID(BINDING_ID,
            "brickletambientlightv3");
    public static final ThingTypeUID THING_TYPE_BRICKLET_ANALOG_IN = new ThingTypeUID(BINDING_ID, "brickletanalogin");
    public static final ThingTypeUID THING_TYPE_BRICKLET_ANALOG_IN_V2 = new ThingTypeUID(BINDING_ID,
            "brickletanaloginv2");
    public static final ThingTypeUID THING_TYPE_BRICKLET_ANALOG_IN_V3 = new ThingTypeUID(BINDING_ID,
            "brickletanaloginv3");
    public static final ThingTypeUID THING_TYPE_BRICKLET_ANALOG_OUT = new ThingTypeUID(BINDING_ID, "brickletanalogout");
    public static final ThingTypeUID THING_TYPE_BRICKLET_ANALOG_OUT_V2 = new ThingTypeUID(BINDING_ID,
            "brickletanalogoutv2");
    public static final ThingTypeUID THING_TYPE_BRICKLET_ANALOG_OUT_V3 = new ThingTypeUID(BINDING_ID,
            "brickletanalogoutv3");
    public static final ThingTypeUID THING_TYPE_BRICKLET_BAROMETER = new ThingTypeUID(BINDING_ID, "brickletbarometer");
    public static final ThingTypeUID THING_TYPE_BRICKLET_BAROMETER_V2 = new ThingTypeUID(BINDING_ID,
            "brickletbarometerv2");
    public static final ThingTypeUID THING_TYPE_BRICKLET_CAN = new ThingTypeUID(BINDING_ID, "brickletcan");
    public static final ThingTypeUID THING_TYPE_BRICKLET_CAN_V2 = new ThingTypeUID(BINDING_ID, "brickletcanv2");
    public static final ThingTypeUID THING_TYPE_BRICKLET_CO2 = new ThingTypeUID(BINDING_ID, "brickletco2");
    public static final ThingTypeUID THING_TYPE_BRICKLET_CO2_V2 = new ThingTypeUID(BINDING_ID, "brickletco2v2");
    public static final ThingTypeUID THING_TYPE_BRICKLET_COLOR = new ThingTypeUID(BINDING_ID, "brickletcolor");
    public static final ThingTypeUID THING_TYPE_BRICKLET_COLOR_V2 = new ThingTypeUID(BINDING_ID, "brickletcolorv2");
    public static final ThingTypeUID THING_TYPE_BRICKLET_COMPASS = new ThingTypeUID(BINDING_ID, "brickletcompass");
    public static final ThingTypeUID THING_TYPE_BRICKLET_CURRENT12 = new ThingTypeUID(BINDING_ID, "brickletcurrent12");
    public static final ThingTypeUID THING_TYPE_BRICKLET_CURRENT25 = new ThingTypeUID(BINDING_ID, "brickletcurrent25");
    public static final ThingTypeUID THING_TYPE_BRICKLET_DISTANCE_IR = new ThingTypeUID(BINDING_ID,
            "brickletdistanceir");
    public static final ThingTypeUID THING_TYPE_BRICKLET_DISTANCE_IR_V2 = new ThingTypeUID(BINDING_ID,
            "brickletdistanceirv2");
    public static final ThingTypeUID THING_TYPE_BRICKLET_DISTANCE_US = new ThingTypeUID(BINDING_ID,
            "brickletdistanceus");
    public static final ThingTypeUID THING_TYPE_BRICKLET_DISTANCE_US_V2 = new ThingTypeUID(BINDING_ID,
            "brickletdistanceusv2");
    public static final ThingTypeUID THING_TYPE_BRICKLET_DMX = new ThingTypeUID(BINDING_ID, "brickletdmx");
    public static final ThingTypeUID THING_TYPE_BRICKLET_DUAL_BUTTON = new ThingTypeUID(BINDING_ID,
            "brickletdualbutton");
    public static final ThingTypeUID THING_TYPE_BRICKLET_DUAL_BUTTON_V2 = new ThingTypeUID(BINDING_ID,
            "brickletdualbuttonv2");
    public static final ThingTypeUID THING_TYPE_BRICKLET_DUAL_RELAY = new ThingTypeUID(BINDING_ID, "brickletdualrelay");
    public static final ThingTypeUID THING_TYPE_BRICKLET_DUST_DETECTOR = new ThingTypeUID(BINDING_ID,
            "brickletdustdetector");
    public static final ThingTypeUID THING_TYPE_BRICKLET_E_PAPER_296X128 = new ThingTypeUID(BINDING_ID,
            "brickletepaper296x128");
    public static final ThingTypeUID THING_TYPE_BRICKLET_ENERGY_MONITOR = new ThingTypeUID(BINDING_ID,
            "brickletenergymonitor");
    public static final ThingTypeUID THING_TYPE_BRICKLET_GPS = new ThingTypeUID(BINDING_ID, "brickletgps");
    public static final ThingTypeUID THING_TYPE_BRICKLET_GPS_V2 = new ThingTypeUID(BINDING_ID, "brickletgpsv2");
    public static final ThingTypeUID THING_TYPE_BRICKLET_HALL_EFFECT = new ThingTypeUID(BINDING_ID,
            "bricklethalleffect");
    public static final ThingTypeUID THING_TYPE_BRICKLET_HALL_EFFECT_V2 = new ThingTypeUID(BINDING_ID,
            "bricklethalleffectv2");
    public static final ThingTypeUID THING_TYPE_BRICKLET_HUMIDITY = new ThingTypeUID(BINDING_ID, "bricklethumidity");
    public static final ThingTypeUID THING_TYPE_BRICKLET_HUMIDITY_V2 = new ThingTypeUID(BINDING_ID,
            "bricklethumidityv2");
    public static final ThingTypeUID THING_TYPE_BRICKLET_INDUSTRIAL_ANALOG_OUT = new ThingTypeUID(BINDING_ID,
            "brickletindustrialanalogout");
    public static final ThingTypeUID THING_TYPE_BRICKLET_INDUSTRIAL_ANALOG_OUT_V2 = new ThingTypeUID(BINDING_ID,
            "brickletindustrialanalogoutv2");
    public static final ThingTypeUID THING_TYPE_BRICKLET_INDUSTRIAL_COUNTER = new ThingTypeUID(BINDING_ID,
            "brickletindustrialcounter");
    public static final ThingTypeUID THING_TYPE_BRICKLET_INDUSTRIAL_DIGITAL_IN_4 = new ThingTypeUID(BINDING_ID,
            "brickletindustrialdigitalin4");
    public static final ThingTypeUID THING_TYPE_BRICKLET_INDUSTRIAL_DIGITAL_IN_4_V2 = new ThingTypeUID(BINDING_ID,
            "brickletindustrialdigitalin4v2");
    public static final ThingTypeUID THING_TYPE_BRICKLET_INDUSTRIAL_DIGITAL_OUT_4 = new ThingTypeUID(BINDING_ID,
            "brickletindustrialdigitalout4");
    public static final ThingTypeUID THING_TYPE_BRICKLET_INDUSTRIAL_DIGITAL_OUT_4_V2 = new ThingTypeUID(BINDING_ID,
            "brickletindustrialdigitalout4v2");
    public static final ThingTypeUID THING_TYPE_BRICKLET_INDUSTRIAL_DUAL_0_20MA = new ThingTypeUID(BINDING_ID,
            "brickletindustrialdual020ma");
    public static final ThingTypeUID THING_TYPE_BRICKLET_INDUSTRIAL_DUAL_0_20MA_V2 = new ThingTypeUID(BINDING_ID,
            "brickletindustrialdual020mav2");
    public static final ThingTypeUID THING_TYPE_BRICKLET_INDUSTRIAL_DUAL_ANALOG_IN = new ThingTypeUID(BINDING_ID,
            "brickletindustrialdualanalogin");
    public static final ThingTypeUID THING_TYPE_BRICKLET_INDUSTRIAL_DUAL_ANALOG_IN_V2 = new ThingTypeUID(BINDING_ID,
            "brickletindustrialdualanaloginv2");
    public static final ThingTypeUID THING_TYPE_BRICKLET_INDUSTRIAL_DUAL_RELAY = new ThingTypeUID(BINDING_ID,
            "brickletindustrialdualrelay");
    public static final ThingTypeUID THING_TYPE_BRICKLET_INDUSTRIAL_QUAD_RELAY = new ThingTypeUID(BINDING_ID,
            "brickletindustrialquadrelay");
    public static final ThingTypeUID THING_TYPE_BRICKLET_INDUSTRIAL_QUAD_RELAY_V2 = new ThingTypeUID(BINDING_ID,
            "brickletindustrialquadrelayv2");
    public static final ThingTypeUID THING_TYPE_BRICKLET_IO16 = new ThingTypeUID(BINDING_ID, "brickletio16");
    public static final ThingTypeUID THING_TYPE_BRICKLET_IO16_V2 = new ThingTypeUID(BINDING_ID, "brickletio16v2");
    public static final ThingTypeUID THING_TYPE_BRICKLET_IO4 = new ThingTypeUID(BINDING_ID, "brickletio4");
    public static final ThingTypeUID THING_TYPE_BRICKLET_IO4_V2 = new ThingTypeUID(BINDING_ID, "brickletio4v2");
    public static final ThingTypeUID THING_TYPE_BRICKLET_ISOLATOR = new ThingTypeUID(BINDING_ID, "brickletisolator");
    public static final ThingTypeUID THING_TYPE_BRICKLET_JOYSTICK = new ThingTypeUID(BINDING_ID, "brickletjoystick");
    public static final ThingTypeUID THING_TYPE_BRICKLET_JOYSTICK_V2 = new ThingTypeUID(BINDING_ID,
            "brickletjoystickv2");
    public static final ThingTypeUID THING_TYPE_BRICKLET_LASER_RANGE_FINDER = new ThingTypeUID(BINDING_ID,
            "brickletlaserrangefinder");
    public static final ThingTypeUID THING_TYPE_BRICKLET_LASER_RANGE_FINDER_V2 = new ThingTypeUID(BINDING_ID,
            "brickletlaserrangefinderv2");
    public static final ThingTypeUID THING_TYPE_BRICKLET_LCD_128X64 = new ThingTypeUID(BINDING_ID, "brickletlcd128x64");
    public static final ThingTypeUID THING_TYPE_BRICKLET_LCD_16X2 = new ThingTypeUID(BINDING_ID, "brickletlcd16x2");
    public static final ThingTypeUID THING_TYPE_BRICKLET_LCD_20X4 = new ThingTypeUID(BINDING_ID, "brickletlcd20x4");
    public static final ThingTypeUID THING_TYPE_BRICKLET_LED_STRIP = new ThingTypeUID(BINDING_ID, "brickletledstrip");
    public static final ThingTypeUID THING_TYPE_BRICKLET_LED_STRIP_V2 = new ThingTypeUID(BINDING_ID,
            "brickletledstripv2");
    public static final ThingTypeUID THING_TYPE_BRICKLET_LINE = new ThingTypeUID(BINDING_ID, "brickletline");
    public static final ThingTypeUID THING_TYPE_BRICKLET_LINEAR_POTI = new ThingTypeUID(BINDING_ID,
            "brickletlinearpoti");
    public static final ThingTypeUID THING_TYPE_BRICKLET_LINEAR_POTI_V2 = new ThingTypeUID(BINDING_ID,
            "brickletlinearpotiv2");
    public static final ThingTypeUID THING_TYPE_BRICKLET_LOAD_CELL = new ThingTypeUID(BINDING_ID, "brickletloadcell");
    public static final ThingTypeUID THING_TYPE_BRICKLET_LOAD_CELL_V2 = new ThingTypeUID(BINDING_ID,
            "brickletloadcellv2");
    public static final ThingTypeUID THING_TYPE_BRICKLET_MOISTURE = new ThingTypeUID(BINDING_ID, "brickletmoisture");
    public static final ThingTypeUID THING_TYPE_BRICKLET_MOTION_DETECTOR = new ThingTypeUID(BINDING_ID,
            "brickletmotiondetector");
    public static final ThingTypeUID THING_TYPE_BRICKLET_MOTION_DETECTOR_V2 = new ThingTypeUID(BINDING_ID,
            "brickletmotiondetectorv2");
    public static final ThingTypeUID THING_TYPE_BRICKLET_MOTORIZED_LINEAR_POTI = new ThingTypeUID(BINDING_ID,
            "brickletmotorizedlinearpoti");
    public static final ThingTypeUID THING_TYPE_BRICKLET_MULTI_TOUCH = new ThingTypeUID(BINDING_ID,
            "brickletmultitouch");
    public static final ThingTypeUID THING_TYPE_BRICKLET_MULTI_TOUCH_V2 = new ThingTypeUID(BINDING_ID,
            "brickletmultitouchv2");
    public static final ThingTypeUID THING_TYPE_BRICKLET_NFC = new ThingTypeUID(BINDING_ID, "brickletnfc");
    public static final ThingTypeUID THING_TYPE_BRICKLET_NFC_RFID = new ThingTypeUID(BINDING_ID, "brickletnfcrfid");
    public static final ThingTypeUID THING_TYPE_BRICKLET_OLED_128X64 = new ThingTypeUID(BINDING_ID,
            "brickletoled128x64");
    public static final ThingTypeUID THING_TYPE_BRICKLET_OLED_128X64_V2 = new ThingTypeUID(BINDING_ID,
            "brickletoled128x64v2");
    public static final ThingTypeUID THING_TYPE_BRICKLET_OLED_64X48 = new ThingTypeUID(BINDING_ID, "brickletoled64x48");
    public static final ThingTypeUID THING_TYPE_BRICKLET_ONE_WIRE = new ThingTypeUID(BINDING_ID, "brickletonewire");
    public static final ThingTypeUID THING_TYPE_BRICKLET_OUTDOOR_WEATHER = new ThingTypeUID(BINDING_ID,
            "brickletoutdoorweather");
    public static final ThingTypeUID THING_TYPE_BRICKLET_PARTICULATE_MATTER = new ThingTypeUID(BINDING_ID,
            "brickletparticulatematter");
    public static final ThingTypeUID THING_TYPE_BRICKLET_PIEZO_BUZZER = new ThingTypeUID(BINDING_ID,
            "brickletpiezobuzzer");
    public static final ThingTypeUID THING_TYPE_BRICKLET_PIEZO_SPEAKER = new ThingTypeUID(BINDING_ID,
            "brickletpiezospeaker");
    public static final ThingTypeUID THING_TYPE_BRICKLET_PIEZO_SPEAKER_V2 = new ThingTypeUID(BINDING_ID,
            "brickletpiezospeakerv2");
    public static final ThingTypeUID THING_TYPE_BRICKLET_PTC = new ThingTypeUID(BINDING_ID, "brickletptc");
    public static final ThingTypeUID THING_TYPE_BRICKLET_PTC_V2 = new ThingTypeUID(BINDING_ID, "brickletptcv2");
    public static final ThingTypeUID THING_TYPE_BRICKLET_REAL_TIME_CLOCK = new ThingTypeUID(BINDING_ID,
            "brickletrealtimeclock");
    public static final ThingTypeUID THING_TYPE_BRICKLET_REAL_TIME_CLOCK_V2 = new ThingTypeUID(BINDING_ID,
            "brickletrealtimeclockv2");
    public static final ThingTypeUID THING_TYPE_BRICKLET_REMOTE_SWITCH = new ThingTypeUID(BINDING_ID,
            "brickletremoteswitch");
    public static final ThingTypeUID THING_TYPE_BRICKLET_REMOTE_SWITCH_V2 = new ThingTypeUID(BINDING_ID,
            "brickletremoteswitchv2");
    public static final ThingTypeUID THING_TYPE_BRICKLET_RGB_LED_BUTTON = new ThingTypeUID(BINDING_ID,
            "brickletrgbledbutton");
    public static final ThingTypeUID THING_TYPE_BRICKLET_RGB_LED = new ThingTypeUID(BINDING_ID, "brickletrgbled");
    public static final ThingTypeUID THING_TYPE_BRICKLET_RGB_LED_MATRIX = new ThingTypeUID(BINDING_ID,
            "brickletrgbledmatrix");
    public static final ThingTypeUID THING_TYPE_BRICKLET_RGB_LED_V2 = new ThingTypeUID(BINDING_ID, "brickletrgbledv2");
    public static final ThingTypeUID THING_TYPE_BRICKLET_ROTARY_ENCODER = new ThingTypeUID(BINDING_ID,
            "brickletrotaryencoder");
    public static final ThingTypeUID THING_TYPE_BRICKLET_ROTARY_ENCODER_V2 = new ThingTypeUID(BINDING_ID,
            "brickletrotaryencoderv2");
    public static final ThingTypeUID THING_TYPE_BRICKLET_ROTARY_POTI = new ThingTypeUID(BINDING_ID,
            "brickletrotarypoti");
    public static final ThingTypeUID THING_TYPE_BRICKLET_ROTARY_POTI_V2 = new ThingTypeUID(BINDING_ID,
            "brickletrotarypotiv2");
    public static final ThingTypeUID THING_TYPE_BRICKLET_RS232 = new ThingTypeUID(BINDING_ID, "brickletrs232");
    public static final ThingTypeUID THING_TYPE_BRICKLET_RS232_V2 = new ThingTypeUID(BINDING_ID, "brickletrs232v2");
    public static final ThingTypeUID THING_TYPE_BRICKLET_RS485 = new ThingTypeUID(BINDING_ID, "brickletrs485");
    public static final ThingTypeUID THING_TYPE_BRICKLET_SEGMENT_DISPLAY_4X7 = new ThingTypeUID(BINDING_ID,
            "brickletsegmentdisplay4x7");
    public static final ThingTypeUID THING_TYPE_BRICKLET_SEGMENT_DISPLAY_4X7_V2 = new ThingTypeUID(BINDING_ID,
            "brickletsegmentdisplay4x7v2");
    public static final ThingTypeUID THING_TYPE_BRICKLET_SOLID_STATE_RELAY = new ThingTypeUID(BINDING_ID,
            "brickletsolidstaterelay");
    public static final ThingTypeUID THING_TYPE_BRICKLET_SOLID_STATE_RELAY_V2 = new ThingTypeUID(BINDING_ID,
            "brickletsolidstaterelayv2");
    public static final ThingTypeUID THING_TYPE_BRICKLET_SOUND_INTENSITY = new ThingTypeUID(BINDING_ID,
            "brickletsoundintensity");
    public static final ThingTypeUID THING_TYPE_BRICKLET_SOUND_PRESSURE_LEVEL = new ThingTypeUID(BINDING_ID,
            "brickletsoundpressurelevel");
    public static final ThingTypeUID THING_TYPE_BRICKLET_TEMPERATURE = new ThingTypeUID(BINDING_ID,
            "bricklettemperature");
    public static final ThingTypeUID THING_TYPE_BRICKLET_TEMPERATURE_IR = new ThingTypeUID(BINDING_ID,
            "bricklettemperatureir");
    public static final ThingTypeUID THING_TYPE_BRICKLET_TEMPERATURE_IR_V2 = new ThingTypeUID(BINDING_ID,
            "bricklettemperatureirv2");
    public static final ThingTypeUID THING_TYPE_BRICKLET_TEMPERATURE_V2 = new ThingTypeUID(BINDING_ID,
            "bricklettemperaturev2");
    public static final ThingTypeUID THING_TYPE_BRICKLET_THERMAL_IMAGING = new ThingTypeUID(BINDING_ID,
            "brickletthermalimaging");
    public static final ThingTypeUID THING_TYPE_BRICKLET_THERMOCOUPLE = new ThingTypeUID(BINDING_ID,
            "brickletthermocouple");
    public static final ThingTypeUID THING_TYPE_BRICKLET_THERMOCOUPLE_V2 = new ThingTypeUID(BINDING_ID,
            "brickletthermocouplev2");
    public static final ThingTypeUID THING_TYPE_BRICKLET_TILT = new ThingTypeUID(BINDING_ID, "bricklettilt");
    public static final ThingTypeUID THING_TYPE_BRICKLET_UV_LIGHT = new ThingTypeUID(BINDING_ID, "brickletuvlight");
    public static final ThingTypeUID THING_TYPE_BRICKLET_UV_LIGHT_V2 = new ThingTypeUID(BINDING_ID,
            "brickletuvlightv2");
    public static final ThingTypeUID THING_TYPE_BRICKLET_VOLTAGE = new ThingTypeUID(BINDING_ID, "brickletvoltage");
    public static final ThingTypeUID THING_TYPE_BRICKLET_VOLTAGE_CURRENT = new ThingTypeUID(BINDING_ID,
            "brickletvoltagecurrent");
    public static final ThingTypeUID THING_TYPE_BRICKLET_VOLTAGE_CURRENT_V2 = new ThingTypeUID(BINDING_ID,
            "brickletvoltagecurrentv2");
    public static final ThingTypeUID THING_TYPE_BRICKLET_XMC1400_BREAKOUT = new ThingTypeUID(BINDING_ID,
            "brickletxmc1400breakout");
    public static final ThingTypeUID THING_TYPE_OUTDOOR_WEATHER_SENSOR = new ThingTypeUID(BINDING_ID,
            "outdoorweathersensor");
    public static final ThingTypeUID THING_TYPE_OUTDOOR_WEATHER_STATION = new ThingTypeUID(BINDING_ID,
            "outdoorweatherstation");
    public static final ThingTypeUID THING_TYPE_REMOTE_SOCKET_TYPE_A = new ThingTypeUID(BINDING_ID,
            "remotesockettypea");
    public static final ThingTypeUID THING_TYPE_REMOTE_SOCKET_TYPE_B = new ThingTypeUID(BINDING_ID,
            "remotesockettypeb");
    public static final ThingTypeUID THING_TYPE_REMOTE_SOCKET_TYPE_C = new ThingTypeUID(BINDING_ID,
            "remotesockettypec");
    public static final ThingTypeUID THING_TYPE_REMOTE_DIMMER_TYPE_B = new ThingTypeUID(BINDING_ID,
            "remotedimmertypeb");

    public static final List<ThingTypeUID> SUPPORTED_DEVICES = Arrays.asList(THING_TYPE_BRICK_DAEMON,
            THING_TYPE_BRICK_DC, THING_TYPE_BRICK_HAT, THING_TYPE_BRICK_HAT_ZERO, THING_TYPE_BRICK_IMU,
            THING_TYPE_BRICK_IMU_V2, THING_TYPE_BRICK_MASTER, THING_TYPE_BRICK_RED, THING_TYPE_BRICK_SERVO,
            THING_TYPE_BRICK_SILENT_STEPPER, THING_TYPE_BRICK_STEPPER, THING_TYPE_BRICKLET_ACCELEROMETER,
            THING_TYPE_BRICKLET_ACCELEROMETER_V2, THING_TYPE_BRICKLET_AIR_QUALITY, THING_TYPE_BRICKLET_AMBIENT_LIGHT,
            THING_TYPE_BRICKLET_AMBIENT_LIGHT_V2, THING_TYPE_BRICKLET_AMBIENT_LIGHT_V3, THING_TYPE_BRICKLET_ANALOG_IN,
            THING_TYPE_BRICKLET_ANALOG_IN_V2, THING_TYPE_BRICKLET_ANALOG_IN_V3, THING_TYPE_BRICKLET_ANALOG_OUT,
            THING_TYPE_BRICKLET_ANALOG_OUT_V2, THING_TYPE_BRICKLET_ANALOG_OUT_V3, THING_TYPE_BRICKLET_BAROMETER,
            THING_TYPE_BRICKLET_BAROMETER_V2, THING_TYPE_BRICKLET_CAN, THING_TYPE_BRICKLET_CAN_V2,
            THING_TYPE_BRICKLET_CO2, THING_TYPE_BRICKLET_CO2_V2, THING_TYPE_BRICKLET_COLOR,
            THING_TYPE_BRICKLET_COLOR_V2, THING_TYPE_BRICKLET_COMPASS, THING_TYPE_BRICKLET_CURRENT12,
            THING_TYPE_BRICKLET_CURRENT25, THING_TYPE_BRICKLET_DISTANCE_IR, THING_TYPE_BRICKLET_DISTANCE_IR_V2,
            THING_TYPE_BRICKLET_DISTANCE_US, THING_TYPE_BRICKLET_DISTANCE_US_V2, THING_TYPE_BRICKLET_DMX,
            THING_TYPE_BRICKLET_DUAL_BUTTON, THING_TYPE_BRICKLET_DUAL_BUTTON_V2, THING_TYPE_BRICKLET_DUAL_RELAY,
            THING_TYPE_BRICKLET_DUST_DETECTOR, THING_TYPE_BRICKLET_E_PAPER_296X128, THING_TYPE_BRICKLET_ENERGY_MONITOR,
            THING_TYPE_BRICKLET_GPS, THING_TYPE_BRICKLET_GPS_V2, THING_TYPE_BRICKLET_HALL_EFFECT,
            THING_TYPE_BRICKLET_HALL_EFFECT_V2, THING_TYPE_BRICKLET_HUMIDITY, THING_TYPE_BRICKLET_HUMIDITY_V2,
            THING_TYPE_BRICKLET_INDUSTRIAL_ANALOG_OUT, THING_TYPE_BRICKLET_INDUSTRIAL_ANALOG_OUT_V2,
            THING_TYPE_BRICKLET_INDUSTRIAL_COUNTER, THING_TYPE_BRICKLET_INDUSTRIAL_DIGITAL_IN_4,
            THING_TYPE_BRICKLET_INDUSTRIAL_DIGITAL_IN_4_V2, THING_TYPE_BRICKLET_INDUSTRIAL_DIGITAL_OUT_4,
            THING_TYPE_BRICKLET_INDUSTRIAL_DIGITAL_OUT_4_V2, THING_TYPE_BRICKLET_INDUSTRIAL_DUAL_0_20MA,
            THING_TYPE_BRICKLET_INDUSTRIAL_DUAL_0_20MA_V2, THING_TYPE_BRICKLET_INDUSTRIAL_DUAL_ANALOG_IN,
            THING_TYPE_BRICKLET_INDUSTRIAL_DUAL_ANALOG_IN_V2, THING_TYPE_BRICKLET_INDUSTRIAL_DUAL_RELAY,
            THING_TYPE_BRICKLET_INDUSTRIAL_QUAD_RELAY, THING_TYPE_BRICKLET_INDUSTRIAL_QUAD_RELAY_V2,
            THING_TYPE_BRICKLET_IO16, THING_TYPE_BRICKLET_IO16_V2, THING_TYPE_BRICKLET_IO4, THING_TYPE_BRICKLET_IO4_V2,
            THING_TYPE_BRICKLET_ISOLATOR, THING_TYPE_BRICKLET_JOYSTICK, THING_TYPE_BRICKLET_JOYSTICK_V2,
            THING_TYPE_BRICKLET_LASER_RANGE_FINDER, THING_TYPE_BRICKLET_LASER_RANGE_FINDER_V2,
            THING_TYPE_BRICKLET_LCD_128X64, THING_TYPE_BRICKLET_LCD_16X2, THING_TYPE_BRICKLET_LCD_20X4,
            THING_TYPE_BRICKLET_LED_STRIP, THING_TYPE_BRICKLET_LED_STRIP_V2, THING_TYPE_BRICKLET_LINE,
            THING_TYPE_BRICKLET_LINEAR_POTI, THING_TYPE_BRICKLET_LINEAR_POTI_V2, THING_TYPE_BRICKLET_LOAD_CELL,
            THING_TYPE_BRICKLET_LOAD_CELL_V2, THING_TYPE_BRICKLET_MOISTURE, THING_TYPE_BRICKLET_MOTION_DETECTOR,
            THING_TYPE_BRICKLET_MOTION_DETECTOR_V2, THING_TYPE_BRICKLET_MOTORIZED_LINEAR_POTI,
            THING_TYPE_BRICKLET_MULTI_TOUCH, THING_TYPE_BRICKLET_MULTI_TOUCH_V2, THING_TYPE_BRICKLET_NFC,
            THING_TYPE_BRICKLET_NFC_RFID, THING_TYPE_BRICKLET_OLED_128X64, THING_TYPE_BRICKLET_OLED_128X64_V2,
            THING_TYPE_BRICKLET_OLED_64X48, THING_TYPE_BRICKLET_ONE_WIRE, THING_TYPE_BRICKLET_OUTDOOR_WEATHER,
            THING_TYPE_BRICKLET_PARTICULATE_MATTER, THING_TYPE_BRICKLET_PIEZO_BUZZER, THING_TYPE_BRICKLET_PIEZO_SPEAKER,
            THING_TYPE_BRICKLET_PIEZO_SPEAKER_V2, THING_TYPE_BRICKLET_PTC, THING_TYPE_BRICKLET_PTC_V2,
            THING_TYPE_BRICKLET_REAL_TIME_CLOCK, THING_TYPE_BRICKLET_REAL_TIME_CLOCK_V2,
            THING_TYPE_BRICKLET_REMOTE_SWITCH, THING_TYPE_BRICKLET_REMOTE_SWITCH_V2, THING_TYPE_BRICKLET_RGB_LED_BUTTON,
            THING_TYPE_BRICKLET_RGB_LED, THING_TYPE_BRICKLET_RGB_LED_MATRIX, THING_TYPE_BRICKLET_RGB_LED_V2,
            THING_TYPE_BRICKLET_ROTARY_ENCODER, THING_TYPE_BRICKLET_ROTARY_ENCODER_V2, THING_TYPE_BRICKLET_ROTARY_POTI,
            THING_TYPE_BRICKLET_ROTARY_POTI_V2, THING_TYPE_BRICKLET_RS232, THING_TYPE_BRICKLET_RS232_V2,
            THING_TYPE_BRICKLET_RS485, THING_TYPE_BRICKLET_SEGMENT_DISPLAY_4X7,
            THING_TYPE_BRICKLET_SEGMENT_DISPLAY_4X7_V2, THING_TYPE_BRICKLET_SOLID_STATE_RELAY,
            THING_TYPE_BRICKLET_SOLID_STATE_RELAY_V2, THING_TYPE_BRICKLET_SOUND_INTENSITY,
            THING_TYPE_BRICKLET_SOUND_PRESSURE_LEVEL, THING_TYPE_BRICKLET_TEMPERATURE,
            THING_TYPE_BRICKLET_TEMPERATURE_IR, THING_TYPE_BRICKLET_TEMPERATURE_IR_V2,
            THING_TYPE_BRICKLET_TEMPERATURE_V2, THING_TYPE_BRICKLET_THERMAL_IMAGING, THING_TYPE_BRICKLET_THERMOCOUPLE,
            THING_TYPE_BRICKLET_THERMOCOUPLE_V2, THING_TYPE_BRICKLET_TILT, THING_TYPE_BRICKLET_UV_LIGHT,
            THING_TYPE_BRICKLET_UV_LIGHT_V2, THING_TYPE_BRICKLET_VOLTAGE, THING_TYPE_BRICKLET_VOLTAGE_CURRENT,
            THING_TYPE_BRICKLET_VOLTAGE_CURRENT_V2, THING_TYPE_BRICKLET_XMC1400_BREAKOUT,
            THING_TYPE_OUTDOOR_WEATHER_SENSOR, THING_TYPE_OUTDOOR_WEATHER_STATION, THING_TYPE_REMOTE_SOCKET_TYPE_A,
            THING_TYPE_REMOTE_SOCKET_TYPE_B, THING_TYPE_REMOTE_SOCKET_TYPE_C, THING_TYPE_REMOTE_DIMMER_TYPE_B);

    // List of all Channel Type UIDs
    public static final ChannelTypeUID CHANNEL_TYPE_BRICK_DC_CURRENT_VELOCITY = new ChannelTypeUID(BINDING_ID,
            "BrickDCCurrentVelocity");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICK_HAT_USB_VOLTAGE = new ChannelTypeUID(BINDING_ID,
            "BrickHATUSBVoltage");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICK_HAT_DC_VOLTAGE = new ChannelTypeUID(BINDING_ID,
            "BrickHATDCVoltage");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICK_HAT_POWER_BRICKLETS = new ChannelTypeUID(BINDING_ID,
            "BrickHATPowerBricklets");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICK_HAT_SLEEP = new ChannelTypeUID(BINDING_ID, "BrickHATSleep");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICK_HAT_ZERO_USB_VOLTAGE = new ChannelTypeUID(BINDING_ID,
            "BrickHATZeroUSBVoltage");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICK_IMU_ORIENTATION = new ChannelTypeUID(BINDING_ID,
            "BrickIMUOrientation");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICK_IMU_QUATERNION = new ChannelTypeUID(BINDING_ID,
            "BrickIMUQuaternion");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICK_IMU_ACCELERATION = new ChannelTypeUID(BINDING_ID,
            "BrickIMUAcceleration");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICK_IMU_MAGNETIC_FIELD = new ChannelTypeUID(BINDING_ID,
            "BrickIMUMagneticField");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICK_IMU_ANGULAR_VELOCITY = new ChannelTypeUID(BINDING_ID,
            "BrickIMUAngularVelocity");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICK_IMU_ENABLE_LEDS = new ChannelTypeUID(BINDING_ID,
            "BrickIMUEnableLEDs");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICK_IMU_V2_ACCELERATION = new ChannelTypeUID(BINDING_ID,
            "BrickIMUV2Acceleration");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICK_IMU_V2_MAGNETIC_FIELD = new ChannelTypeUID(BINDING_ID,
            "BrickIMUV2MagneticField");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICK_IMU_V2_ANGULAR_VELOCITY = new ChannelTypeUID(BINDING_ID,
            "BrickIMUV2AngularVelocity");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICK_IMU_V2_ORIENTATION = new ChannelTypeUID(BINDING_ID,
            "BrickIMUV2Orientation");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICK_IMU_V2_QUATERNION = new ChannelTypeUID(BINDING_ID,
            "BrickIMUV2Quaternion");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICK_IMU_V2_LINEAR_ACCELERATION = new ChannelTypeUID(BINDING_ID,
            "BrickIMUV2LinearAcceleration");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICK_IMU_V2_GRAVITY_VECTOR = new ChannelTypeUID(BINDING_ID,
            "BrickIMUV2GravityVector");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICK_IMU_V2_TEMPERATURE = new ChannelTypeUID(BINDING_ID,
            "BrickIMUV2Temperature");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICK_IMU_V2_ENABLE_LEDS = new ChannelTypeUID(BINDING_ID,
            "BrickIMUV2EnableLEDs");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICK_MASTER_STACK_VOLTAGE = new ChannelTypeUID(BINDING_ID,
            "BrickMasterStackVoltage");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICK_MASTER_USB_VOLTAGE = new ChannelTypeUID(BINDING_ID,
            "BrickMasterUSBVoltage");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICK_MASTER_STACK_CURRENT = new ChannelTypeUID(BINDING_ID,
            "BrickMasterStackCurrent");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICK_MASTER_BRICKLETS_ENABLED = new ChannelTypeUID(BINDING_ID,
            "BrickMasterBrickletsEnabled");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICK_SILENT_STEPPER_CURRENT_VELOCITY = new ChannelTypeUID(
            BINDING_ID, "BrickSilentStepperCurrentVelocity");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICK_SILENT_STEPPER_CURRENT_POSITION = new ChannelTypeUID(
            BINDING_ID, "BrickSilentStepperCurrentPosition");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICK_SILENT_STEPPER_REMAINING_STEPS = new ChannelTypeUID(
            BINDING_ID, "BrickSilentStepperRemainingSteps");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICK_SILENT_STEPPER_STACK_VOLTAGE = new ChannelTypeUID(BINDING_ID,
            "BrickSilentStepperStackVoltage");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICK_SILENT_STEPPER_EXTERNAL_VOLTAGE = new ChannelTypeUID(
            BINDING_ID, "BrickSilentStepperExternalVoltage");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICK_SILENT_STEPPER_CURRENT_CONSUMPTION = new ChannelTypeUID(
            BINDING_ID, "BrickSilentStepperCurrentConsumption");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICK_SILENT_STEPPER_STATE = new ChannelTypeUID(BINDING_ID,
            "BrickSilentStepperState");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICK_STEPPER_CURRENT_VELOCITY = new ChannelTypeUID(BINDING_ID,
            "BrickStepperCurrentVelocity");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICK_STEPPER_CURRENT_POSITION = new ChannelTypeUID(BINDING_ID,
            "BrickStepperCurrentPosition");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICK_STEPPER_REMAINING_STEPS = new ChannelTypeUID(BINDING_ID,
            "BrickStepperRemainingSteps");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICK_STEPPER_STACK_VOLTAGE = new ChannelTypeUID(BINDING_ID,
            "BrickStepperStackVoltage");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICK_STEPPER_EXTERNAL_VOLTAGE = new ChannelTypeUID(BINDING_ID,
            "BrickStepperExternalVoltage");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICK_STEPPER_CURRENT_CONSUMPTION = new ChannelTypeUID(BINDING_ID,
            "BrickStepperCurrentConsumption");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICK_STEPPER_STATE = new ChannelTypeUID(BINDING_ID,
            "BrickStepperState");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_ACCELEROMETER_ACCELERATION = new ChannelTypeUID(BINDING_ID,
            "BrickletAccelerometerAcceleration");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_ACCELEROMETER_LED = new ChannelTypeUID(BINDING_ID,
            "BrickletAccelerometerLED");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_ACCELEROMETER_TEMPERATURE = new ChannelTypeUID(BINDING_ID,
            "BrickletAccelerometerTemperature");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_ACCELEROMETER_V2_ACCELERATION = new ChannelTypeUID(
            BINDING_ID, "BrickletAccelerometerV2Acceleration");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_AIR_QUALITY_HUMIDITY = new ChannelTypeUID(BINDING_ID,
            "BrickletAirQualityHumidity");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_AIR_QUALITY_TEMPERATURE = new ChannelTypeUID(BINDING_ID,
            "BrickletAirQualityTemperature");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_AIR_QUALITY_AIR_PRESSURE = new ChannelTypeUID(BINDING_ID,
            "BrickletAirQualityAirPressure");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_AIR_QUALITY_IAQ_INDEX = new ChannelTypeUID(BINDING_ID,
            "BrickletAirQualityIAQIndex");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_AIR_QUALITY_IAQ_INDEX_ACCURACY = new ChannelTypeUID(
            BINDING_ID, "BrickletAirQualityIAQIndexAccuracy");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_AMBIENT_LIGHT_ILLUMINANCE = new ChannelTypeUID(BINDING_ID,
            "BrickletAmbientLightIlluminance");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_AMBIENT_LIGHT_ANALOG_VALUE = new ChannelTypeUID(BINDING_ID,
            "BrickletAmbientLightAnalogValue");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_AMBIENT_LIGHT_V2_ILLUMINANCE = new ChannelTypeUID(
            BINDING_ID, "BrickletAmbientLightV2Illuminance");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_AMBIENT_LIGHT_V3_ILLUMINANCE = new ChannelTypeUID(
            BINDING_ID, "BrickletAmbientLightV3Illuminance");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_ANALOG_IN_VOLTAGE = new ChannelTypeUID(BINDING_ID,
            "BrickletAnalogInVoltage");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_ANALOG_IN_ANALOG_VALUE = new ChannelTypeUID(BINDING_ID,
            "BrickletAnalogInAnalogValue");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_ANALOG_IN_V2_VOLTAGE = new ChannelTypeUID(BINDING_ID,
            "BrickletAnalogInV2Voltage");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_ANALOG_IN_V2_ANALOG_VALUE = new ChannelTypeUID(BINDING_ID,
            "BrickletAnalogInV2AnalogValue");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_ANALOG_IN_V3_VOLTAGE = new ChannelTypeUID(BINDING_ID,
            "BrickletAnalogInV3Voltage");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_ANALOG_OUT_VOLTAGE = new ChannelTypeUID(BINDING_ID,
            "BrickletAnalogOutVoltage");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_ANALOG_OUT_MODE = new ChannelTypeUID(BINDING_ID,
            "BrickletAnalogOutMode");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_ANALOG_OUT_V2_INPUT_VOLTAGE = new ChannelTypeUID(
            BINDING_ID, "BrickletAnalogOutV2InputVoltage");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_ANALOG_OUT_V2_OUTPUT_VOLTAGE = new ChannelTypeUID(
            BINDING_ID, "BrickletAnalogOutV2OutputVoltage");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_ANALOG_OUT_V3_INPUT_VOLTAGE = new ChannelTypeUID(
            BINDING_ID, "BrickletAnalogOutV3InputVoltage");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_ANALOG_OUT_V3_OUTPUT_VOLTAGE = new ChannelTypeUID(
            BINDING_ID, "BrickletAnalogOutV3OutputVoltage");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_BAROMETER_AIR_PRESSURE = new ChannelTypeUID(BINDING_ID,
            "BrickletBarometerAirPressure");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_BAROMETER_ALTITUDE = new ChannelTypeUID(BINDING_ID,
            "BrickletBarometerAltitude");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_BAROMETER_V2_AIR_PRESSURE = new ChannelTypeUID(BINDING_ID,
            "BrickletBarometerV2AirPressure");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_BAROMETER_V2_ALTITUDE = new ChannelTypeUID(BINDING_ID,
            "BrickletBarometerV2Altitude");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_BAROMETER_V2_TEMPERATURE = new ChannelTypeUID(BINDING_ID,
            "BrickletBarometerV2Temperature");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_CAN_WRITE_ERROR_LEVEL = new ChannelTypeUID(BINDING_ID,
            "BrickletCANWriteErrorLevel");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_CAN_READ_ERROR_LEVEL = new ChannelTypeUID(BINDING_ID,
            "BrickletCANReadErrorLevel");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_CAN_TRANSCEIVER_DISABLED = new ChannelTypeUID(BINDING_ID,
            "BrickletCANTransceiverDisabled");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_CAN_WRITE_TIMEOUT_COUNT = new ChannelTypeUID(BINDING_ID,
            "BrickletCANWriteTimeoutCount");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_CAN_READ_REGISTER_OVERFLOW_COUNT = new ChannelTypeUID(
            BINDING_ID, "BrickletCANReadRegisterOverflowCount");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_CAN_READ_BUFFER_OVERFLOW_COUNT = new ChannelTypeUID(
            BINDING_ID, "BrickletCANReadBufferOverflowCount");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_CO2_CO2_CONCENTRATION = new ChannelTypeUID(BINDING_ID,
            "BrickletCO2CO2Concentration");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_CO2_V2_CO2_CONCENTRATION = new ChannelTypeUID(BINDING_ID,
            "BrickletCO2V2CO2Concentration");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_CO2_V2_TEMPERATURE = new ChannelTypeUID(BINDING_ID,
            "BrickletCO2V2Temperature");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_CO2_V2_HUMIDITY = new ChannelTypeUID(BINDING_ID,
            "BrickletCO2V2Humidity");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_CO2_V2_AIR_PRESSURE = new ChannelTypeUID(BINDING_ID,
            "BrickletCO2V2AirPressure");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_COLOR_COLOR = new ChannelTypeUID(BINDING_ID,
            "BrickletColorColor");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_COLOR_ILLUMINANCE = new ChannelTypeUID(BINDING_ID,
            "BrickletColorIlluminance");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_COLOR_COLOR_TEMPERATURE = new ChannelTypeUID(BINDING_ID,
            "BrickletColorColorTemperature");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_COLOR_LIGHT = new ChannelTypeUID(BINDING_ID,
            "BrickletColorLight");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_COLOR_V2_COLOR = new ChannelTypeUID(BINDING_ID,
            "BrickletColorV2Color");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_COLOR_V2_ILLUMINANCE = new ChannelTypeUID(BINDING_ID,
            "BrickletColorV2Illuminance");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_COLOR_V2_COLOR_TEMPERATURE = new ChannelTypeUID(BINDING_ID,
            "BrickletColorV2ColorTemperature");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_COLOR_V2_LIGHT = new ChannelTypeUID(BINDING_ID,
            "BrickletColorV2Light");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_COMPASS_HEADING = new ChannelTypeUID(BINDING_ID,
            "BrickletCompassHeading");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_COMPASS_MAGNETIC_FLUX_DENSITY = new ChannelTypeUID(
            BINDING_ID, "BrickletCompassMagneticFluxDensity");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_CURRENT12_CURRENT = new ChannelTypeUID(BINDING_ID,
            "BrickletCurrent12Current");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_CURRENT12_OVER_CURRENT = new ChannelTypeUID(BINDING_ID,
            "BrickletCurrent12OverCurrent");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_CURRENT12_ANALOG_VALUE = new ChannelTypeUID(BINDING_ID,
            "BrickletCurrent12AnalogValue");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_CURRENT25_CURRENT = new ChannelTypeUID(BINDING_ID,
            "BrickletCurrent25Current");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_CURRENT25_OVER_CURRENT = new ChannelTypeUID(BINDING_ID,
            "BrickletCurrent25OverCurrent");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_CURRENT25_ANALOG_VALUE = new ChannelTypeUID(BINDING_ID,
            "BrickletCurrent25AnalogValue");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_DISTANCE_IR_DISTANCE = new ChannelTypeUID(BINDING_ID,
            "BrickletDistanceIRDistance");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_DISTANCE_IR_ANALOG_VALUE = new ChannelTypeUID(BINDING_ID,
            "BrickletDistanceIRAnalogValue");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_DISTANCE_IR_V2_DISTANCE = new ChannelTypeUID(BINDING_ID,
            "BrickletDistanceIRV2Distance");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_DISTANCE_IR_V2_ANALOG_VALUE = new ChannelTypeUID(
            BINDING_ID, "BrickletDistanceIRV2AnalogValue");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_DISTANCE_US_DISTANCE = new ChannelTypeUID(BINDING_ID,
            "BrickletDistanceUSDistance");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_DISTANCE_US_V2_DISTANCE = new ChannelTypeUID(BINDING_ID,
            "BrickletDistanceUSV2Distance");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_DMX_OVERRUN_ERROR_COUNT = new ChannelTypeUID(BINDING_ID,
            "BrickletDMXOverrunErrorCount");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_DMX_FRAMING_ERROR_COUNT = new ChannelTypeUID(BINDING_ID,
            "BrickletDMXFramingErrorCount");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_DUAL_BUTTON_LEFT_LED = new ChannelTypeUID(BINDING_ID,
            "BrickletDualButtonLeftLED");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_DUAL_BUTTON_RIGHT_LED = new ChannelTypeUID(BINDING_ID,
            "BrickletDualButtonRightLED");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_DUAL_BUTTON_V2_LEFT_LED = new ChannelTypeUID(BINDING_ID,
            "BrickletDualButtonV2LeftLED");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_DUAL_BUTTON_V2_RIGHT_LED = new ChannelTypeUID(BINDING_ID,
            "BrickletDualButtonV2RightLED");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_DUAL_RELAY_RELAY = new ChannelTypeUID(BINDING_ID,
            "BrickletDualRelayRelay");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_DUAL_RELAY_MONOFLOP = new ChannelTypeUID(BINDING_ID,
            "BrickletDualRelayMonoflop");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_DUST_DETECTOR_DUST_DENSITY = new ChannelTypeUID(BINDING_ID,
            "BrickletDustDetectorDustDensity");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_E_PAPER_296X128_DRAW_STATUS = new ChannelTypeUID(
            BINDING_ID, "BrickletEPaper296x128DrawStatus");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_ENERGY_MONITOR_VOLTAGE = new ChannelTypeUID(BINDING_ID,
            "BrickletEnergyMonitorVoltage");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_ENERGY_MONITOR_CURRENT = new ChannelTypeUID(BINDING_ID,
            "BrickletEnergyMonitorCurrent");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_ENERGY_MONITOR_ENERGY = new ChannelTypeUID(BINDING_ID,
            "BrickletEnergyMonitorEnergy");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_ENERGY_MONITOR_REALPOWER = new ChannelTypeUID(BINDING_ID,
            "BrickletEnergyMonitorRealPower");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_ENERGY_MONITOR_APPPOWER = new ChannelTypeUID(BINDING_ID,
            "BrickletEnergyMonitorAppPower");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_ENERGY_MONITOR_REACPOWER = new ChannelTypeUID(BINDING_ID,
            "BrickletEnergyMonitorReacPower");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_ENERGY_MONITOR_FACTOR = new ChannelTypeUID(BINDING_ID,
            "BrickletEnergyMonitorFactor");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_ENERGY_MONITOR_FREQUENCY = new ChannelTypeUID(BINDING_ID,
            "BrickletEnergyMonitorFrequency");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_ENERGY_MONITOR_RESET = new ChannelTypeUID(BINDING_ID,
            "BrickletEnergyMonitorReset");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_GPS_COORDINATES = new ChannelTypeUID(BINDING_ID,
            "BrickletGPSCoordinates");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_GPS_FIX = new ChannelTypeUID(BINDING_ID, "BrickletGPSFix");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_GPS_SATELLITES_IN_VIEW = new ChannelTypeUID(BINDING_ID,
            "BrickletGPSSatellitesInView");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_GPS_SATELLITES_USED = new ChannelTypeUID(BINDING_ID,
            "BrickletGPSSatellitesUsed");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_GPS_ALTITUDE = new ChannelTypeUID(BINDING_ID,
            "BrickletGPSAltitude");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_GPS_GEOIDAL_SEPARATION = new ChannelTypeUID(BINDING_ID,
            "BrickletGPSGeoidalSeparation");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_GPS_COURSE = new ChannelTypeUID(BINDING_ID,
            "BrickletGPSCourse");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_GPS_SPEED = new ChannelTypeUID(BINDING_ID,
            "BrickletGPSSpeed");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_GPS_DATE_TIME = new ChannelTypeUID(BINDING_ID,
            "BrickletGPSDateTime");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_GPS_RESTART = new ChannelTypeUID(BINDING_ID,
            "BrickletGPSRestart");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_GPS_V2_COORDINATES = new ChannelTypeUID(BINDING_ID,
            "BrickletGPSV2Coordinates");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_GPS_V2_FIX = new ChannelTypeUID(BINDING_ID,
            "BrickletGPSV2Fix");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_GPS_V2_SATELLITES_IN_VIEW = new ChannelTypeUID(BINDING_ID,
            "BrickletGPSV2SatellitesInView");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_GPS_V2_ALTITUDE = new ChannelTypeUID(BINDING_ID,
            "BrickletGPSV2Altitude");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_GPS_V2_GEOIDAL_SEPARATION = new ChannelTypeUID(BINDING_ID,
            "BrickletGPSV2GeoidalSeparation");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_GPS_V2_COURSE = new ChannelTypeUID(BINDING_ID,
            "BrickletGPSV2Course");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_GPS_V2_SPEED = new ChannelTypeUID(BINDING_ID,
            "BrickletGPSV2Speed");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_GPS_V2_DATE_TIME = new ChannelTypeUID(BINDING_ID,
            "BrickletGPSV2DateTime");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_GPS_V2_RESTART = new ChannelTypeUID(BINDING_ID,
            "BrickletGPSV2Restart");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_HALL_EFFECT_EDGE_COUNT = new ChannelTypeUID(BINDING_ID,
            "BrickletHallEffectEdgeCount");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_HALL_EFFECT_MAGNETIC_FIELD_DETECTED = new ChannelTypeUID(
            BINDING_ID, "BrickletHallEffectMagneticFieldDetected");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_HALL_EFFECT_V2_COUNTER = new ChannelTypeUID(BINDING_ID,
            "BrickletHallEffectV2Counter");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_HALL_EFFECT_V2_MAGNETIC_FLUX_DENSITY = new ChannelTypeUID(
            BINDING_ID, "BrickletHallEffectV2MagneticFluxDensity");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_HUMIDITY_HUMIDITY = new ChannelTypeUID(BINDING_ID,
            "BrickletHumidityHumidity");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_HUMIDITY_ANALOG_VALUE = new ChannelTypeUID(BINDING_ID,
            "BrickletHumidityAnalogValue");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_HUMIDITY_V2_HUMIDITY = new ChannelTypeUID(BINDING_ID,
            "BrickletHumidityV2Humidity");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_HUMIDITY_V2_TEMPERATURE = new ChannelTypeUID(BINDING_ID,
            "BrickletHumidityV2Temperature");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_HUMIDITY_V2_HEATER = new ChannelTypeUID(BINDING_ID,
            "BrickletHumidityV2Heater");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_INDUSTRIAL_ANALOG_OUT_ENABLED = new ChannelTypeUID(
            BINDING_ID, "BrickletIndustrialAnalogOutEnabled");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_INDUSTRIAL_ANALOG_OUT_VOLTAGE = new ChannelTypeUID(
            BINDING_ID, "BrickletIndustrialAnalogOutVoltage");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_INDUSTRIAL_ANALOG_OUT_CURRENT = new ChannelTypeUID(
            BINDING_ID, "BrickletIndustrialAnalogOutCurrent");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_INDUSTRIAL_ANALOG_OUT_V2_ENABLED = new ChannelTypeUID(
            BINDING_ID, "BrickletIndustrialAnalogOutV2Enabled");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_INDUSTRIAL_ANALOG_OUT_V2_VOLTAGE = new ChannelTypeUID(
            BINDING_ID, "BrickletIndustrialAnalogOutV2Voltage");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_INDUSTRIAL_ANALOG_OUT_V2_CURRENT = new ChannelTypeUID(
            BINDING_ID, "BrickletIndustrialAnalogOutV2Current");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_INDUSTRIAL_COUNTER_DUTY_CYCLE = new ChannelTypeUID(
            BINDING_ID, "BrickletIndustrialCounterDutyCycle");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_INDUSTRIAL_COUNTER_PERIOD = new ChannelTypeUID(BINDING_ID,
            "BrickletIndustrialCounterPeriod");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_INDUSTRIAL_COUNTER_FREQUENCY = new ChannelTypeUID(
            BINDING_ID, "BrickletIndustrialCounterFrequency");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_INDUSTRIAL_COUNTER_VALUE = new ChannelTypeUID(BINDING_ID,
            "BrickletIndustrialCounterValue");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_INDUSTRIAL_COUNTER_COUNTER = new ChannelTypeUID(BINDING_ID,
            "BrickletIndustrialCounterCounter");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_INDUSTRIAL_DIGITAL_IN_4_INPUT_PIN = new ChannelTypeUID(
            BINDING_ID, "BrickletIndustrialDigitalIn4InputPin");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_INDUSTRIAL_DIGITAL_IN_4_EDGE_COUNT = new ChannelTypeUID(
            BINDING_ID, "BrickletIndustrialDigitalIn4EdgeCount");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_INDUSTRIAL_DIGITAL_IN_4_V2_VALUE = new ChannelTypeUID(
            BINDING_ID, "BrickletIndustrialDigitalIn4V2Value");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_INDUSTRIAL_DIGITAL_IN_4_V2_EDGE_COUNT = new ChannelTypeUID(
            BINDING_ID, "BrickletIndustrialDigitalIn4V2EdgeCount");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_INDUSTRIAL_DIGITAL_OUT_4_OUTPUT_PIN = new ChannelTypeUID(
            BINDING_ID, "BrickletIndustrialDigitalOut4OutputPin");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_INDUSTRIAL_DIGITAL_OUT_4_MONOFLOP = new ChannelTypeUID(
            BINDING_ID, "BrickletIndustrialDigitalOut4Monoflop");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_INDUSTRIAL_DIGITAL_OUT_4_V2_OUTPUT_PIN = new ChannelTypeUID(
            BINDING_ID, "BrickletIndustrialDigitalOut4V2OutputPin");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_INDUSTRIAL_DIGITAL_OUT_4_V2_MONOFLOP = new ChannelTypeUID(
            BINDING_ID, "BrickletIndustrialDigitalOut4V2Monoflop");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_INDUSTRIAL_DUAL_0_20MA_CURRENT = new ChannelTypeUID(
            BINDING_ID, "BrickletIndustrialDual020mACurrent");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_INDUSTRIAL_DUAL_0_20MA_V2_CURRENT = new ChannelTypeUID(
            BINDING_ID, "BrickletIndustrialDual020mAV2Current");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_INDUSTRIAL_DUAL_ANALOG_IN_VOLTAGE = new ChannelTypeUID(
            BINDING_ID, "BrickletIndustrialDualAnalogInVoltage");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_INDUSTRIAL_DUAL_ANALOG_IN_V2_VOLTAGE = new ChannelTypeUID(
            BINDING_ID, "BrickletIndustrialDualAnalogInV2Voltage");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_INDUSTRIAL_DUAL_RELAY_RELAY = new ChannelTypeUID(
            BINDING_ID, "BrickletIndustrialDualRelayRelay");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_INDUSTRIAL_DUAL_RELAY_MONOFLOP = new ChannelTypeUID(
            BINDING_ID, "BrickletIndustrialDualRelayMonoflop");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_INDUSTRIAL_QUAD_RELAY_RELAY = new ChannelTypeUID(
            BINDING_ID, "BrickletIndustrialQuadRelayRelay");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_INDUSTRIAL_QUAD_RELAY_MONOFLOP = new ChannelTypeUID(
            BINDING_ID, "BrickletIndustrialQuadRelayMonoflop");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_INDUSTRIAL_QUAD_RELAY_V2_RELAY = new ChannelTypeUID(
            BINDING_ID, "BrickletIndustrialQuadRelayV2Relay");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_INDUSTRIAL_QUAD_RELAY_V2_MONOFLOP = new ChannelTypeUID(
            BINDING_ID, "BrickletIndustrialQuadRelayV2Monoflop");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_IO16_INPUT_PIN = new ChannelTypeUID(BINDING_ID,
            "BrickletIO16InputPin");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_IO16_OUTPUT_PIN = new ChannelTypeUID(BINDING_ID,
            "BrickletIO16OutputPin");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_IO16_MONOFLOP = new ChannelTypeUID(BINDING_ID,
            "BrickletIO16Monoflop");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_IO16_EDGE_COUNT = new ChannelTypeUID(BINDING_ID,
            "BrickletIO16EdgeCount");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_IO16_V2_INPUT_VALUE = new ChannelTypeUID(BINDING_ID,
            "BrickletIO16V2InputValue");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_IO16_V2_OUTPUT_PIN = new ChannelTypeUID(BINDING_ID,
            "BrickletIO16V2OutputPin");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_IO16_V2_MONOFLOP = new ChannelTypeUID(BINDING_ID,
            "BrickletIO16V2Monoflop");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_IO16_V2_EDGE_COUNT = new ChannelTypeUID(BINDING_ID,
            "BrickletIO16V2EdgeCount");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_IO4_INPUT_PIN = new ChannelTypeUID(BINDING_ID,
            "BrickletIO4InputPin");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_IO4_OUTPUT_PIN = new ChannelTypeUID(BINDING_ID,
            "BrickletIO4OutputPin");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_IO4_MONOFLOP = new ChannelTypeUID(BINDING_ID,
            "BrickletIO4Monoflop");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_IO4_EDGE_COUNT = new ChannelTypeUID(BINDING_ID,
            "BrickletIO4EdgeCount");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_IO4_V2_INPUT_VALUE = new ChannelTypeUID(BINDING_ID,
            "BrickletIO4V2InputValue");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_IO4_V2_OUTPUT_PIN = new ChannelTypeUID(BINDING_ID,
            "BrickletIO4V2OutputPin");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_IO4_V2_MONOFLOP = new ChannelTypeUID(BINDING_ID,
            "BrickletIO4V2Monoflop");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_IO4_V2_EDGE_COUNT = new ChannelTypeUID(BINDING_ID,
            "BrickletIO4V2EdgeCount");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_ISOLATOR_MESSAGES_FROM_BRICK = new ChannelTypeUID(
            BINDING_ID, "BrickletIsolatorMessagesFromBrick");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_ISOLATOR_MESSAGES_FROM_BRICKLET = new ChannelTypeUID(
            BINDING_ID, "BrickletIsolatorMessagesFromBricklet");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_ISOLATOR_CONNECTED_BRICKLET_DEVICE_NAME = new ChannelTypeUID(
            BINDING_ID, "BrickletIsolatorConnectedBrickletDeviceName");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_ISOLATOR_CONNECTED_BRICKLET_UID = new ChannelTypeUID(
            BINDING_ID, "BrickletIsolatorConnectedBrickletUID");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_JOYSTICK_POSITION = new ChannelTypeUID(BINDING_ID,
            "BrickletJoystickPosition");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_JOYSTICK_ANALOG_VALUE_X = new ChannelTypeUID(BINDING_ID,
            "BrickletJoystickAnalogValueX");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_JOYSTICK_ANALOG_VALUE_Y = new ChannelTypeUID(BINDING_ID,
            "BrickletJoystickAnalogValueY");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_JOYSTICK_V2_POSITION = new ChannelTypeUID(BINDING_ID,
            "BrickletJoystickV2Position");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_LASER_RANGE_FINDER_DISTANCE = new ChannelTypeUID(
            BINDING_ID, "BrickletLaserRangeFinderDistance");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_LASER_RANGE_FINDER_VELOCITY = new ChannelTypeUID(
            BINDING_ID, "BrickletLaserRangeFinderVelocity");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_LASER_RANGE_FINDER_ENABLE_LASER = new ChannelTypeUID(
            BINDING_ID, "BrickletLaserRangeFinderEnableLaser");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_LASER_RANGE_FINDER_V2_DISTANCE = new ChannelTypeUID(
            BINDING_ID, "BrickletLaserRangeFinderV2Distance");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_LASER_RANGE_FINDER_V2_VELOCITY = new ChannelTypeUID(
            BINDING_ID, "BrickletLaserRangeFinderV2Velocity");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_LASER_RANGE_FINDER_V2_ENABLE_LASER = new ChannelTypeUID(
            BINDING_ID, "BrickletLaserRangeFinderV2EnableLaser");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_LCD_128X64_TEXT = new ChannelTypeUID(BINDING_ID,
            "BrickletLCD128x64Text");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_LCD_128X64_CLEAR_DISPLAY = new ChannelTypeUID(BINDING_ID,
            "BrickletLCD128x64ClearDisplay");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_LCD_128X64_DRAW_BUFFERED_FRAME = new ChannelTypeUID(
            BINDING_ID, "BrickletLCD128x64DrawBufferedFrame");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_LCD_128X64_BACKLIGHT = new ChannelTypeUID(BINDING_ID,
            "BrickletLCD128x64Backlight");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_LCD_128X64_GUI_TAB_SELECTED = new ChannelTypeUID(
            BINDING_ID, "BrickletLCD128x64GUITabSelected");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_LCD_128X64_GUI_SLIDER = new ChannelTypeUID(BINDING_ID,
            "BrickletLCD128x64GUISlider");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_LCD_16X2_TEXT = new ChannelTypeUID(BINDING_ID,
            "BrickletLCD16x2Text");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_LCD_16X2_CLEAR_DISPLAY = new ChannelTypeUID(BINDING_ID,
            "BrickletLCD16x2ClearDisplay");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_LCD_16X2_BACKLIGHT = new ChannelTypeUID(BINDING_ID,
            "BrickletLCD16x2Backlight");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_LCD_20X4_TEXT = new ChannelTypeUID(BINDING_ID,
            "BrickletLCD20x4Text");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_LCD_20X4_CLEAR_DISPLAY = new ChannelTypeUID(BINDING_ID,
            "BrickletLCD20x4ClearDisplay");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_LCD_20X4_BACKLIGHT = new ChannelTypeUID(BINDING_ID,
            "BrickletLCD20x4Backlight");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_LED_STRIP_LED_VALUES = new ChannelTypeUID(BINDING_ID,
            "BrickletLEDStripLEDValues");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_LED_STRIP_V2_LED_VALUES = new ChannelTypeUID(BINDING_ID,
            "BrickletLEDStripV2LEDValues");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_LINE_REFLECTIVITY = new ChannelTypeUID(BINDING_ID,
            "BrickletLineReflectivity");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_LINEAR_POTI_POSITION = new ChannelTypeUID(BINDING_ID,
            "BrickletLinearPotiPosition");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_LINEAR_POTI_ANALOG_VALUE = new ChannelTypeUID(BINDING_ID,
            "BrickletLinearPotiAnalogValue");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_LINEAR_POTI_V2_POSITION = new ChannelTypeUID(BINDING_ID,
            "BrickletLinearPotiV2Position");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_LOAD_CELL_WEIGHT = new ChannelTypeUID(BINDING_ID,
            "BrickletLoadCellWeight");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_LOAD_CELL_TARE = new ChannelTypeUID(BINDING_ID,
            "BrickletLoadCellTare");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_LOAD_CELL_LED = new ChannelTypeUID(BINDING_ID,
            "BrickletLoadCellLED");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_LOAD_CELL_V2_WEIGHT = new ChannelTypeUID(BINDING_ID,
            "BrickletLoadCellV2Weight");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_LOAD_CELL_V2_TARE = new ChannelTypeUID(BINDING_ID,
            "BrickletLoadCellV2Tare");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_MOISTURE_MOISTURE = new ChannelTypeUID(BINDING_ID,
            "BrickletMoistureMoisture");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_MOTION_DETECTOR_V2_INDICATOR = new ChannelTypeUID(
            BINDING_ID, "BrickletMotionDetectorV2Indicator");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_MOTORIZED_LINEAR_POTI_POSITION = new ChannelTypeUID(
            BINDING_ID, "BrickletMotorizedLinearPotiPosition");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_MOTORIZED_LINEAR_POTI_MOTOR_POSITION = new ChannelTypeUID(
            BINDING_ID, "BrickletMotorizedLinearPotiMotorPosition");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_MULTI_TOUCH_ELECTRODE = new ChannelTypeUID(BINDING_ID,
            "BrickletMultiTouchElectrode");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_MULTI_TOUCH_RECALIBRATE = new ChannelTypeUID(BINDING_ID,
            "BrickletMultiTouchRecalibrate");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_MULTI_TOUCH_V2_ELECTRODE = new ChannelTypeUID(BINDING_ID,
            "BrickletMultiTouchV2Electrode");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_MULTI_TOUCH_V2_RECALIBRATE = new ChannelTypeUID(BINDING_ID,
            "BrickletMultiTouchV2Recalibrate");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_NFC_STATE = new ChannelTypeUID(BINDING_ID,
            "BrickletNFCState");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_NFC_RFID_STATE = new ChannelTypeUID(BINDING_ID,
            "BrickletNFCRFIDState");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_OLED_128X64_TEXT = new ChannelTypeUID(BINDING_ID,
            "BrickletOLED128x64Text");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_OLED_128X64_CLEAR_DISPLAY = new ChannelTypeUID(BINDING_ID,
            "BrickletOLED128x64ClearDisplay");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_OLED_128X64_V2_TEXT = new ChannelTypeUID(BINDING_ID,
            "BrickletOLED128x64V2Text");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_OLED_128X64_V2_CLEAR_DISPLAY = new ChannelTypeUID(
            BINDING_ID, "BrickletOLED128x64V2ClearDisplay");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_OLED_128X64_V2_DRAW_BUFFERED_FRAME = new ChannelTypeUID(
            BINDING_ID, "BrickletOLED128x64V2DrawBufferedFrame");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_OLED_64X48_TEXT = new ChannelTypeUID(BINDING_ID,
            "BrickletOLED64x48Text");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_OLED_64X48_CLEAR_DISPLAY = new ChannelTypeUID(BINDING_ID,
            "BrickletOLED64x48ClearDisplay");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_OUTDOOR_WEATHER_SENSOR_IDENTIFIERS = new ChannelTypeUID(
            BINDING_ID, "BrickletOutdoorWeatherSensorIdentifiers");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_OUTDOOR_WEATHER_STATION_IDENTIFIERS = new ChannelTypeUID(
            BINDING_ID, "BrickletOutdoorWeatherStationIdentifiers");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_PARTICULATE_MATTER_PM10_CONCENTRATION = new ChannelTypeUID(
            BINDING_ID, "BrickletParticulateMatterPM10Concentration");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_PARTICULATE_MATTER_PM25_CONCENTRATION = new ChannelTypeUID(
            BINDING_ID, "BrickletParticulateMatterPM25Concentration");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_PARTICULATE_MATTER_PM100_CONCENTRATION = new ChannelTypeUID(
            BINDING_ID, "BrickletParticulateMatterPM100Concentration");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_PARTICULATE_MATTER_PART_COUNT_3 = new ChannelTypeUID(
            BINDING_ID, "BrickletParticulateMatterPartCount3");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_PARTICULATE_MATTER_PART_COUNT_5 = new ChannelTypeUID(
            BINDING_ID, "BrickletParticulateMatterPartCount5");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_PARTICULATE_MATTER_PART_COUNT_10 = new ChannelTypeUID(
            BINDING_ID, "BrickletParticulateMatterPartCount10");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_PARTICULATE_MATTER_PART_COUNT_25 = new ChannelTypeUID(
            BINDING_ID, "BrickletParticulateMatterPartCount25");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_PARTICULATE_MATTER_PART_COUNT_50 = new ChannelTypeUID(
            BINDING_ID, "BrickletParticulateMatterPartCount50");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_PARTICULATE_MATTER_PART_COUNT_100 = new ChannelTypeUID(
            BINDING_ID, "BrickletParticulateMatterPartCount100");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_PARTICULATE_MATTER_SENSOR_ENABLED = new ChannelTypeUID(
            BINDING_ID, "BrickletParticulateMatterSensorEnabled");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_PIEZO_BUZZER_BEEP = new ChannelTypeUID(BINDING_ID,
            "BrickletPiezoBuzzerBeep");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_PIEZO_BUZZER_MORSE_CODE = new ChannelTypeUID(BINDING_ID,
            "BrickletPiezoBuzzerMorseCode");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_PIEZO_SPEAKER_V2_BEEP = new ChannelTypeUID(BINDING_ID,
            "BrickletPiezoSpeakerV2Beep");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_PIEZO_SPEAKER_V2_ALARM = new ChannelTypeUID(BINDING_ID,
            "BrickletPiezoSpeakerV2Alarm");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_PIEZO_SPEAKER_V2_VOLUME = new ChannelTypeUID(BINDING_ID,
            "BrickletPiezoSpeakerV2Volume");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_PIEZO_SPEAKER_V2_BEEP_FREQUENCY = new ChannelTypeUID(
            BINDING_ID, "BrickletPiezoSpeakerV2BeepFrequency");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_PTC_TEMPERATURE = new ChannelTypeUID(BINDING_ID,
            "BrickletPTCTemperature");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_PTC_RESISTANCE = new ChannelTypeUID(BINDING_ID,
            "BrickletPTCResistance");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_PTC_SENSOR_CONNECTED = new ChannelTypeUID(BINDING_ID,
            "BrickletPTCSensorConnected");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_PTC_V2_TEMPERATURE = new ChannelTypeUID(BINDING_ID,
            "BrickletPTCV2Temperature");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_PTC_V2_RESISTANCE = new ChannelTypeUID(BINDING_ID,
            "BrickletPTCV2Resistance");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_PTC_V2_SENSOR_CONNECTED = new ChannelTypeUID(BINDING_ID,
            "BrickletPTCV2SensorConnected");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_REAL_TIME_CLOCK_DATE_TIME = new ChannelTypeUID(BINDING_ID,
            "BrickletRealTimeClockDateTime");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_REAL_TIME_CLOCK_TIMESTAMP = new ChannelTypeUID(BINDING_ID,
            "BrickletRealTimeClockTimestamp");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_REAL_TIME_CLOCK_V2_DATE_TIME = new ChannelTypeUID(
            BINDING_ID, "BrickletRealTimeClockV2DateTime");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_REAL_TIME_CLOCK_V2_TIMESTAMP = new ChannelTypeUID(
            BINDING_ID, "BrickletRealTimeClockV2Timestamp");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_RGB_LED_BUTTON_COLOR = new ChannelTypeUID(BINDING_ID,
            "BrickletRGBLEDButtonColor");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_RGB_LED_COLOR = new ChannelTypeUID(BINDING_ID,
            "BrickletRGBLEDColor");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_RGB_LED_MATRIX_LED_VALUES = new ChannelTypeUID(BINDING_ID,
            "BrickletRGBLEDMatrixLEDValues");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_RGB_LED_V2_COLOR = new ChannelTypeUID(BINDING_ID,
            "BrickletRGBLEDV2Color");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_ROTARY_ENCODER_COUNT = new ChannelTypeUID(BINDING_ID,
            "BrickletRotaryEncoderCount");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_ROTARY_ENCODER_RESET_COUNTER = new ChannelTypeUID(
            BINDING_ID, "BrickletRotaryEncoderResetCounter");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_ROTARY_ENCODER_V2_COUNT = new ChannelTypeUID(BINDING_ID,
            "BrickletRotaryEncoderV2Count");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_ROTARY_ENCODER_V2_RESET_COUNTER = new ChannelTypeUID(
            BINDING_ID, "BrickletRotaryEncoderV2ResetCounter");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_ROTARY_POTI_POSITION = new ChannelTypeUID(BINDING_ID,
            "BrickletRotaryPotiPosition");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_ROTARY_POTI_ANALOG_VALUE = new ChannelTypeUID(BINDING_ID,
            "BrickletRotaryPotiAnalogValue");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_ROTARY_POTI_V2_POSITION = new ChannelTypeUID(BINDING_ID,
            "BrickletRotaryPotiV2Position");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_RS232_V2_OVERRUN_ERROR_COUNT = new ChannelTypeUID(
            BINDING_ID, "BrickletRS232V2OverrunErrorCount");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_RS232_V2_PARITY_ERROR_COUNT = new ChannelTypeUID(
            BINDING_ID, "BrickletRS232V2ParityErrorCount");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_RS232_V2_SEND_BUFFER_USED = new ChannelTypeUID(BINDING_ID,
            "BrickletRS232V2SendBufferUsed");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_RS232_V2_RECEIVE_BUFFER_USED = new ChannelTypeUID(
            BINDING_ID, "BrickletRS232V2ReceiveBufferUsed");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_RS485_OVERRUN_ERROR_COUNT = new ChannelTypeUID(BINDING_ID,
            "BrickletRS485OverrunErrorCount");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_RS485_PARITY_ERROR_COUNT = new ChannelTypeUID(BINDING_ID,
            "BrickletRS485ParityErrorCount");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_RS485_MODBUS_ERROR = new ChannelTypeUID(BINDING_ID,
            "BrickletRS485ModbusError");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_RS485_SEND_BUFFER_USED = new ChannelTypeUID(BINDING_ID,
            "BrickletRS485SendBufferUsed");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_RS485_RECEIVE_BUFFER_USED = new ChannelTypeUID(BINDING_ID,
            "BrickletRS485ReceiveBufferUsed");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_SEGMENT_DISPLAY_4X7_BRIGHTNESS = new ChannelTypeUID(
            BINDING_ID, "BrickletSegmentDisplay4x7Brightness");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_SEGMENT_DISPLAY_4X7_SEGMENTS = new ChannelTypeUID(
            BINDING_ID, "BrickletSegmentDisplay4x7Segments");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_SEGMENT_DISPLAY_4X7_COLON = new ChannelTypeUID(BINDING_ID,
            "BrickletSegmentDisplay4x7Colon");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_SEGMENT_DISPLAY_4X7_TEXT = new ChannelTypeUID(BINDING_ID,
            "BrickletSegmentDisplay4x7Text");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_SEGMENT_DISPLAY_4X7_V2_BRIGHTNESS = new ChannelTypeUID(
            BINDING_ID, "BrickletSegmentDisplay4x7V2Brightness");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_SEGMENT_DISPLAY_4X7_V2_SEGMENTS = new ChannelTypeUID(
            BINDING_ID, "BrickletSegmentDisplay4x7V2Segments");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_SEGMENT_DISPLAY_4X7_V2_COLON_UPPER = new ChannelTypeUID(
            BINDING_ID, "BrickletSegmentDisplay4x7V2ColonUpper");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_SEGMENT_DISPLAY_4X7_V2_COLON_LOWER = new ChannelTypeUID(
            BINDING_ID, "BrickletSegmentDisplay4x7V2ColonLower");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_SEGMENT_DISPLAY_4X7_V2_TICK = new ChannelTypeUID(
            BINDING_ID, "BrickletSegmentDisplay4x7V2Tick");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_SEGMENT_DISPLAY_4X7_V2_TEXT = new ChannelTypeUID(
            BINDING_ID, "BrickletSegmentDisplay4x7V2Text");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_SOLID_STATE_RELAY_RELAY = new ChannelTypeUID(BINDING_ID,
            "BrickletSolidStateRelayRelay");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_SOLID_STATE_RELAY_MONOFLOP = new ChannelTypeUID(BINDING_ID,
            "BrickletSolidStateRelayMonoflop");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_SOLID_STATE_RELAY_V2_RELAY = new ChannelTypeUID(BINDING_ID,
            "BrickletSolidStateRelayV2Relay");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_SOLID_STATE_RELAY_V2_MONOFLOP = new ChannelTypeUID(
            BINDING_ID, "BrickletSolidStateRelayV2Monoflop");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_SOUND_INTENSITY_INTENSITY = new ChannelTypeUID(BINDING_ID,
            "BrickletSoundIntensityIntensity");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_SOUND_PRESSURE_LEVEL_DECIBEL = new ChannelTypeUID(
            BINDING_ID, "BrickletSoundPressureLevelDecibel");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_TEMPERATURE_TEMPERATURE = new ChannelTypeUID(BINDING_ID,
            "BrickletTemperatureTemperature");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_TEMPERATURE_IR_AMBIENT_TEMPERATURE = new ChannelTypeUID(
            BINDING_ID, "BrickletTemperatureIRAmbientTemperature");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_TEMPERATURE_IR_OBJECT_TEMPERATURE = new ChannelTypeUID(
            BINDING_ID, "BrickletTemperatureIRObjectTemperature");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_TEMPERATURE_IR_V2_AMBIENT_TEMPERATURE = new ChannelTypeUID(
            BINDING_ID, "BrickletTemperatureIRV2AmbientTemperature");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_TEMPERATURE_IR_V2_OBJECT_TEMPERATURE = new ChannelTypeUID(
            BINDING_ID, "BrickletTemperatureIRV2ObjectTemperature");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_TEMPERATURE_V2_TEMPERATURE = new ChannelTypeUID(BINDING_ID,
            "BrickletTemperatureV2Temperature");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_TEMPERATURE_V2_HEATER = new ChannelTypeUID(BINDING_ID,
            "BrickletTemperatureV2Heater");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_THERMAL_IMAGING_HIGH_CONTRAST_IMAGE = new ChannelTypeUID(
            BINDING_ID, "BrickletThermalImagingHighContrastImage");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_THERMAL_IMAGING_TEMPERATURE_IMAGE = new ChannelTypeUID(
            BINDING_ID, "BrickletThermalImagingTemperatureImage");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_THERMAL_IMAGING_TEMPERATURE = new ChannelTypeUID(
            BINDING_ID, "BrickletThermalImagingTemperature");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_THERMAL_IMAGING_SPOTMETER_ROI_PIXEL_COUNT = new ChannelTypeUID(
            BINDING_ID, "BrickletThermalImagingSpotmeterROIPixelCount");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_THERMAL_IMAGING_FFC_STATUS = new ChannelTypeUID(BINDING_ID,
            "BrickletThermalImagingFFCStatus");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_THERMAL_IMAGING_SHUTTER_LOCKOUT = new ChannelTypeUID(
            BINDING_ID, "BrickletThermalImagingShutterLockout");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_THERMAL_IMAGING_OVERTEMPERATURE_SHUTDOWN_IMMINENT = new ChannelTypeUID(
            BINDING_ID, "BrickletThermalImagingOvertemperatureShutdownImminent");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_THERMOCOUPLE_TEMPERATURE = new ChannelTypeUID(BINDING_ID,
            "BrickletThermocoupleTemperature");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_THERMOCOUPLE_OVER_UNDER_VOLTAGE = new ChannelTypeUID(
            BINDING_ID, "BrickletThermocoupleOverUnderVoltage");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_THERMOCOUPLE_OPEN_CIRCUIT = new ChannelTypeUID(BINDING_ID,
            "BrickletThermocoupleOpenCircuit");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_THERMOCOUPLE_V2_TEMPERATURE = new ChannelTypeUID(
            BINDING_ID, "BrickletThermocoupleV2Temperature");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_THERMOCOUPLE_V2_OVER_UNDER_VOLTAGE = new ChannelTypeUID(
            BINDING_ID, "BrickletThermocoupleV2OverUnderVoltage");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_THERMOCOUPLE_V2_OPEN_CIRCUIT = new ChannelTypeUID(
            BINDING_ID, "BrickletThermocoupleV2OpenCircuit");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_TILT_TILTED = new ChannelTypeUID(BINDING_ID,
            "BrickletTiltTilted");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_TILT_VIBRATING = new ChannelTypeUID(BINDING_ID,
            "BrickletTiltVibrating");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_UV_LIGHT_UV_LIGHT = new ChannelTypeUID(BINDING_ID,
            "BrickletUVLightUVLight");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_UV_LIGHT_V2_UVA = new ChannelTypeUID(BINDING_ID,
            "BrickletUVLightV2UVA");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_UV_LIGHT_V2_UVB = new ChannelTypeUID(BINDING_ID,
            "BrickletUVLightV2UVB");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_UV_LIGHT_V2_UVI = new ChannelTypeUID(BINDING_ID,
            "BrickletUVLightV2UVI");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_VOLTAGE_VOLTAGE = new ChannelTypeUID(BINDING_ID,
            "BrickletVoltageVoltage");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_VOLTAGE_ANALOG_VALUE = new ChannelTypeUID(BINDING_ID,
            "BrickletVoltageAnalogValue");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_VOLTAGE_CURRENT_VOLTAGE = new ChannelTypeUID(BINDING_ID,
            "BrickletVoltageCurrentVoltage");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_VOLTAGE_CURRENT_CURRENT = new ChannelTypeUID(BINDING_ID,
            "BrickletVoltageCurrentCurrent");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_VOLTAGE_CURRENT_POWER = new ChannelTypeUID(BINDING_ID,
            "BrickletVoltageCurrentPower");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_VOLTAGE_CURRENT_V2_VOLTAGE = new ChannelTypeUID(BINDING_ID,
            "BrickletVoltageCurrentV2Voltage");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_VOLTAGE_CURRENT_V2_CURRENT = new ChannelTypeUID(BINDING_ID,
            "BrickletVoltageCurrentV2Current");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_VOLTAGE_CURRENT_V2_POWER = new ChannelTypeUID(BINDING_ID,
            "BrickletVoltageCurrentV2Power");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_XMC1400_BREAKOUT_COUNT = new ChannelTypeUID(BINDING_ID,
            "BrickletXMC1400BreakoutCount");
    public static final ChannelTypeUID CHANNEL_TYPE_BRICKLET_XMC1400_BREAKOUT_ADC_VALUE = new ChannelTypeUID(BINDING_ID,
            "BrickletXMC1400BreakoutADCValue");
    public static final ChannelTypeUID CHANNEL_TYPE_OUTDOOR_WEATHER_SENSOR_TEMPERATURE = new ChannelTypeUID(BINDING_ID,
            "OutdoorWeatherSensorTemperature");
    public static final ChannelTypeUID CHANNEL_TYPE_OUTDOOR_WEATHER_SENSOR_HUMIDITY = new ChannelTypeUID(BINDING_ID,
            "OutdoorWeatherSensorHumidity");
    public static final ChannelTypeUID CHANNEL_TYPE_OUTDOOR_WEATHER_SENSOR_LAST_CHANGE = new ChannelTypeUID(BINDING_ID,
            "OutdoorWeatherSensorLastChange");
    public static final ChannelTypeUID CHANNEL_TYPE_OUTDOOR_WEATHER_STATION_TEMPERATURE = new ChannelTypeUID(BINDING_ID,
            "OutdoorWeatherStationTemperature");
    public static final ChannelTypeUID CHANNEL_TYPE_OUTDOOR_WEATHER_STATION_HUMIDITY = new ChannelTypeUID(BINDING_ID,
            "OutdoorWeatherStationHumidity");
    public static final ChannelTypeUID CHANNEL_TYPE_OUTDOOR_WEATHER_STATION_WIND_SPEED = new ChannelTypeUID(BINDING_ID,
            "OutdoorWeatherStationWindSpeed");
    public static final ChannelTypeUID CHANNEL_TYPE_OUTDOOR_WEATHER_STATION_GUST_SPEED = new ChannelTypeUID(BINDING_ID,
            "OutdoorWeatherStationGustSpeed");
    public static final ChannelTypeUID CHANNEL_TYPE_OUTDOOR_WEATHER_STATION_RAIN_FALL = new ChannelTypeUID(BINDING_ID,
            "OutdoorWeatherStationRainFall");
    public static final ChannelTypeUID CHANNEL_TYPE_OUTDOOR_WEATHER_STATION_WIND_DIRECTION = new ChannelTypeUID(
            BINDING_ID, "OutdoorWeatherStationWindDirection");
    public static final ChannelTypeUID CHANNEL_TYPE_OUTDOOR_WEATHER_STATION_BATTERY_LOW = new ChannelTypeUID(BINDING_ID,
            "OutdoorWeatherStationBatteryLow");
    public static final ChannelTypeUID CHANNEL_TYPE_OUTDOOR_WEATHER_STATION_LAST_CHANGE = new ChannelTypeUID(BINDING_ID,
            "OutdoorWeatherStationLastChange");
    public static final ChannelTypeUID CHANNEL_TYPE_REMOTE_SOCKET_TYPE_A_COMMAND = new ChannelTypeUID(BINDING_ID,
            "RemoteSocketTypeACommand");
    public static final ChannelTypeUID CHANNEL_TYPE_REMOTE_SOCKET_TYPE_B_COMMAND = new ChannelTypeUID(BINDING_ID,
            "RemoteSocketTypeBCommand");
    public static final ChannelTypeUID CHANNEL_TYPE_REMOTE_SOCKET_TYPE_C_COMMAND = new ChannelTypeUID(BINDING_ID,
            "RemoteSocketTypeCCommand");
    public static final ChannelTypeUID CHANNEL_TYPE_REMOTE_DIMMER_TYPE_B_VALUE = new ChannelTypeUID(BINDING_ID,
            "RemoteDimmerTypeBValue");

    public static final Map<ChannelTypeUID, ThingTypeUID> SUPPORTED_CHANNELS;

    static {
        SUPPORTED_CHANNELS = new HashMap<>();
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICK_DC_CURRENT_VELOCITY, THING_TYPE_BRICK_DC);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICK_HAT_USB_VOLTAGE, THING_TYPE_BRICK_HAT);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICK_HAT_DC_VOLTAGE, THING_TYPE_BRICK_HAT);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICK_HAT_POWER_BRICKLETS, THING_TYPE_BRICK_HAT);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICK_HAT_SLEEP, THING_TYPE_BRICK_HAT);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICK_HAT_ZERO_USB_VOLTAGE, THING_TYPE_BRICK_HAT_ZERO);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICK_IMU_ORIENTATION, THING_TYPE_BRICK_IMU);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICK_IMU_QUATERNION, THING_TYPE_BRICK_IMU);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICK_IMU_ACCELERATION, THING_TYPE_BRICK_IMU);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICK_IMU_MAGNETIC_FIELD, THING_TYPE_BRICK_IMU);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICK_IMU_ANGULAR_VELOCITY, THING_TYPE_BRICK_IMU);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICK_IMU_ENABLE_LEDS, THING_TYPE_BRICK_IMU);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICK_IMU_V2_ACCELERATION, THING_TYPE_BRICK_IMU_V2);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICK_IMU_V2_MAGNETIC_FIELD, THING_TYPE_BRICK_IMU_V2);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICK_IMU_V2_ANGULAR_VELOCITY, THING_TYPE_BRICK_IMU_V2);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICK_IMU_V2_ORIENTATION, THING_TYPE_BRICK_IMU_V2);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICK_IMU_V2_QUATERNION, THING_TYPE_BRICK_IMU_V2);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICK_IMU_V2_LINEAR_ACCELERATION, THING_TYPE_BRICK_IMU_V2);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICK_IMU_V2_GRAVITY_VECTOR, THING_TYPE_BRICK_IMU_V2);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICK_IMU_V2_TEMPERATURE, THING_TYPE_BRICK_IMU_V2);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICK_IMU_V2_ENABLE_LEDS, THING_TYPE_BRICK_IMU_V2);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICK_MASTER_STACK_VOLTAGE, THING_TYPE_BRICK_MASTER);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICK_MASTER_USB_VOLTAGE, THING_TYPE_BRICK_MASTER);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICK_MASTER_STACK_CURRENT, THING_TYPE_BRICK_MASTER);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICK_MASTER_BRICKLETS_ENABLED, THING_TYPE_BRICK_MASTER);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICK_SILENT_STEPPER_CURRENT_VELOCITY, THING_TYPE_BRICK_SILENT_STEPPER);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICK_SILENT_STEPPER_CURRENT_POSITION, THING_TYPE_BRICK_SILENT_STEPPER);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICK_SILENT_STEPPER_REMAINING_STEPS, THING_TYPE_BRICK_SILENT_STEPPER);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICK_SILENT_STEPPER_STACK_VOLTAGE, THING_TYPE_BRICK_SILENT_STEPPER);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICK_SILENT_STEPPER_EXTERNAL_VOLTAGE, THING_TYPE_BRICK_SILENT_STEPPER);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICK_SILENT_STEPPER_CURRENT_CONSUMPTION, THING_TYPE_BRICK_SILENT_STEPPER);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICK_SILENT_STEPPER_STATE, THING_TYPE_BRICK_SILENT_STEPPER);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICK_STEPPER_CURRENT_VELOCITY, THING_TYPE_BRICK_STEPPER);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICK_STEPPER_CURRENT_POSITION, THING_TYPE_BRICK_STEPPER);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICK_STEPPER_REMAINING_STEPS, THING_TYPE_BRICK_STEPPER);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICK_STEPPER_STACK_VOLTAGE, THING_TYPE_BRICK_STEPPER);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICK_STEPPER_EXTERNAL_VOLTAGE, THING_TYPE_BRICK_STEPPER);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICK_STEPPER_CURRENT_CONSUMPTION, THING_TYPE_BRICK_STEPPER);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICK_STEPPER_STATE, THING_TYPE_BRICK_STEPPER);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_ACCELEROMETER_ACCELERATION, THING_TYPE_BRICKLET_ACCELEROMETER);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_ACCELEROMETER_LED, THING_TYPE_BRICKLET_ACCELEROMETER);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_ACCELEROMETER_TEMPERATURE, THING_TYPE_BRICKLET_ACCELEROMETER);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_ACCELEROMETER_V2_ACCELERATION,
                THING_TYPE_BRICKLET_ACCELEROMETER_V2);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_AIR_QUALITY_HUMIDITY, THING_TYPE_BRICKLET_AIR_QUALITY);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_AIR_QUALITY_TEMPERATURE, THING_TYPE_BRICKLET_AIR_QUALITY);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_AIR_QUALITY_AIR_PRESSURE, THING_TYPE_BRICKLET_AIR_QUALITY);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_AIR_QUALITY_IAQ_INDEX, THING_TYPE_BRICKLET_AIR_QUALITY);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_AIR_QUALITY_IAQ_INDEX_ACCURACY, THING_TYPE_BRICKLET_AIR_QUALITY);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_AMBIENT_LIGHT_ILLUMINANCE, THING_TYPE_BRICKLET_AMBIENT_LIGHT);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_AMBIENT_LIGHT_ANALOG_VALUE, THING_TYPE_BRICKLET_AMBIENT_LIGHT);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_AMBIENT_LIGHT_V2_ILLUMINANCE,
                THING_TYPE_BRICKLET_AMBIENT_LIGHT_V2);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_AMBIENT_LIGHT_V3_ILLUMINANCE,
                THING_TYPE_BRICKLET_AMBIENT_LIGHT_V3);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_ANALOG_IN_VOLTAGE, THING_TYPE_BRICKLET_ANALOG_IN);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_ANALOG_IN_ANALOG_VALUE, THING_TYPE_BRICKLET_ANALOG_IN);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_ANALOG_IN_V2_VOLTAGE, THING_TYPE_BRICKLET_ANALOG_IN_V2);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_ANALOG_IN_V2_ANALOG_VALUE, THING_TYPE_BRICKLET_ANALOG_IN_V2);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_ANALOG_IN_V3_VOLTAGE, THING_TYPE_BRICKLET_ANALOG_IN_V3);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_ANALOG_OUT_VOLTAGE, THING_TYPE_BRICKLET_ANALOG_OUT);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_ANALOG_OUT_MODE, THING_TYPE_BRICKLET_ANALOG_OUT);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_ANALOG_OUT_V2_INPUT_VOLTAGE, THING_TYPE_BRICKLET_ANALOG_OUT_V2);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_ANALOG_OUT_V2_OUTPUT_VOLTAGE, THING_TYPE_BRICKLET_ANALOG_OUT_V2);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_ANALOG_OUT_V3_INPUT_VOLTAGE, THING_TYPE_BRICKLET_ANALOG_OUT_V3);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_ANALOG_OUT_V3_OUTPUT_VOLTAGE, THING_TYPE_BRICKLET_ANALOG_OUT_V3);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_BAROMETER_AIR_PRESSURE, THING_TYPE_BRICKLET_BAROMETER);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_BAROMETER_ALTITUDE, THING_TYPE_BRICKLET_BAROMETER);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_BAROMETER_V2_AIR_PRESSURE, THING_TYPE_BRICKLET_BAROMETER_V2);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_BAROMETER_V2_ALTITUDE, THING_TYPE_BRICKLET_BAROMETER_V2);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_BAROMETER_V2_TEMPERATURE, THING_TYPE_BRICKLET_BAROMETER_V2);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_CAN_WRITE_ERROR_LEVEL, THING_TYPE_BRICKLET_CAN);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_CAN_READ_ERROR_LEVEL, THING_TYPE_BRICKLET_CAN);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_CAN_TRANSCEIVER_DISABLED, THING_TYPE_BRICKLET_CAN);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_CAN_WRITE_TIMEOUT_COUNT, THING_TYPE_BRICKLET_CAN);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_CAN_READ_REGISTER_OVERFLOW_COUNT, THING_TYPE_BRICKLET_CAN);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_CAN_READ_BUFFER_OVERFLOW_COUNT, THING_TYPE_BRICKLET_CAN);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_CO2_CO2_CONCENTRATION, THING_TYPE_BRICKLET_CO2);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_CO2_V2_CO2_CONCENTRATION, THING_TYPE_BRICKLET_CO2_V2);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_CO2_V2_TEMPERATURE, THING_TYPE_BRICKLET_CO2_V2);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_CO2_V2_HUMIDITY, THING_TYPE_BRICKLET_CO2_V2);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_CO2_V2_AIR_PRESSURE, THING_TYPE_BRICKLET_CO2_V2);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_COLOR_COLOR, THING_TYPE_BRICKLET_COLOR);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_COLOR_ILLUMINANCE, THING_TYPE_BRICKLET_COLOR);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_COLOR_COLOR_TEMPERATURE, THING_TYPE_BRICKLET_COLOR);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_COLOR_LIGHT, THING_TYPE_BRICKLET_COLOR);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_COLOR_V2_COLOR, THING_TYPE_BRICKLET_COLOR_V2);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_COLOR_V2_ILLUMINANCE, THING_TYPE_BRICKLET_COLOR_V2);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_COLOR_V2_COLOR_TEMPERATURE, THING_TYPE_BRICKLET_COLOR_V2);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_COLOR_V2_LIGHT, THING_TYPE_BRICKLET_COLOR_V2);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_COMPASS_HEADING, THING_TYPE_BRICKLET_COMPASS);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_COMPASS_MAGNETIC_FLUX_DENSITY, THING_TYPE_BRICKLET_COMPASS);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_CURRENT12_CURRENT, THING_TYPE_BRICKLET_CURRENT12);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_CURRENT12_OVER_CURRENT, THING_TYPE_BRICKLET_CURRENT12);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_CURRENT12_ANALOG_VALUE, THING_TYPE_BRICKLET_CURRENT12);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_CURRENT25_CURRENT, THING_TYPE_BRICKLET_CURRENT25);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_CURRENT25_OVER_CURRENT, THING_TYPE_BRICKLET_CURRENT25);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_CURRENT25_ANALOG_VALUE, THING_TYPE_BRICKLET_CURRENT25);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_DISTANCE_IR_DISTANCE, THING_TYPE_BRICKLET_DISTANCE_IR);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_DISTANCE_IR_ANALOG_VALUE, THING_TYPE_BRICKLET_DISTANCE_IR);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_DISTANCE_IR_V2_DISTANCE, THING_TYPE_BRICKLET_DISTANCE_IR_V2);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_DISTANCE_IR_V2_ANALOG_VALUE, THING_TYPE_BRICKLET_DISTANCE_IR_V2);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_DISTANCE_US_DISTANCE, THING_TYPE_BRICKLET_DISTANCE_US);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_DISTANCE_US_V2_DISTANCE, THING_TYPE_BRICKLET_DISTANCE_US_V2);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_DMX_OVERRUN_ERROR_COUNT, THING_TYPE_BRICKLET_DMX);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_DMX_FRAMING_ERROR_COUNT, THING_TYPE_BRICKLET_DMX);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_DUAL_BUTTON_LEFT_LED, THING_TYPE_BRICKLET_DUAL_BUTTON);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_DUAL_BUTTON_RIGHT_LED, THING_TYPE_BRICKLET_DUAL_BUTTON);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_DUAL_BUTTON_V2_LEFT_LED, THING_TYPE_BRICKLET_DUAL_BUTTON_V2);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_DUAL_BUTTON_V2_RIGHT_LED, THING_TYPE_BRICKLET_DUAL_BUTTON_V2);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_DUAL_RELAY_RELAY, THING_TYPE_BRICKLET_DUAL_RELAY);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_DUAL_RELAY_MONOFLOP, THING_TYPE_BRICKLET_DUAL_RELAY);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_DUST_DETECTOR_DUST_DENSITY, THING_TYPE_BRICKLET_DUST_DETECTOR);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_E_PAPER_296X128_DRAW_STATUS, THING_TYPE_BRICKLET_E_PAPER_296X128);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_ENERGY_MONITOR_VOLTAGE, THING_TYPE_BRICKLET_ENERGY_MONITOR);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_ENERGY_MONITOR_CURRENT, THING_TYPE_BRICKLET_ENERGY_MONITOR);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_ENERGY_MONITOR_ENERGY, THING_TYPE_BRICKLET_ENERGY_MONITOR);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_ENERGY_MONITOR_REALPOWER, THING_TYPE_BRICKLET_ENERGY_MONITOR);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_ENERGY_MONITOR_APPPOWER, THING_TYPE_BRICKLET_ENERGY_MONITOR);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_ENERGY_MONITOR_REACPOWER, THING_TYPE_BRICKLET_ENERGY_MONITOR);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_ENERGY_MONITOR_FACTOR, THING_TYPE_BRICKLET_ENERGY_MONITOR);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_ENERGY_MONITOR_FREQUENCY, THING_TYPE_BRICKLET_ENERGY_MONITOR);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_ENERGY_MONITOR_RESET, THING_TYPE_BRICKLET_ENERGY_MONITOR);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_GPS_COORDINATES, THING_TYPE_BRICKLET_GPS);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_GPS_FIX, THING_TYPE_BRICKLET_GPS);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_GPS_SATELLITES_IN_VIEW, THING_TYPE_BRICKLET_GPS);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_GPS_SATELLITES_USED, THING_TYPE_BRICKLET_GPS);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_GPS_ALTITUDE, THING_TYPE_BRICKLET_GPS);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_GPS_GEOIDAL_SEPARATION, THING_TYPE_BRICKLET_GPS);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_GPS_COURSE, THING_TYPE_BRICKLET_GPS);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_GPS_SPEED, THING_TYPE_BRICKLET_GPS);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_GPS_DATE_TIME, THING_TYPE_BRICKLET_GPS);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_GPS_RESTART, THING_TYPE_BRICKLET_GPS);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_GPS_V2_COORDINATES, THING_TYPE_BRICKLET_GPS_V2);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_GPS_V2_FIX, THING_TYPE_BRICKLET_GPS_V2);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_GPS_V2_SATELLITES_IN_VIEW, THING_TYPE_BRICKLET_GPS_V2);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_GPS_V2_ALTITUDE, THING_TYPE_BRICKLET_GPS_V2);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_GPS_V2_GEOIDAL_SEPARATION, THING_TYPE_BRICKLET_GPS_V2);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_GPS_V2_COURSE, THING_TYPE_BRICKLET_GPS_V2);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_GPS_V2_SPEED, THING_TYPE_BRICKLET_GPS_V2);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_GPS_V2_DATE_TIME, THING_TYPE_BRICKLET_GPS_V2);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_GPS_V2_RESTART, THING_TYPE_BRICKLET_GPS_V2);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_HALL_EFFECT_EDGE_COUNT, THING_TYPE_BRICKLET_HALL_EFFECT);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_HALL_EFFECT_MAGNETIC_FIELD_DETECTED,
                THING_TYPE_BRICKLET_HALL_EFFECT);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_HALL_EFFECT_V2_COUNTER, THING_TYPE_BRICKLET_HALL_EFFECT_V2);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_HALL_EFFECT_V2_MAGNETIC_FLUX_DENSITY,
                THING_TYPE_BRICKLET_HALL_EFFECT_V2);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_HUMIDITY_HUMIDITY, THING_TYPE_BRICKLET_HUMIDITY);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_HUMIDITY_ANALOG_VALUE, THING_TYPE_BRICKLET_HUMIDITY);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_HUMIDITY_V2_HUMIDITY, THING_TYPE_BRICKLET_HUMIDITY_V2);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_HUMIDITY_V2_TEMPERATURE, THING_TYPE_BRICKLET_HUMIDITY_V2);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_HUMIDITY_V2_HEATER, THING_TYPE_BRICKLET_HUMIDITY_V2);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_INDUSTRIAL_ANALOG_OUT_ENABLED,
                THING_TYPE_BRICKLET_INDUSTRIAL_ANALOG_OUT);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_INDUSTRIAL_ANALOG_OUT_VOLTAGE,
                THING_TYPE_BRICKLET_INDUSTRIAL_ANALOG_OUT);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_INDUSTRIAL_ANALOG_OUT_CURRENT,
                THING_TYPE_BRICKLET_INDUSTRIAL_ANALOG_OUT);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_INDUSTRIAL_ANALOG_OUT_V2_ENABLED,
                THING_TYPE_BRICKLET_INDUSTRIAL_ANALOG_OUT_V2);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_INDUSTRIAL_ANALOG_OUT_V2_VOLTAGE,
                THING_TYPE_BRICKLET_INDUSTRIAL_ANALOG_OUT_V2);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_INDUSTRIAL_ANALOG_OUT_V2_CURRENT,
                THING_TYPE_BRICKLET_INDUSTRIAL_ANALOG_OUT_V2);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_INDUSTRIAL_COUNTER_DUTY_CYCLE,
                THING_TYPE_BRICKLET_INDUSTRIAL_COUNTER);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_INDUSTRIAL_COUNTER_PERIOD, THING_TYPE_BRICKLET_INDUSTRIAL_COUNTER);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_INDUSTRIAL_COUNTER_FREQUENCY,
                THING_TYPE_BRICKLET_INDUSTRIAL_COUNTER);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_INDUSTRIAL_COUNTER_VALUE, THING_TYPE_BRICKLET_INDUSTRIAL_COUNTER);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_INDUSTRIAL_COUNTER_COUNTER,
                THING_TYPE_BRICKLET_INDUSTRIAL_COUNTER);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_INDUSTRIAL_DIGITAL_IN_4_INPUT_PIN,
                THING_TYPE_BRICKLET_INDUSTRIAL_DIGITAL_IN_4);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_INDUSTRIAL_DIGITAL_IN_4_EDGE_COUNT,
                THING_TYPE_BRICKLET_INDUSTRIAL_DIGITAL_IN_4);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_INDUSTRIAL_DIGITAL_IN_4_V2_VALUE,
                THING_TYPE_BRICKLET_INDUSTRIAL_DIGITAL_IN_4_V2);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_INDUSTRIAL_DIGITAL_IN_4_V2_EDGE_COUNT,
                THING_TYPE_BRICKLET_INDUSTRIAL_DIGITAL_IN_4_V2);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_INDUSTRIAL_DIGITAL_OUT_4_OUTPUT_PIN,
                THING_TYPE_BRICKLET_INDUSTRIAL_DIGITAL_OUT_4);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_INDUSTRIAL_DIGITAL_OUT_4_MONOFLOP,
                THING_TYPE_BRICKLET_INDUSTRIAL_DIGITAL_OUT_4);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_INDUSTRIAL_DIGITAL_OUT_4_V2_OUTPUT_PIN,
                THING_TYPE_BRICKLET_INDUSTRIAL_DIGITAL_OUT_4_V2);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_INDUSTRIAL_DIGITAL_OUT_4_V2_MONOFLOP,
                THING_TYPE_BRICKLET_INDUSTRIAL_DIGITAL_OUT_4_V2);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_INDUSTRIAL_DUAL_0_20MA_CURRENT,
                THING_TYPE_BRICKLET_INDUSTRIAL_DUAL_0_20MA);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_INDUSTRIAL_DUAL_0_20MA_V2_CURRENT,
                THING_TYPE_BRICKLET_INDUSTRIAL_DUAL_0_20MA_V2);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_INDUSTRIAL_DUAL_ANALOG_IN_VOLTAGE,
                THING_TYPE_BRICKLET_INDUSTRIAL_DUAL_ANALOG_IN);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_INDUSTRIAL_DUAL_ANALOG_IN_V2_VOLTAGE,
                THING_TYPE_BRICKLET_INDUSTRIAL_DUAL_ANALOG_IN_V2);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_INDUSTRIAL_DUAL_RELAY_RELAY,
                THING_TYPE_BRICKLET_INDUSTRIAL_DUAL_RELAY);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_INDUSTRIAL_DUAL_RELAY_MONOFLOP,
                THING_TYPE_BRICKLET_INDUSTRIAL_DUAL_RELAY);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_INDUSTRIAL_QUAD_RELAY_RELAY,
                THING_TYPE_BRICKLET_INDUSTRIAL_QUAD_RELAY);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_INDUSTRIAL_QUAD_RELAY_MONOFLOP,
                THING_TYPE_BRICKLET_INDUSTRIAL_QUAD_RELAY);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_INDUSTRIAL_QUAD_RELAY_V2_RELAY,
                THING_TYPE_BRICKLET_INDUSTRIAL_QUAD_RELAY_V2);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_INDUSTRIAL_QUAD_RELAY_V2_MONOFLOP,
                THING_TYPE_BRICKLET_INDUSTRIAL_QUAD_RELAY_V2);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_IO16_INPUT_PIN, THING_TYPE_BRICKLET_IO16);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_IO16_OUTPUT_PIN, THING_TYPE_BRICKLET_IO16);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_IO16_MONOFLOP, THING_TYPE_BRICKLET_IO16);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_IO16_EDGE_COUNT, THING_TYPE_BRICKLET_IO16);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_IO16_V2_INPUT_VALUE, THING_TYPE_BRICKLET_IO16_V2);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_IO16_V2_OUTPUT_PIN, THING_TYPE_BRICKLET_IO16_V2);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_IO16_V2_MONOFLOP, THING_TYPE_BRICKLET_IO16_V2);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_IO16_V2_EDGE_COUNT, THING_TYPE_BRICKLET_IO16_V2);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_IO4_INPUT_PIN, THING_TYPE_BRICKLET_IO4);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_IO4_OUTPUT_PIN, THING_TYPE_BRICKLET_IO4);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_IO4_MONOFLOP, THING_TYPE_BRICKLET_IO4);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_IO4_EDGE_COUNT, THING_TYPE_BRICKLET_IO4);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_IO4_V2_INPUT_VALUE, THING_TYPE_BRICKLET_IO4_V2);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_IO4_V2_OUTPUT_PIN, THING_TYPE_BRICKLET_IO4_V2);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_IO4_V2_MONOFLOP, THING_TYPE_BRICKLET_IO4_V2);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_IO4_V2_EDGE_COUNT, THING_TYPE_BRICKLET_IO4_V2);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_ISOLATOR_MESSAGES_FROM_BRICK, THING_TYPE_BRICKLET_ISOLATOR);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_ISOLATOR_MESSAGES_FROM_BRICKLET, THING_TYPE_BRICKLET_ISOLATOR);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_ISOLATOR_CONNECTED_BRICKLET_DEVICE_NAME,
                THING_TYPE_BRICKLET_ISOLATOR);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_ISOLATOR_CONNECTED_BRICKLET_UID, THING_TYPE_BRICKLET_ISOLATOR);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_JOYSTICK_POSITION, THING_TYPE_BRICKLET_JOYSTICK);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_JOYSTICK_ANALOG_VALUE_X, THING_TYPE_BRICKLET_JOYSTICK);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_JOYSTICK_ANALOG_VALUE_Y, THING_TYPE_BRICKLET_JOYSTICK);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_JOYSTICK_V2_POSITION, THING_TYPE_BRICKLET_JOYSTICK_V2);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_LASER_RANGE_FINDER_DISTANCE,
                THING_TYPE_BRICKLET_LASER_RANGE_FINDER);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_LASER_RANGE_FINDER_VELOCITY,
                THING_TYPE_BRICKLET_LASER_RANGE_FINDER);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_LASER_RANGE_FINDER_ENABLE_LASER,
                THING_TYPE_BRICKLET_LASER_RANGE_FINDER);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_LASER_RANGE_FINDER_V2_DISTANCE,
                THING_TYPE_BRICKLET_LASER_RANGE_FINDER_V2);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_LASER_RANGE_FINDER_V2_VELOCITY,
                THING_TYPE_BRICKLET_LASER_RANGE_FINDER_V2);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_LASER_RANGE_FINDER_V2_ENABLE_LASER,
                THING_TYPE_BRICKLET_LASER_RANGE_FINDER_V2);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_LCD_128X64_TEXT, THING_TYPE_BRICKLET_LCD_128X64);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_LCD_128X64_CLEAR_DISPLAY, THING_TYPE_BRICKLET_LCD_128X64);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_LCD_128X64_DRAW_BUFFERED_FRAME, THING_TYPE_BRICKLET_LCD_128X64);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_LCD_128X64_BACKLIGHT, THING_TYPE_BRICKLET_LCD_128X64);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_LCD_128X64_GUI_TAB_SELECTED, THING_TYPE_BRICKLET_LCD_128X64);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_LCD_128X64_GUI_SLIDER, THING_TYPE_BRICKLET_LCD_128X64);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_LCD_16X2_TEXT, THING_TYPE_BRICKLET_LCD_16X2);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_LCD_16X2_CLEAR_DISPLAY, THING_TYPE_BRICKLET_LCD_16X2);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_LCD_16X2_BACKLIGHT, THING_TYPE_BRICKLET_LCD_16X2);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_LCD_20X4_TEXT, THING_TYPE_BRICKLET_LCD_20X4);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_LCD_20X4_CLEAR_DISPLAY, THING_TYPE_BRICKLET_LCD_20X4);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_LCD_20X4_BACKLIGHT, THING_TYPE_BRICKLET_LCD_20X4);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_LED_STRIP_LED_VALUES, THING_TYPE_BRICKLET_LED_STRIP);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_LED_STRIP_V2_LED_VALUES, THING_TYPE_BRICKLET_LED_STRIP_V2);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_LINE_REFLECTIVITY, THING_TYPE_BRICKLET_LINE);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_LINEAR_POTI_POSITION, THING_TYPE_BRICKLET_LINEAR_POTI);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_LINEAR_POTI_ANALOG_VALUE, THING_TYPE_BRICKLET_LINEAR_POTI);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_LINEAR_POTI_V2_POSITION, THING_TYPE_BRICKLET_LINEAR_POTI_V2);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_LOAD_CELL_WEIGHT, THING_TYPE_BRICKLET_LOAD_CELL);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_LOAD_CELL_TARE, THING_TYPE_BRICKLET_LOAD_CELL);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_LOAD_CELL_LED, THING_TYPE_BRICKLET_LOAD_CELL);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_LOAD_CELL_V2_WEIGHT, THING_TYPE_BRICKLET_LOAD_CELL_V2);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_LOAD_CELL_V2_TARE, THING_TYPE_BRICKLET_LOAD_CELL_V2);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_MOISTURE_MOISTURE, THING_TYPE_BRICKLET_MOISTURE);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_MOTION_DETECTOR_V2_INDICATOR,
                THING_TYPE_BRICKLET_MOTION_DETECTOR_V2);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_MOTORIZED_LINEAR_POTI_POSITION,
                THING_TYPE_BRICKLET_MOTORIZED_LINEAR_POTI);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_MOTORIZED_LINEAR_POTI_MOTOR_POSITION,
                THING_TYPE_BRICKLET_MOTORIZED_LINEAR_POTI);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_MULTI_TOUCH_ELECTRODE, THING_TYPE_BRICKLET_MULTI_TOUCH);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_MULTI_TOUCH_RECALIBRATE, THING_TYPE_BRICKLET_MULTI_TOUCH);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_MULTI_TOUCH_V2_ELECTRODE, THING_TYPE_BRICKLET_MULTI_TOUCH_V2);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_MULTI_TOUCH_V2_RECALIBRATE, THING_TYPE_BRICKLET_MULTI_TOUCH_V2);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_NFC_STATE, THING_TYPE_BRICKLET_NFC);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_NFC_RFID_STATE, THING_TYPE_BRICKLET_NFC_RFID);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_OLED_128X64_TEXT, THING_TYPE_BRICKLET_OLED_128X64);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_OLED_128X64_CLEAR_DISPLAY, THING_TYPE_BRICKLET_OLED_128X64);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_OLED_128X64_V2_TEXT, THING_TYPE_BRICKLET_OLED_128X64_V2);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_OLED_128X64_V2_CLEAR_DISPLAY, THING_TYPE_BRICKLET_OLED_128X64_V2);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_OLED_128X64_V2_DRAW_BUFFERED_FRAME,
                THING_TYPE_BRICKLET_OLED_128X64_V2);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_OLED_64X48_TEXT, THING_TYPE_BRICKLET_OLED_64X48);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_OLED_64X48_CLEAR_DISPLAY, THING_TYPE_BRICKLET_OLED_64X48);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_OUTDOOR_WEATHER_SENSOR_IDENTIFIERS,
                THING_TYPE_BRICKLET_OUTDOOR_WEATHER);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_OUTDOOR_WEATHER_STATION_IDENTIFIERS,
                THING_TYPE_BRICKLET_OUTDOOR_WEATHER);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_PARTICULATE_MATTER_PM10_CONCENTRATION,
                THING_TYPE_BRICKLET_PARTICULATE_MATTER);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_PARTICULATE_MATTER_PM25_CONCENTRATION,
                THING_TYPE_BRICKLET_PARTICULATE_MATTER);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_PARTICULATE_MATTER_PM100_CONCENTRATION,
                THING_TYPE_BRICKLET_PARTICULATE_MATTER);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_PARTICULATE_MATTER_PART_COUNT_3,
                THING_TYPE_BRICKLET_PARTICULATE_MATTER);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_PARTICULATE_MATTER_PART_COUNT_5,
                THING_TYPE_BRICKLET_PARTICULATE_MATTER);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_PARTICULATE_MATTER_PART_COUNT_10,
                THING_TYPE_BRICKLET_PARTICULATE_MATTER);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_PARTICULATE_MATTER_PART_COUNT_25,
                THING_TYPE_BRICKLET_PARTICULATE_MATTER);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_PARTICULATE_MATTER_PART_COUNT_50,
                THING_TYPE_BRICKLET_PARTICULATE_MATTER);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_PARTICULATE_MATTER_PART_COUNT_100,
                THING_TYPE_BRICKLET_PARTICULATE_MATTER);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_PARTICULATE_MATTER_SENSOR_ENABLED,
                THING_TYPE_BRICKLET_PARTICULATE_MATTER);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_PIEZO_BUZZER_BEEP, THING_TYPE_BRICKLET_PIEZO_BUZZER);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_PIEZO_BUZZER_MORSE_CODE, THING_TYPE_BRICKLET_PIEZO_BUZZER);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_PIEZO_SPEAKER_V2_BEEP, THING_TYPE_BRICKLET_PIEZO_SPEAKER_V2);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_PIEZO_SPEAKER_V2_ALARM, THING_TYPE_BRICKLET_PIEZO_SPEAKER_V2);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_PIEZO_SPEAKER_V2_VOLUME, THING_TYPE_BRICKLET_PIEZO_SPEAKER_V2);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_PIEZO_SPEAKER_V2_BEEP_FREQUENCY,
                THING_TYPE_BRICKLET_PIEZO_SPEAKER_V2);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_PTC_TEMPERATURE, THING_TYPE_BRICKLET_PTC);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_PTC_RESISTANCE, THING_TYPE_BRICKLET_PTC);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_PTC_SENSOR_CONNECTED, THING_TYPE_BRICKLET_PTC);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_PTC_V2_TEMPERATURE, THING_TYPE_BRICKLET_PTC_V2);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_PTC_V2_RESISTANCE, THING_TYPE_BRICKLET_PTC_V2);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_PTC_V2_SENSOR_CONNECTED, THING_TYPE_BRICKLET_PTC_V2);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_REAL_TIME_CLOCK_DATE_TIME, THING_TYPE_BRICKLET_REAL_TIME_CLOCK);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_REAL_TIME_CLOCK_TIMESTAMP, THING_TYPE_BRICKLET_REAL_TIME_CLOCK);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_REAL_TIME_CLOCK_V2_DATE_TIME,
                THING_TYPE_BRICKLET_REAL_TIME_CLOCK_V2);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_REAL_TIME_CLOCK_V2_TIMESTAMP,
                THING_TYPE_BRICKLET_REAL_TIME_CLOCK_V2);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_RGB_LED_BUTTON_COLOR, THING_TYPE_BRICKLET_RGB_LED_BUTTON);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_RGB_LED_COLOR, THING_TYPE_BRICKLET_RGB_LED);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_RGB_LED_MATRIX_LED_VALUES, THING_TYPE_BRICKLET_RGB_LED_MATRIX);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_RGB_LED_V2_COLOR, THING_TYPE_BRICKLET_RGB_LED_V2);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_ROTARY_ENCODER_COUNT, THING_TYPE_BRICKLET_ROTARY_ENCODER);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_ROTARY_ENCODER_RESET_COUNTER, THING_TYPE_BRICKLET_ROTARY_ENCODER);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_ROTARY_ENCODER_V2_COUNT, THING_TYPE_BRICKLET_ROTARY_ENCODER_V2);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_ROTARY_ENCODER_V2_RESET_COUNTER,
                THING_TYPE_BRICKLET_ROTARY_ENCODER_V2);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_ROTARY_POTI_POSITION, THING_TYPE_BRICKLET_ROTARY_POTI);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_ROTARY_POTI_ANALOG_VALUE, THING_TYPE_BRICKLET_ROTARY_POTI);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_ROTARY_POTI_V2_POSITION, THING_TYPE_BRICKLET_ROTARY_POTI_V2);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_RS232_V2_OVERRUN_ERROR_COUNT, THING_TYPE_BRICKLET_RS232_V2);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_RS232_V2_PARITY_ERROR_COUNT, THING_TYPE_BRICKLET_RS232_V2);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_RS232_V2_SEND_BUFFER_USED, THING_TYPE_BRICKLET_RS232_V2);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_RS232_V2_RECEIVE_BUFFER_USED, THING_TYPE_BRICKLET_RS232_V2);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_RS485_OVERRUN_ERROR_COUNT, THING_TYPE_BRICKLET_RS485);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_RS485_PARITY_ERROR_COUNT, THING_TYPE_BRICKLET_RS485);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_RS485_MODBUS_ERROR, THING_TYPE_BRICKLET_RS485);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_RS485_SEND_BUFFER_USED, THING_TYPE_BRICKLET_RS485);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_RS485_RECEIVE_BUFFER_USED, THING_TYPE_BRICKLET_RS485);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_SEGMENT_DISPLAY_4X7_BRIGHTNESS,
                THING_TYPE_BRICKLET_SEGMENT_DISPLAY_4X7);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_SEGMENT_DISPLAY_4X7_SEGMENTS,
                THING_TYPE_BRICKLET_SEGMENT_DISPLAY_4X7);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_SEGMENT_DISPLAY_4X7_COLON,
                THING_TYPE_BRICKLET_SEGMENT_DISPLAY_4X7);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_SEGMENT_DISPLAY_4X7_TEXT, THING_TYPE_BRICKLET_SEGMENT_DISPLAY_4X7);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_SEGMENT_DISPLAY_4X7_V2_BRIGHTNESS,
                THING_TYPE_BRICKLET_SEGMENT_DISPLAY_4X7_V2);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_SEGMENT_DISPLAY_4X7_V2_SEGMENTS,
                THING_TYPE_BRICKLET_SEGMENT_DISPLAY_4X7_V2);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_SEGMENT_DISPLAY_4X7_V2_COLON_UPPER,
                THING_TYPE_BRICKLET_SEGMENT_DISPLAY_4X7_V2);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_SEGMENT_DISPLAY_4X7_V2_COLON_LOWER,
                THING_TYPE_BRICKLET_SEGMENT_DISPLAY_4X7_V2);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_SEGMENT_DISPLAY_4X7_V2_TICK,
                THING_TYPE_BRICKLET_SEGMENT_DISPLAY_4X7_V2);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_SEGMENT_DISPLAY_4X7_V2_TEXT,
                THING_TYPE_BRICKLET_SEGMENT_DISPLAY_4X7_V2);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_SOLID_STATE_RELAY_RELAY, THING_TYPE_BRICKLET_SOLID_STATE_RELAY);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_SOLID_STATE_RELAY_MONOFLOP, THING_TYPE_BRICKLET_SOLID_STATE_RELAY);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_SOLID_STATE_RELAY_V2_RELAY,
                THING_TYPE_BRICKLET_SOLID_STATE_RELAY_V2);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_SOLID_STATE_RELAY_V2_MONOFLOP,
                THING_TYPE_BRICKLET_SOLID_STATE_RELAY_V2);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_SOUND_INTENSITY_INTENSITY, THING_TYPE_BRICKLET_SOUND_INTENSITY);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_SOUND_PRESSURE_LEVEL_DECIBEL,
                THING_TYPE_BRICKLET_SOUND_PRESSURE_LEVEL);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_TEMPERATURE_TEMPERATURE, THING_TYPE_BRICKLET_TEMPERATURE);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_TEMPERATURE_IR_AMBIENT_TEMPERATURE,
                THING_TYPE_BRICKLET_TEMPERATURE_IR);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_TEMPERATURE_IR_OBJECT_TEMPERATURE,
                THING_TYPE_BRICKLET_TEMPERATURE_IR);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_TEMPERATURE_IR_V2_AMBIENT_TEMPERATURE,
                THING_TYPE_BRICKLET_TEMPERATURE_IR_V2);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_TEMPERATURE_IR_V2_OBJECT_TEMPERATURE,
                THING_TYPE_BRICKLET_TEMPERATURE_IR_V2);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_TEMPERATURE_V2_TEMPERATURE, THING_TYPE_BRICKLET_TEMPERATURE_V2);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_TEMPERATURE_V2_HEATER, THING_TYPE_BRICKLET_TEMPERATURE_V2);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_THERMAL_IMAGING_HIGH_CONTRAST_IMAGE,
                THING_TYPE_BRICKLET_THERMAL_IMAGING);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_THERMAL_IMAGING_TEMPERATURE_IMAGE,
                THING_TYPE_BRICKLET_THERMAL_IMAGING);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_THERMAL_IMAGING_TEMPERATURE, THING_TYPE_BRICKLET_THERMAL_IMAGING);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_THERMAL_IMAGING_SPOTMETER_ROI_PIXEL_COUNT,
                THING_TYPE_BRICKLET_THERMAL_IMAGING);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_THERMAL_IMAGING_FFC_STATUS, THING_TYPE_BRICKLET_THERMAL_IMAGING);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_THERMAL_IMAGING_SHUTTER_LOCKOUT,
                THING_TYPE_BRICKLET_THERMAL_IMAGING);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_THERMAL_IMAGING_OVERTEMPERATURE_SHUTDOWN_IMMINENT,
                THING_TYPE_BRICKLET_THERMAL_IMAGING);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_THERMOCOUPLE_TEMPERATURE, THING_TYPE_BRICKLET_THERMOCOUPLE);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_THERMOCOUPLE_OVER_UNDER_VOLTAGE, THING_TYPE_BRICKLET_THERMOCOUPLE);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_THERMOCOUPLE_OPEN_CIRCUIT, THING_TYPE_BRICKLET_THERMOCOUPLE);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_THERMOCOUPLE_V2_TEMPERATURE, THING_TYPE_BRICKLET_THERMOCOUPLE_V2);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_THERMOCOUPLE_V2_OVER_UNDER_VOLTAGE,
                THING_TYPE_BRICKLET_THERMOCOUPLE_V2);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_THERMOCOUPLE_V2_OPEN_CIRCUIT, THING_TYPE_BRICKLET_THERMOCOUPLE_V2);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_TILT_TILTED, THING_TYPE_BRICKLET_TILT);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_TILT_VIBRATING, THING_TYPE_BRICKLET_TILT);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_UV_LIGHT_UV_LIGHT, THING_TYPE_BRICKLET_UV_LIGHT);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_UV_LIGHT_V2_UVA, THING_TYPE_BRICKLET_UV_LIGHT_V2);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_UV_LIGHT_V2_UVB, THING_TYPE_BRICKLET_UV_LIGHT_V2);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_UV_LIGHT_V2_UVI, THING_TYPE_BRICKLET_UV_LIGHT_V2);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_VOLTAGE_VOLTAGE, THING_TYPE_BRICKLET_VOLTAGE);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_VOLTAGE_ANALOG_VALUE, THING_TYPE_BRICKLET_VOLTAGE);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_VOLTAGE_CURRENT_VOLTAGE, THING_TYPE_BRICKLET_VOLTAGE_CURRENT);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_VOLTAGE_CURRENT_CURRENT, THING_TYPE_BRICKLET_VOLTAGE_CURRENT);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_VOLTAGE_CURRENT_POWER, THING_TYPE_BRICKLET_VOLTAGE_CURRENT);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_VOLTAGE_CURRENT_V2_VOLTAGE,
                THING_TYPE_BRICKLET_VOLTAGE_CURRENT_V2);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_VOLTAGE_CURRENT_V2_CURRENT,
                THING_TYPE_BRICKLET_VOLTAGE_CURRENT_V2);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_VOLTAGE_CURRENT_V2_POWER, THING_TYPE_BRICKLET_VOLTAGE_CURRENT_V2);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_XMC1400_BREAKOUT_COUNT, THING_TYPE_BRICKLET_XMC1400_BREAKOUT);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_BRICKLET_XMC1400_BREAKOUT_ADC_VALUE, THING_TYPE_BRICKLET_XMC1400_BREAKOUT);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_OUTDOOR_WEATHER_SENSOR_TEMPERATURE, THING_TYPE_OUTDOOR_WEATHER_SENSOR);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_OUTDOOR_WEATHER_SENSOR_HUMIDITY, THING_TYPE_OUTDOOR_WEATHER_SENSOR);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_OUTDOOR_WEATHER_SENSOR_LAST_CHANGE, THING_TYPE_OUTDOOR_WEATHER_SENSOR);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_OUTDOOR_WEATHER_STATION_TEMPERATURE, THING_TYPE_OUTDOOR_WEATHER_STATION);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_OUTDOOR_WEATHER_STATION_HUMIDITY, THING_TYPE_OUTDOOR_WEATHER_STATION);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_OUTDOOR_WEATHER_STATION_WIND_SPEED, THING_TYPE_OUTDOOR_WEATHER_STATION);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_OUTDOOR_WEATHER_STATION_GUST_SPEED, THING_TYPE_OUTDOOR_WEATHER_STATION);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_OUTDOOR_WEATHER_STATION_RAIN_FALL, THING_TYPE_OUTDOOR_WEATHER_STATION);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_OUTDOOR_WEATHER_STATION_WIND_DIRECTION, THING_TYPE_OUTDOOR_WEATHER_STATION);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_OUTDOOR_WEATHER_STATION_BATTERY_LOW, THING_TYPE_OUTDOOR_WEATHER_STATION);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_OUTDOOR_WEATHER_STATION_LAST_CHANGE, THING_TYPE_OUTDOOR_WEATHER_STATION);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_REMOTE_SOCKET_TYPE_A_COMMAND, THING_TYPE_REMOTE_SOCKET_TYPE_A);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_REMOTE_SOCKET_TYPE_B_COMMAND, THING_TYPE_REMOTE_SOCKET_TYPE_B);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_REMOTE_SOCKET_TYPE_C_COMMAND, THING_TYPE_REMOTE_SOCKET_TYPE_C);
        SUPPORTED_CHANNELS.put(CHANNEL_TYPE_REMOTE_DIMMER_TYPE_B_VALUE, THING_TYPE_REMOTE_DIMMER_TYPE_B);
    }

    public static final URI CONFIG_DESCRIPTION_URI_BRICK_DAEMON = URI
            .create("thing-type:" + THING_TYPE_BRICK_DAEMON.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICK_DC_CURRENT_VELOCITY = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICK_DC_CURRENT_VELOCITY.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICK_DC = URI
            .create("thing-type:" + THING_TYPE_BRICK_DC.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICK_HAT_USB_VOLTAGE = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICK_HAT_USB_VOLTAGE.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICK_HAT_DC_VOLTAGE = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICK_HAT_DC_VOLTAGE.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICK_HAT_POWER_BRICKLETS = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICK_HAT_POWER_BRICKLETS.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICK_HAT_SLEEP = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICK_HAT_SLEEP.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICK_HAT = URI
            .create("thing-type:" + THING_TYPE_BRICK_HAT.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICK_HAT_ZERO_USB_VOLTAGE = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICK_HAT_ZERO_USB_VOLTAGE.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICK_HAT_ZERO = URI
            .create("thing-type:" + THING_TYPE_BRICK_HAT_ZERO.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICK_IMU_ORIENTATION = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICK_IMU_ORIENTATION.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICK_IMU_QUATERNION = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICK_IMU_QUATERNION.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICK_IMU_ACCELERATION = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICK_IMU_ACCELERATION.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICK_IMU_MAGNETIC_FIELD = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICK_IMU_MAGNETIC_FIELD.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICK_IMU_ANGULAR_VELOCITY = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICK_IMU_ANGULAR_VELOCITY.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICK_IMU_ENABLE_LEDS = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICK_IMU_ENABLE_LEDS.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICK_IMU = URI
            .create("thing-type:" + THING_TYPE_BRICK_IMU.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICK_IMU_V2_ACCELERATION = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICK_IMU_V2_ACCELERATION.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICK_IMU_V2_MAGNETIC_FIELD = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICK_IMU_V2_MAGNETIC_FIELD.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICK_IMU_V2_ANGULAR_VELOCITY = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICK_IMU_V2_ANGULAR_VELOCITY.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICK_IMU_V2_ORIENTATION = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICK_IMU_V2_ORIENTATION.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICK_IMU_V2_QUATERNION = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICK_IMU_V2_QUATERNION.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICK_IMU_V2_LINEAR_ACCELERATION = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICK_IMU_V2_LINEAR_ACCELERATION.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICK_IMU_V2_GRAVITY_VECTOR = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICK_IMU_V2_GRAVITY_VECTOR.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICK_IMU_V2_TEMPERATURE = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICK_IMU_V2_TEMPERATURE.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICK_IMU_V2_ENABLE_LEDS = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICK_IMU_V2_ENABLE_LEDS.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICK_IMU_V2 = URI
            .create("thing-type:" + THING_TYPE_BRICK_IMU_V2.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICK_MASTER_STACK_VOLTAGE = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICK_MASTER_STACK_VOLTAGE.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICK_MASTER_USB_VOLTAGE = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICK_MASTER_USB_VOLTAGE.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICK_MASTER_STACK_CURRENT = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICK_MASTER_STACK_CURRENT.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICK_MASTER_BRICKLETS_ENABLED = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICK_MASTER_BRICKLETS_ENABLED.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICK_MASTER = URI
            .create("thing-type:" + THING_TYPE_BRICK_MASTER.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICK_RED = URI
            .create("thing-type:" + THING_TYPE_BRICK_RED.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICK_SERVO = URI
            .create("thing-type:" + THING_TYPE_BRICK_SERVO.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICK_SILENT_STEPPER_CURRENT_VELOCITY = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICK_SILENT_STEPPER_CURRENT_VELOCITY.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICK_SILENT_STEPPER_CURRENT_POSITION = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICK_SILENT_STEPPER_CURRENT_POSITION.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICK_SILENT_STEPPER_REMAINING_STEPS = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICK_SILENT_STEPPER_REMAINING_STEPS.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICK_SILENT_STEPPER_STACK_VOLTAGE = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICK_SILENT_STEPPER_STACK_VOLTAGE.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICK_SILENT_STEPPER_EXTERNAL_VOLTAGE = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICK_SILENT_STEPPER_EXTERNAL_VOLTAGE.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICK_SILENT_STEPPER_CURRENT_CONSUMPTION = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICK_SILENT_STEPPER_CURRENT_CONSUMPTION.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICK_SILENT_STEPPER_STATE = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICK_SILENT_STEPPER_STATE.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICK_SILENT_STEPPER = URI
            .create("thing-type:" + THING_TYPE_BRICK_SILENT_STEPPER.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICK_STEPPER_CURRENT_VELOCITY = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICK_STEPPER_CURRENT_VELOCITY.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICK_STEPPER_CURRENT_POSITION = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICK_STEPPER_CURRENT_POSITION.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICK_STEPPER_REMAINING_STEPS = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICK_STEPPER_REMAINING_STEPS.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICK_STEPPER_STACK_VOLTAGE = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICK_STEPPER_STACK_VOLTAGE.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICK_STEPPER_EXTERNAL_VOLTAGE = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICK_STEPPER_EXTERNAL_VOLTAGE.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICK_STEPPER_CURRENT_CONSUMPTION = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICK_STEPPER_CURRENT_CONSUMPTION.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICK_STEPPER_STATE = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICK_STEPPER_STATE.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICK_STEPPER = URI
            .create("thing-type:" + THING_TYPE_BRICK_STEPPER.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_ACCELEROMETER_ACCELERATION = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_ACCELEROMETER_ACCELERATION.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_ACCELEROMETER_LED = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_ACCELEROMETER_LED.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_ACCELEROMETER_TEMPERATURE = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_ACCELEROMETER_TEMPERATURE.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_ACCELEROMETER = URI
            .create("thing-type:" + THING_TYPE_BRICKLET_ACCELEROMETER.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_ACCELEROMETER_V2_ACCELERATION = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_ACCELEROMETER_V2_ACCELERATION.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_ACCELEROMETER_V2 = URI
            .create("thing-type:" + THING_TYPE_BRICKLET_ACCELEROMETER_V2.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_AIR_QUALITY_HUMIDITY = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_AIR_QUALITY_HUMIDITY.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_AIR_QUALITY_TEMPERATURE = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_AIR_QUALITY_TEMPERATURE.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_AIR_QUALITY_AIR_PRESSURE = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_AIR_QUALITY_AIR_PRESSURE.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_AIR_QUALITY_IAQ_INDEX = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_AIR_QUALITY_IAQ_INDEX.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_AIR_QUALITY_IAQ_INDEX_ACCURACY = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_AIR_QUALITY_IAQ_INDEX_ACCURACY.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_AIR_QUALITY = URI
            .create("thing-type:" + THING_TYPE_BRICKLET_AIR_QUALITY.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_AMBIENT_LIGHT_ILLUMINANCE = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_AMBIENT_LIGHT_ILLUMINANCE.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_AMBIENT_LIGHT_ANALOG_VALUE = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_AMBIENT_LIGHT_ANALOG_VALUE.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_AMBIENT_LIGHT = URI
            .create("thing-type:" + THING_TYPE_BRICKLET_AMBIENT_LIGHT.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_AMBIENT_LIGHT_V2_ILLUMINANCE = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_AMBIENT_LIGHT_V2_ILLUMINANCE.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_AMBIENT_LIGHT_V2 = URI
            .create("thing-type:" + THING_TYPE_BRICKLET_AMBIENT_LIGHT_V2.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_AMBIENT_LIGHT_V3_ILLUMINANCE = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_AMBIENT_LIGHT_V3_ILLUMINANCE.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_AMBIENT_LIGHT_V3 = URI
            .create("thing-type:" + THING_TYPE_BRICKLET_AMBIENT_LIGHT_V3.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_ANALOG_IN_VOLTAGE = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_ANALOG_IN_VOLTAGE.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_ANALOG_IN_ANALOG_VALUE = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_ANALOG_IN_ANALOG_VALUE.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_ANALOG_IN = URI
            .create("thing-type:" + THING_TYPE_BRICKLET_ANALOG_IN.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_ANALOG_IN_V2_VOLTAGE = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_ANALOG_IN_V2_VOLTAGE.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_ANALOG_IN_V2_ANALOG_VALUE = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_ANALOG_IN_V2_ANALOG_VALUE.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_ANALOG_IN_V2 = URI
            .create("thing-type:" + THING_TYPE_BRICKLET_ANALOG_IN_V2.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_ANALOG_IN_V3_VOLTAGE = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_ANALOG_IN_V3_VOLTAGE.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_ANALOG_IN_V3 = URI
            .create("thing-type:" + THING_TYPE_BRICKLET_ANALOG_IN_V3.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_ANALOG_OUT_VOLTAGE = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_ANALOG_OUT_VOLTAGE.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_ANALOG_OUT_MODE = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_ANALOG_OUT_MODE.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_ANALOG_OUT = URI
            .create("thing-type:" + THING_TYPE_BRICKLET_ANALOG_OUT.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_ANALOG_OUT_V2_INPUT_VOLTAGE = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_ANALOG_OUT_V2_INPUT_VOLTAGE.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_ANALOG_OUT_V2_OUTPUT_VOLTAGE = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_ANALOG_OUT_V2_OUTPUT_VOLTAGE.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_ANALOG_OUT_V2 = URI
            .create("thing-type:" + THING_TYPE_BRICKLET_ANALOG_OUT_V2.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_ANALOG_OUT_V3_INPUT_VOLTAGE = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_ANALOG_OUT_V3_INPUT_VOLTAGE.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_ANALOG_OUT_V3_OUTPUT_VOLTAGE = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_ANALOG_OUT_V3_OUTPUT_VOLTAGE.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_ANALOG_OUT_V3 = URI
            .create("thing-type:" + THING_TYPE_BRICKLET_ANALOG_OUT_V3.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_BAROMETER_AIR_PRESSURE = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_BAROMETER_AIR_PRESSURE.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_BAROMETER_ALTITUDE = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_BAROMETER_ALTITUDE.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_BAROMETER = URI
            .create("thing-type:" + THING_TYPE_BRICKLET_BAROMETER.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_BAROMETER_V2_AIR_PRESSURE = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_BAROMETER_V2_AIR_PRESSURE.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_BAROMETER_V2_ALTITUDE = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_BAROMETER_V2_ALTITUDE.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_BAROMETER_V2_TEMPERATURE = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_BAROMETER_V2_TEMPERATURE.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_BAROMETER_V2 = URI
            .create("thing-type:" + THING_TYPE_BRICKLET_BAROMETER_V2.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_CAN_WRITE_ERROR_LEVEL = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_CAN_WRITE_ERROR_LEVEL.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_CAN_READ_ERROR_LEVEL = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_CAN_READ_ERROR_LEVEL.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_CAN_TRANSCEIVER_DISABLED = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_CAN_TRANSCEIVER_DISABLED.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_CAN_WRITE_TIMEOUT_COUNT = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_CAN_WRITE_TIMEOUT_COUNT.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_CAN_READ_REGISTER_OVERFLOW_COUNT = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_CAN_READ_REGISTER_OVERFLOW_COUNT.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_CAN_READ_BUFFER_OVERFLOW_COUNT = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_CAN_READ_BUFFER_OVERFLOW_COUNT.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_CAN = URI
            .create("thing-type:" + THING_TYPE_BRICKLET_CAN.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_CAN_V2 = URI
            .create("thing-type:" + THING_TYPE_BRICKLET_CAN_V2.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_CO2_CO2_CONCENTRATION = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_CO2_CO2_CONCENTRATION.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_CO2 = URI
            .create("thing-type:" + THING_TYPE_BRICKLET_CO2.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_CO2_V2_CO2_CONCENTRATION = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_CO2_V2_CO2_CONCENTRATION.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_CO2_V2_TEMPERATURE = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_CO2_V2_TEMPERATURE.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_CO2_V2_HUMIDITY = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_CO2_V2_HUMIDITY.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_CO2_V2_AIR_PRESSURE = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_CO2_V2_AIR_PRESSURE.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_CO2_V2 = URI
            .create("thing-type:" + THING_TYPE_BRICKLET_CO2_V2.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_COLOR_COLOR = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_COLOR_COLOR.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_COLOR_ILLUMINANCE = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_COLOR_ILLUMINANCE.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_COLOR_COLOR_TEMPERATURE = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_COLOR_COLOR_TEMPERATURE.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_COLOR_LIGHT = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_COLOR_LIGHT.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_COLOR = URI
            .create("thing-type:" + THING_TYPE_BRICKLET_COLOR.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_COLOR_V2_COLOR = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_COLOR_V2_COLOR.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_COLOR_V2_ILLUMINANCE = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_COLOR_V2_ILLUMINANCE.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_COLOR_V2_COLOR_TEMPERATURE = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_COLOR_V2_COLOR_TEMPERATURE.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_COLOR_V2_LIGHT = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_COLOR_V2_LIGHT.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_COLOR_V2 = URI
            .create("thing-type:" + THING_TYPE_BRICKLET_COLOR_V2.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_COMPASS_HEADING = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_COMPASS_HEADING.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_COMPASS_MAGNETIC_FLUX_DENSITY = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_COMPASS_MAGNETIC_FLUX_DENSITY.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_COMPASS = URI
            .create("thing-type:" + THING_TYPE_BRICKLET_COMPASS.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_CURRENT12_CURRENT = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_CURRENT12_CURRENT.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_CURRENT12_OVER_CURRENT = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_CURRENT12_OVER_CURRENT.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_CURRENT12_ANALOG_VALUE = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_CURRENT12_ANALOG_VALUE.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_CURRENT12 = URI
            .create("thing-type:" + THING_TYPE_BRICKLET_CURRENT12.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_CURRENT25_CURRENT = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_CURRENT25_CURRENT.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_CURRENT25_OVER_CURRENT = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_CURRENT25_OVER_CURRENT.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_CURRENT25_ANALOG_VALUE = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_CURRENT25_ANALOG_VALUE.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_CURRENT25 = URI
            .create("thing-type:" + THING_TYPE_BRICKLET_CURRENT25.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_DISTANCE_IR_DISTANCE = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_DISTANCE_IR_DISTANCE.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_DISTANCE_IR_ANALOG_VALUE = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_DISTANCE_IR_ANALOG_VALUE.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_DISTANCE_IR = URI
            .create("thing-type:" + THING_TYPE_BRICKLET_DISTANCE_IR.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_DISTANCE_IR_V2_DISTANCE = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_DISTANCE_IR_V2_DISTANCE.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_DISTANCE_IR_V2_ANALOG_VALUE = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_DISTANCE_IR_V2_ANALOG_VALUE.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_DISTANCE_IR_V2 = URI
            .create("thing-type:" + THING_TYPE_BRICKLET_DISTANCE_IR_V2.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_DISTANCE_US_DISTANCE = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_DISTANCE_US_DISTANCE.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_DISTANCE_US = URI
            .create("thing-type:" + THING_TYPE_BRICKLET_DISTANCE_US.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_DISTANCE_US_V2_DISTANCE = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_DISTANCE_US_V2_DISTANCE.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_DISTANCE_US_V2 = URI
            .create("thing-type:" + THING_TYPE_BRICKLET_DISTANCE_US_V2.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_DMX_OVERRUN_ERROR_COUNT = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_DMX_OVERRUN_ERROR_COUNT.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_DMX_FRAMING_ERROR_COUNT = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_DMX_FRAMING_ERROR_COUNT.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_DMX = URI
            .create("thing-type:" + THING_TYPE_BRICKLET_DMX.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_DUAL_BUTTON_LEFT_LED = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_DUAL_BUTTON_LEFT_LED.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_DUAL_BUTTON_RIGHT_LED = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_DUAL_BUTTON_RIGHT_LED.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_DUAL_BUTTON = URI
            .create("thing-type:" + THING_TYPE_BRICKLET_DUAL_BUTTON.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_DUAL_BUTTON_V2_LEFT_LED = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_DUAL_BUTTON_V2_LEFT_LED.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_DUAL_BUTTON_V2_RIGHT_LED = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_DUAL_BUTTON_V2_RIGHT_LED.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_DUAL_BUTTON_V2 = URI
            .create("thing-type:" + THING_TYPE_BRICKLET_DUAL_BUTTON_V2.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_DUAL_RELAY_RELAY = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_DUAL_RELAY_RELAY.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_DUAL_RELAY_MONOFLOP = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_DUAL_RELAY_MONOFLOP.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_DUAL_RELAY = URI
            .create("thing-type:" + THING_TYPE_BRICKLET_DUAL_RELAY.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_DUST_DETECTOR_DUST_DENSITY = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_DUST_DETECTOR_DUST_DENSITY.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_DUST_DETECTOR = URI
            .create("thing-type:" + THING_TYPE_BRICKLET_DUST_DETECTOR.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_E_PAPER_296X128_DRAW_STATUS = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_E_PAPER_296X128_DRAW_STATUS.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_E_PAPER_296X128 = URI
            .create("thing-type:" + THING_TYPE_BRICKLET_E_PAPER_296X128.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_ENERGY_MONITOR_VOLTAGE = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_ENERGY_MONITOR_VOLTAGE.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_ENERGY_MONITOR_CURRENT = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_ENERGY_MONITOR_CURRENT.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_ENERGY_MONITOR_ENERGY = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_ENERGY_MONITOR_ENERGY.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_ENERGY_MONITOR_REALPOWER = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_ENERGY_MONITOR_REALPOWER.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_ENERGY_MONITOR_APPPOWER = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_ENERGY_MONITOR_APPPOWER.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_ENERGY_MONITOR_REACPOWER = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_ENERGY_MONITOR_REACPOWER.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_ENERGY_MONITOR_FACTOR = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_ENERGY_MONITOR_FACTOR.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_ENERGY_MONITOR_FREQUENCY = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_ENERGY_MONITOR_FREQUENCY.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_ENERGY_MONITOR_RESET = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_ENERGY_MONITOR_RESET.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_ENERGY_MONITOR = URI
            .create("thing-type:" + THING_TYPE_BRICKLET_ENERGY_MONITOR.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_GPS_COORDINATES = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_GPS_COORDINATES.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_GPS_FIX = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_GPS_FIX.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_GPS_SATELLITES_IN_VIEW = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_GPS_SATELLITES_IN_VIEW.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_GPS_SATELLITES_USED = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_GPS_SATELLITES_USED.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_GPS_ALTITUDE = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_GPS_ALTITUDE.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_GPS_GEOIDAL_SEPARATION = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_GPS_GEOIDAL_SEPARATION.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_GPS_COURSE = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_GPS_COURSE.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_GPS_SPEED = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_GPS_SPEED.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_GPS_DATE_TIME = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_GPS_DATE_TIME.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_GPS_RESTART = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_GPS_RESTART.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_GPS = URI
            .create("thing-type:" + THING_TYPE_BRICKLET_GPS.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_GPS_V2_COORDINATES = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_GPS_V2_COORDINATES.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_GPS_V2_FIX = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_GPS_V2_FIX.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_GPS_V2_SATELLITES_IN_VIEW = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_GPS_V2_SATELLITES_IN_VIEW.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_GPS_V2_ALTITUDE = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_GPS_V2_ALTITUDE.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_GPS_V2_GEOIDAL_SEPARATION = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_GPS_V2_GEOIDAL_SEPARATION.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_GPS_V2_COURSE = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_GPS_V2_COURSE.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_GPS_V2_SPEED = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_GPS_V2_SPEED.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_GPS_V2_DATE_TIME = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_GPS_V2_DATE_TIME.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_GPS_V2_RESTART = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_GPS_V2_RESTART.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_GPS_V2 = URI
            .create("thing-type:" + THING_TYPE_BRICKLET_GPS_V2.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_HALL_EFFECT_EDGE_COUNT = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_HALL_EFFECT_EDGE_COUNT.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_HALL_EFFECT_MAGNETIC_FIELD_DETECTED = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_HALL_EFFECT_MAGNETIC_FIELD_DETECTED.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_HALL_EFFECT = URI
            .create("thing-type:" + THING_TYPE_BRICKLET_HALL_EFFECT.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_HALL_EFFECT_V2_COUNTER = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_HALL_EFFECT_V2_COUNTER.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_HALL_EFFECT_V2_MAGNETIC_FLUX_DENSITY = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_HALL_EFFECT_V2_MAGNETIC_FLUX_DENSITY.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_HALL_EFFECT_V2 = URI
            .create("thing-type:" + THING_TYPE_BRICKLET_HALL_EFFECT_V2.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_HUMIDITY_HUMIDITY = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_HUMIDITY_HUMIDITY.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_HUMIDITY_ANALOG_VALUE = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_HUMIDITY_ANALOG_VALUE.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_HUMIDITY = URI
            .create("thing-type:" + THING_TYPE_BRICKLET_HUMIDITY.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_HUMIDITY_V2_HUMIDITY = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_HUMIDITY_V2_HUMIDITY.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_HUMIDITY_V2_TEMPERATURE = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_HUMIDITY_V2_TEMPERATURE.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_HUMIDITY_V2_HEATER = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_HUMIDITY_V2_HEATER.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_HUMIDITY_V2 = URI
            .create("thing-type:" + THING_TYPE_BRICKLET_HUMIDITY_V2.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_INDUSTRIAL_ANALOG_OUT_ENABLED = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_INDUSTRIAL_ANALOG_OUT_ENABLED.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_INDUSTRIAL_ANALOG_OUT_VOLTAGE = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_INDUSTRIAL_ANALOG_OUT_VOLTAGE.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_INDUSTRIAL_ANALOG_OUT_CURRENT = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_INDUSTRIAL_ANALOG_OUT_CURRENT.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_INDUSTRIAL_ANALOG_OUT = URI
            .create("thing-type:" + THING_TYPE_BRICKLET_INDUSTRIAL_ANALOG_OUT.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_INDUSTRIAL_ANALOG_OUT_V2_ENABLED = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_INDUSTRIAL_ANALOG_OUT_V2_ENABLED.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_INDUSTRIAL_ANALOG_OUT_V2_VOLTAGE = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_INDUSTRIAL_ANALOG_OUT_V2_VOLTAGE.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_INDUSTRIAL_ANALOG_OUT_V2_CURRENT = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_INDUSTRIAL_ANALOG_OUT_V2_CURRENT.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_INDUSTRIAL_ANALOG_OUT_V2 = URI
            .create("thing-type:" + THING_TYPE_BRICKLET_INDUSTRIAL_ANALOG_OUT_V2.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_INDUSTRIAL_COUNTER_DUTY_CYCLE = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_INDUSTRIAL_COUNTER_DUTY_CYCLE.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_INDUSTRIAL_COUNTER_PERIOD = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_INDUSTRIAL_COUNTER_PERIOD.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_INDUSTRIAL_COUNTER_FREQUENCY = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_INDUSTRIAL_COUNTER_FREQUENCY.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_INDUSTRIAL_COUNTER_VALUE = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_INDUSTRIAL_COUNTER_VALUE.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_INDUSTRIAL_COUNTER_COUNTER = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_INDUSTRIAL_COUNTER_COUNTER.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_INDUSTRIAL_COUNTER = URI
            .create("thing-type:" + THING_TYPE_BRICKLET_INDUSTRIAL_COUNTER.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_INDUSTRIAL_DIGITAL_IN_4_INPUT_PIN = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_INDUSTRIAL_DIGITAL_IN_4_INPUT_PIN.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_INDUSTRIAL_DIGITAL_IN_4_EDGE_COUNT = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_INDUSTRIAL_DIGITAL_IN_4_EDGE_COUNT.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_INDUSTRIAL_DIGITAL_IN_4 = URI
            .create("thing-type:" + THING_TYPE_BRICKLET_INDUSTRIAL_DIGITAL_IN_4.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_INDUSTRIAL_DIGITAL_IN_4_V2_VALUE = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_INDUSTRIAL_DIGITAL_IN_4_V2_VALUE.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_INDUSTRIAL_DIGITAL_IN_4_V2_EDGE_COUNT = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_INDUSTRIAL_DIGITAL_IN_4_V2_EDGE_COUNT.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_INDUSTRIAL_DIGITAL_IN_4_V2 = URI
            .create("thing-type:" + THING_TYPE_BRICKLET_INDUSTRIAL_DIGITAL_IN_4_V2.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_INDUSTRIAL_DIGITAL_OUT_4_OUTPUT_PIN = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_INDUSTRIAL_DIGITAL_OUT_4_OUTPUT_PIN.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_INDUSTRIAL_DIGITAL_OUT_4_MONOFLOP = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_INDUSTRIAL_DIGITAL_OUT_4_MONOFLOP.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_INDUSTRIAL_DIGITAL_OUT_4 = URI
            .create("thing-type:" + THING_TYPE_BRICKLET_INDUSTRIAL_DIGITAL_OUT_4.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_INDUSTRIAL_DIGITAL_OUT_4_V2_OUTPUT_PIN = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_INDUSTRIAL_DIGITAL_OUT_4_V2_OUTPUT_PIN.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_INDUSTRIAL_DIGITAL_OUT_4_V2_MONOFLOP = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_INDUSTRIAL_DIGITAL_OUT_4_V2_MONOFLOP.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_INDUSTRIAL_DIGITAL_OUT_4_V2 = URI
            .create("thing-type:" + THING_TYPE_BRICKLET_INDUSTRIAL_DIGITAL_OUT_4_V2.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_INDUSTRIAL_DUAL_0_20MA_CURRENT = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_INDUSTRIAL_DUAL_0_20MA_CURRENT.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_INDUSTRIAL_DUAL_0_20MA = URI
            .create("thing-type:" + THING_TYPE_BRICKLET_INDUSTRIAL_DUAL_0_20MA.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_INDUSTRIAL_DUAL_0_20MA_V2_CURRENT = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_INDUSTRIAL_DUAL_0_20MA_V2_CURRENT.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_INDUSTRIAL_DUAL_0_20MA_V2 = URI
            .create("thing-type:" + THING_TYPE_BRICKLET_INDUSTRIAL_DUAL_0_20MA_V2.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_INDUSTRIAL_DUAL_ANALOG_IN_VOLTAGE = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_INDUSTRIAL_DUAL_ANALOG_IN_VOLTAGE.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_INDUSTRIAL_DUAL_ANALOG_IN = URI
            .create("thing-type:" + THING_TYPE_BRICKLET_INDUSTRIAL_DUAL_ANALOG_IN.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_INDUSTRIAL_DUAL_ANALOG_IN_V2_VOLTAGE = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_INDUSTRIAL_DUAL_ANALOG_IN_V2_VOLTAGE.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_INDUSTRIAL_DUAL_ANALOG_IN_V2 = URI
            .create("thing-type:" + THING_TYPE_BRICKLET_INDUSTRIAL_DUAL_ANALOG_IN_V2.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_INDUSTRIAL_DUAL_RELAY_RELAY = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_INDUSTRIAL_DUAL_RELAY_RELAY.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_INDUSTRIAL_DUAL_RELAY_MONOFLOP = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_INDUSTRIAL_DUAL_RELAY_MONOFLOP.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_INDUSTRIAL_DUAL_RELAY = URI
            .create("thing-type:" + THING_TYPE_BRICKLET_INDUSTRIAL_DUAL_RELAY.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_INDUSTRIAL_QUAD_RELAY_RELAY = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_INDUSTRIAL_QUAD_RELAY_RELAY.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_INDUSTRIAL_QUAD_RELAY_MONOFLOP = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_INDUSTRIAL_QUAD_RELAY_MONOFLOP.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_INDUSTRIAL_QUAD_RELAY = URI
            .create("thing-type:" + THING_TYPE_BRICKLET_INDUSTRIAL_QUAD_RELAY.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_INDUSTRIAL_QUAD_RELAY_V2_RELAY = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_INDUSTRIAL_QUAD_RELAY_V2_RELAY.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_INDUSTRIAL_QUAD_RELAY_V2_MONOFLOP = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_INDUSTRIAL_QUAD_RELAY_V2_MONOFLOP.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_INDUSTRIAL_QUAD_RELAY_V2 = URI
            .create("thing-type:" + THING_TYPE_BRICKLET_INDUSTRIAL_QUAD_RELAY_V2.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_IO16_INPUT_PIN = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_IO16_INPUT_PIN.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_IO16_OUTPUT_PIN = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_IO16_OUTPUT_PIN.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_IO16_MONOFLOP = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_IO16_MONOFLOP.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_IO16_EDGE_COUNT = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_IO16_EDGE_COUNT.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_IO16 = URI
            .create("thing-type:" + THING_TYPE_BRICKLET_IO16.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_IO16_V2_INPUT_VALUE = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_IO16_V2_INPUT_VALUE.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_IO16_V2_OUTPUT_PIN = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_IO16_V2_OUTPUT_PIN.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_IO16_V2_MONOFLOP = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_IO16_V2_MONOFLOP.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_IO16_V2_EDGE_COUNT = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_IO16_V2_EDGE_COUNT.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_IO16_V2 = URI
            .create("thing-type:" + THING_TYPE_BRICKLET_IO16_V2.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_IO4_INPUT_PIN = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_IO4_INPUT_PIN.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_IO4_OUTPUT_PIN = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_IO4_OUTPUT_PIN.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_IO4_MONOFLOP = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_IO4_MONOFLOP.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_IO4_EDGE_COUNT = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_IO4_EDGE_COUNT.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_IO4 = URI
            .create("thing-type:" + THING_TYPE_BRICKLET_IO4.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_IO4_V2_INPUT_VALUE = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_IO4_V2_INPUT_VALUE.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_IO4_V2_OUTPUT_PIN = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_IO4_V2_OUTPUT_PIN.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_IO4_V2_MONOFLOP = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_IO4_V2_MONOFLOP.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_IO4_V2_EDGE_COUNT = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_IO4_V2_EDGE_COUNT.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_IO4_V2 = URI
            .create("thing-type:" + THING_TYPE_BRICKLET_IO4_V2.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_ISOLATOR_MESSAGES_FROM_BRICK = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_ISOLATOR_MESSAGES_FROM_BRICK.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_ISOLATOR_MESSAGES_FROM_BRICKLET = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_ISOLATOR_MESSAGES_FROM_BRICKLET.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_ISOLATOR_CONNECTED_BRICKLET_DEVICE_NAME = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_ISOLATOR_CONNECTED_BRICKLET_DEVICE_NAME.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_ISOLATOR_CONNECTED_BRICKLET_UID = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_ISOLATOR_CONNECTED_BRICKLET_UID.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_ISOLATOR = URI
            .create("thing-type:" + THING_TYPE_BRICKLET_ISOLATOR.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_JOYSTICK_POSITION = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_JOYSTICK_POSITION.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_JOYSTICK_ANALOG_VALUE_X = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_JOYSTICK_ANALOG_VALUE_X.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_JOYSTICK_ANALOG_VALUE_Y = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_JOYSTICK_ANALOG_VALUE_Y.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_JOYSTICK = URI
            .create("thing-type:" + THING_TYPE_BRICKLET_JOYSTICK.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_JOYSTICK_V2_POSITION = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_JOYSTICK_V2_POSITION.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_JOYSTICK_V2 = URI
            .create("thing-type:" + THING_TYPE_BRICKLET_JOYSTICK_V2.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_LASER_RANGE_FINDER_DISTANCE = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_LASER_RANGE_FINDER_DISTANCE.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_LASER_RANGE_FINDER_VELOCITY = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_LASER_RANGE_FINDER_VELOCITY.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_LASER_RANGE_FINDER_ENABLE_LASER = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_LASER_RANGE_FINDER_ENABLE_LASER.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_LASER_RANGE_FINDER = URI
            .create("thing-type:" + THING_TYPE_BRICKLET_LASER_RANGE_FINDER.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_LASER_RANGE_FINDER_V2_DISTANCE = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_LASER_RANGE_FINDER_V2_DISTANCE.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_LASER_RANGE_FINDER_V2_VELOCITY = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_LASER_RANGE_FINDER_V2_VELOCITY.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_LASER_RANGE_FINDER_V2_ENABLE_LASER = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_LASER_RANGE_FINDER_V2_ENABLE_LASER.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_LASER_RANGE_FINDER_V2 = URI
            .create("thing-type:" + THING_TYPE_BRICKLET_LASER_RANGE_FINDER_V2.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_LCD_128X64_TEXT = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_LCD_128X64_TEXT.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_LCD_128X64_CLEAR_DISPLAY = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_LCD_128X64_CLEAR_DISPLAY.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_LCD_128X64_DRAW_BUFFERED_FRAME = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_LCD_128X64_DRAW_BUFFERED_FRAME.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_LCD_128X64_BACKLIGHT = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_LCD_128X64_BACKLIGHT.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_LCD_128X64_GUI_TAB_SELECTED = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_LCD_128X64_GUI_TAB_SELECTED.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_LCD_128X64_GUI_SLIDER = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_LCD_128X64_GUI_SLIDER.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_LCD_128X64 = URI
            .create("thing-type:" + THING_TYPE_BRICKLET_LCD_128X64.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_LCD_16X2_TEXT = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_LCD_16X2_TEXT.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_LCD_16X2_CLEAR_DISPLAY = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_LCD_16X2_CLEAR_DISPLAY.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_LCD_16X2_BACKLIGHT = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_LCD_16X2_BACKLIGHT.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_LCD_16X2 = URI
            .create("thing-type:" + THING_TYPE_BRICKLET_LCD_16X2.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_LCD_20X4_TEXT = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_LCD_20X4_TEXT.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_LCD_20X4_CLEAR_DISPLAY = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_LCD_20X4_CLEAR_DISPLAY.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_LCD_20X4_BACKLIGHT = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_LCD_20X4_BACKLIGHT.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_LCD_20X4 = URI
            .create("thing-type:" + THING_TYPE_BRICKLET_LCD_20X4.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_LED_STRIP_LED_VALUES = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_LED_STRIP_LED_VALUES.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_LED_STRIP = URI
            .create("thing-type:" + THING_TYPE_BRICKLET_LED_STRIP.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_LED_STRIP_V2_LED_VALUES = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_LED_STRIP_V2_LED_VALUES.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_LED_STRIP_V2 = URI
            .create("thing-type:" + THING_TYPE_BRICKLET_LED_STRIP_V2.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_LINE_REFLECTIVITY = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_LINE_REFLECTIVITY.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_LINE = URI
            .create("thing-type:" + THING_TYPE_BRICKLET_LINE.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_LINEAR_POTI_POSITION = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_LINEAR_POTI_POSITION.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_LINEAR_POTI_ANALOG_VALUE = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_LINEAR_POTI_ANALOG_VALUE.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_LINEAR_POTI = URI
            .create("thing-type:" + THING_TYPE_BRICKLET_LINEAR_POTI.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_LINEAR_POTI_V2_POSITION = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_LINEAR_POTI_V2_POSITION.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_LINEAR_POTI_V2 = URI
            .create("thing-type:" + THING_TYPE_BRICKLET_LINEAR_POTI_V2.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_LOAD_CELL_WEIGHT = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_LOAD_CELL_WEIGHT.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_LOAD_CELL_TARE = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_LOAD_CELL_TARE.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_LOAD_CELL_LED = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_LOAD_CELL_LED.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_LOAD_CELL = URI
            .create("thing-type:" + THING_TYPE_BRICKLET_LOAD_CELL.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_LOAD_CELL_V2_WEIGHT = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_LOAD_CELL_V2_WEIGHT.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_LOAD_CELL_V2_TARE = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_LOAD_CELL_V2_TARE.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_LOAD_CELL_V2 = URI
            .create("thing-type:" + THING_TYPE_BRICKLET_LOAD_CELL_V2.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_MOISTURE_MOISTURE = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_MOISTURE_MOISTURE.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_MOISTURE = URI
            .create("thing-type:" + THING_TYPE_BRICKLET_MOISTURE.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_MOTION_DETECTOR = URI
            .create("thing-type:" + THING_TYPE_BRICKLET_MOTION_DETECTOR.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_MOTION_DETECTOR_V2_INDICATOR = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_MOTION_DETECTOR_V2_INDICATOR.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_MOTION_DETECTOR_V2 = URI
            .create("thing-type:" + THING_TYPE_BRICKLET_MOTION_DETECTOR_V2.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_MOTORIZED_LINEAR_POTI_POSITION = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_MOTORIZED_LINEAR_POTI_POSITION.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_MOTORIZED_LINEAR_POTI_MOTOR_POSITION = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_MOTORIZED_LINEAR_POTI_MOTOR_POSITION.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_MOTORIZED_LINEAR_POTI = URI
            .create("thing-type:" + THING_TYPE_BRICKLET_MOTORIZED_LINEAR_POTI.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_MULTI_TOUCH_ELECTRODE = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_MULTI_TOUCH_ELECTRODE.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_MULTI_TOUCH_RECALIBRATE = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_MULTI_TOUCH_RECALIBRATE.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_MULTI_TOUCH = URI
            .create("thing-type:" + THING_TYPE_BRICKLET_MULTI_TOUCH.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_MULTI_TOUCH_V2_ELECTRODE = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_MULTI_TOUCH_V2_ELECTRODE.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_MULTI_TOUCH_V2_RECALIBRATE = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_MULTI_TOUCH_V2_RECALIBRATE.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_MULTI_TOUCH_V2 = URI
            .create("thing-type:" + THING_TYPE_BRICKLET_MULTI_TOUCH_V2.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_NFC_STATE = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_NFC_STATE.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_NFC = URI
            .create("thing-type:" + THING_TYPE_BRICKLET_NFC.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_NFC_RFID_STATE = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_NFC_RFID_STATE.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_NFC_RFID = URI
            .create("thing-type:" + THING_TYPE_BRICKLET_NFC_RFID.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_OLED_128X64_TEXT = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_OLED_128X64_TEXT.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_OLED_128X64_CLEAR_DISPLAY = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_OLED_128X64_CLEAR_DISPLAY.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_OLED_128X64 = URI
            .create("thing-type:" + THING_TYPE_BRICKLET_OLED_128X64.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_OLED_128X64_V2_TEXT = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_OLED_128X64_V2_TEXT.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_OLED_128X64_V2_CLEAR_DISPLAY = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_OLED_128X64_V2_CLEAR_DISPLAY.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_OLED_128X64_V2_DRAW_BUFFERED_FRAME = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_OLED_128X64_V2_DRAW_BUFFERED_FRAME.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_OLED_128X64_V2 = URI
            .create("thing-type:" + THING_TYPE_BRICKLET_OLED_128X64_V2.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_OLED_64X48_TEXT = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_OLED_64X48_TEXT.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_OLED_64X48_CLEAR_DISPLAY = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_OLED_64X48_CLEAR_DISPLAY.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_OLED_64X48 = URI
            .create("thing-type:" + THING_TYPE_BRICKLET_OLED_64X48.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_ONE_WIRE = URI
            .create("thing-type:" + THING_TYPE_BRICKLET_ONE_WIRE.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_OUTDOOR_WEATHER_SENSOR_IDENTIFIERS = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_OUTDOOR_WEATHER_SENSOR_IDENTIFIERS.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_OUTDOOR_WEATHER_STATION_IDENTIFIERS = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_OUTDOOR_WEATHER_STATION_IDENTIFIERS.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_OUTDOOR_WEATHER = URI
            .create("thing-type:" + THING_TYPE_BRICKLET_OUTDOOR_WEATHER.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_PARTICULATE_MATTER_PM10_CONCENTRATION = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_PARTICULATE_MATTER_PM10_CONCENTRATION.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_PARTICULATE_MATTER_PM25_CONCENTRATION = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_PARTICULATE_MATTER_PM25_CONCENTRATION.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_PARTICULATE_MATTER_PM100_CONCENTRATION = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_PARTICULATE_MATTER_PM100_CONCENTRATION.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_PARTICULATE_MATTER_PART_COUNT_3 = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_PARTICULATE_MATTER_PART_COUNT_3.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_PARTICULATE_MATTER_PART_COUNT_5 = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_PARTICULATE_MATTER_PART_COUNT_5.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_PARTICULATE_MATTER_PART_COUNT_10 = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_PARTICULATE_MATTER_PART_COUNT_10.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_PARTICULATE_MATTER_PART_COUNT_25 = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_PARTICULATE_MATTER_PART_COUNT_25.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_PARTICULATE_MATTER_PART_COUNT_50 = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_PARTICULATE_MATTER_PART_COUNT_50.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_PARTICULATE_MATTER_PART_COUNT_100 = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_PARTICULATE_MATTER_PART_COUNT_100.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_PARTICULATE_MATTER_SENSOR_ENABLED = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_PARTICULATE_MATTER_SENSOR_ENABLED.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_PARTICULATE_MATTER = URI
            .create("thing-type:" + THING_TYPE_BRICKLET_PARTICULATE_MATTER.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_PIEZO_BUZZER_BEEP = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_PIEZO_BUZZER_BEEP.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_PIEZO_BUZZER_MORSE_CODE = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_PIEZO_BUZZER_MORSE_CODE.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_PIEZO_BUZZER = URI
            .create("thing-type:" + THING_TYPE_BRICKLET_PIEZO_BUZZER.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_PIEZO_SPEAKER = URI
            .create("thing-type:" + THING_TYPE_BRICKLET_PIEZO_SPEAKER.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_PIEZO_SPEAKER_V2_BEEP = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_PIEZO_SPEAKER_V2_BEEP.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_PIEZO_SPEAKER_V2_ALARM = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_PIEZO_SPEAKER_V2_ALARM.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_PIEZO_SPEAKER_V2_VOLUME = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_PIEZO_SPEAKER_V2_VOLUME.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_PIEZO_SPEAKER_V2_BEEP_FREQUENCY = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_PIEZO_SPEAKER_V2_BEEP_FREQUENCY.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_PIEZO_SPEAKER_V2 = URI
            .create("thing-type:" + THING_TYPE_BRICKLET_PIEZO_SPEAKER_V2.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_PTC_TEMPERATURE = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_PTC_TEMPERATURE.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_PTC_RESISTANCE = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_PTC_RESISTANCE.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_PTC_SENSOR_CONNECTED = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_PTC_SENSOR_CONNECTED.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_PTC = URI
            .create("thing-type:" + THING_TYPE_BRICKLET_PTC.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_PTC_V2_TEMPERATURE = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_PTC_V2_TEMPERATURE.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_PTC_V2_RESISTANCE = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_PTC_V2_RESISTANCE.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_PTC_V2_SENSOR_CONNECTED = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_PTC_V2_SENSOR_CONNECTED.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_PTC_V2 = URI
            .create("thing-type:" + THING_TYPE_BRICKLET_PTC_V2.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_REAL_TIME_CLOCK_DATE_TIME = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_REAL_TIME_CLOCK_DATE_TIME.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_REAL_TIME_CLOCK_TIMESTAMP = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_REAL_TIME_CLOCK_TIMESTAMP.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_REAL_TIME_CLOCK = URI
            .create("thing-type:" + THING_TYPE_BRICKLET_REAL_TIME_CLOCK.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_REAL_TIME_CLOCK_V2_DATE_TIME = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_REAL_TIME_CLOCK_V2_DATE_TIME.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_REAL_TIME_CLOCK_V2_TIMESTAMP = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_REAL_TIME_CLOCK_V2_TIMESTAMP.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_REAL_TIME_CLOCK_V2 = URI
            .create("thing-type:" + THING_TYPE_BRICKLET_REAL_TIME_CLOCK_V2.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_REMOTE_SWITCH = URI
            .create("thing-type:" + THING_TYPE_BRICKLET_REMOTE_SWITCH.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_REMOTE_SWITCH_V2 = URI
            .create("thing-type:" + THING_TYPE_BRICKLET_REMOTE_SWITCH_V2.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_RGB_LED_BUTTON_COLOR = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_RGB_LED_BUTTON_COLOR.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_RGB_LED_BUTTON = URI
            .create("thing-type:" + THING_TYPE_BRICKLET_RGB_LED_BUTTON.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_RGB_LED_COLOR = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_RGB_LED_COLOR.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_RGB_LED = URI
            .create("thing-type:" + THING_TYPE_BRICKLET_RGB_LED.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_RGB_LED_MATRIX_LED_VALUES = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_RGB_LED_MATRIX_LED_VALUES.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_RGB_LED_MATRIX = URI
            .create("thing-type:" + THING_TYPE_BRICKLET_RGB_LED_MATRIX.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_RGB_LED_V2_COLOR = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_RGB_LED_V2_COLOR.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_RGB_LED_V2 = URI
            .create("thing-type:" + THING_TYPE_BRICKLET_RGB_LED_V2.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_ROTARY_ENCODER_COUNT = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_ROTARY_ENCODER_COUNT.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_ROTARY_ENCODER_RESET_COUNTER = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_ROTARY_ENCODER_RESET_COUNTER.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_ROTARY_ENCODER = URI
            .create("thing-type:" + THING_TYPE_BRICKLET_ROTARY_ENCODER.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_ROTARY_ENCODER_V2_COUNT = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_ROTARY_ENCODER_V2_COUNT.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_ROTARY_ENCODER_V2_RESET_COUNTER = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_ROTARY_ENCODER_V2_RESET_COUNTER.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_ROTARY_ENCODER_V2 = URI
            .create("thing-type:" + THING_TYPE_BRICKLET_ROTARY_ENCODER_V2.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_ROTARY_POTI_POSITION = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_ROTARY_POTI_POSITION.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_ROTARY_POTI_ANALOG_VALUE = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_ROTARY_POTI_ANALOG_VALUE.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_ROTARY_POTI = URI
            .create("thing-type:" + THING_TYPE_BRICKLET_ROTARY_POTI.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_ROTARY_POTI_V2_POSITION = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_ROTARY_POTI_V2_POSITION.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_ROTARY_POTI_V2 = URI
            .create("thing-type:" + THING_TYPE_BRICKLET_ROTARY_POTI_V2.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_RS232 = URI
            .create("thing-type:" + THING_TYPE_BRICKLET_RS232.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_RS232_V2_OVERRUN_ERROR_COUNT = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_RS232_V2_OVERRUN_ERROR_COUNT.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_RS232_V2_PARITY_ERROR_COUNT = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_RS232_V2_PARITY_ERROR_COUNT.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_RS232_V2_SEND_BUFFER_USED = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_RS232_V2_SEND_BUFFER_USED.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_RS232_V2_RECEIVE_BUFFER_USED = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_RS232_V2_RECEIVE_BUFFER_USED.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_RS232_V2 = URI
            .create("thing-type:" + THING_TYPE_BRICKLET_RS232_V2.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_RS485_OVERRUN_ERROR_COUNT = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_RS485_OVERRUN_ERROR_COUNT.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_RS485_PARITY_ERROR_COUNT = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_RS485_PARITY_ERROR_COUNT.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_RS485_MODBUS_ERROR = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_RS485_MODBUS_ERROR.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_RS485_SEND_BUFFER_USED = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_RS485_SEND_BUFFER_USED.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_RS485_RECEIVE_BUFFER_USED = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_RS485_RECEIVE_BUFFER_USED.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_RS485 = URI
            .create("thing-type:" + THING_TYPE_BRICKLET_RS485.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_SEGMENT_DISPLAY_4X7_BRIGHTNESS = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_SEGMENT_DISPLAY_4X7_BRIGHTNESS.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_SEGMENT_DISPLAY_4X7_SEGMENTS = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_SEGMENT_DISPLAY_4X7_SEGMENTS.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_SEGMENT_DISPLAY_4X7_COLON = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_SEGMENT_DISPLAY_4X7_COLON.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_SEGMENT_DISPLAY_4X7_TEXT = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_SEGMENT_DISPLAY_4X7_TEXT.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_SEGMENT_DISPLAY_4X7 = URI
            .create("thing-type:" + THING_TYPE_BRICKLET_SEGMENT_DISPLAY_4X7.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_SEGMENT_DISPLAY_4X7_V2_BRIGHTNESS = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_SEGMENT_DISPLAY_4X7_V2_BRIGHTNESS.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_SEGMENT_DISPLAY_4X7_V2_SEGMENTS = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_SEGMENT_DISPLAY_4X7_V2_SEGMENTS.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_SEGMENT_DISPLAY_4X7_V2_COLON_UPPER = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_SEGMENT_DISPLAY_4X7_V2_COLON_UPPER.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_SEGMENT_DISPLAY_4X7_V2_COLON_LOWER = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_SEGMENT_DISPLAY_4X7_V2_COLON_LOWER.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_SEGMENT_DISPLAY_4X7_V2_TICK = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_SEGMENT_DISPLAY_4X7_V2_TICK.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_SEGMENT_DISPLAY_4X7_V2_TEXT = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_SEGMENT_DISPLAY_4X7_V2_TEXT.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_SEGMENT_DISPLAY_4X7_V2 = URI
            .create("thing-type:" + THING_TYPE_BRICKLET_SEGMENT_DISPLAY_4X7_V2.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_SOLID_STATE_RELAY_RELAY = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_SOLID_STATE_RELAY_RELAY.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_SOLID_STATE_RELAY_MONOFLOP = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_SOLID_STATE_RELAY_MONOFLOP.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_SOLID_STATE_RELAY = URI
            .create("thing-type:" + THING_TYPE_BRICKLET_SOLID_STATE_RELAY.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_SOLID_STATE_RELAY_V2_RELAY = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_SOLID_STATE_RELAY_V2_RELAY.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_SOLID_STATE_RELAY_V2_MONOFLOP = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_SOLID_STATE_RELAY_V2_MONOFLOP.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_SOLID_STATE_RELAY_V2 = URI
            .create("thing-type:" + THING_TYPE_BRICKLET_SOLID_STATE_RELAY_V2.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_SOUND_INTENSITY_INTENSITY = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_SOUND_INTENSITY_INTENSITY.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_SOUND_INTENSITY = URI
            .create("thing-type:" + THING_TYPE_BRICKLET_SOUND_INTENSITY.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_SOUND_PRESSURE_LEVEL_DECIBEL = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_SOUND_PRESSURE_LEVEL_DECIBEL.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_SOUND_PRESSURE_LEVEL = URI
            .create("thing-type:" + THING_TYPE_BRICKLET_SOUND_PRESSURE_LEVEL.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_TEMPERATURE_TEMPERATURE = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_TEMPERATURE_TEMPERATURE.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_TEMPERATURE = URI
            .create("thing-type:" + THING_TYPE_BRICKLET_TEMPERATURE.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_TEMPERATURE_IR_AMBIENT_TEMPERATURE = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_TEMPERATURE_IR_AMBIENT_TEMPERATURE.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_TEMPERATURE_IR_OBJECT_TEMPERATURE = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_TEMPERATURE_IR_OBJECT_TEMPERATURE.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_TEMPERATURE_IR = URI
            .create("thing-type:" + THING_TYPE_BRICKLET_TEMPERATURE_IR.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_TEMPERATURE_IR_V2_AMBIENT_TEMPERATURE = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_TEMPERATURE_IR_V2_AMBIENT_TEMPERATURE.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_TEMPERATURE_IR_V2_OBJECT_TEMPERATURE = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_TEMPERATURE_IR_V2_OBJECT_TEMPERATURE.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_TEMPERATURE_IR_V2 = URI
            .create("thing-type:" + THING_TYPE_BRICKLET_TEMPERATURE_IR_V2.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_TEMPERATURE_V2_TEMPERATURE = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_TEMPERATURE_V2_TEMPERATURE.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_TEMPERATURE_V2_HEATER = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_TEMPERATURE_V2_HEATER.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_TEMPERATURE_V2 = URI
            .create("thing-type:" + THING_TYPE_BRICKLET_TEMPERATURE_V2.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_THERMAL_IMAGING_HIGH_CONTRAST_IMAGE = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_THERMAL_IMAGING_HIGH_CONTRAST_IMAGE.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_THERMAL_IMAGING_TEMPERATURE_IMAGE = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_THERMAL_IMAGING_TEMPERATURE_IMAGE.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_THERMAL_IMAGING_TEMPERATURE = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_THERMAL_IMAGING_TEMPERATURE.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_THERMAL_IMAGING_SPOTMETER_ROI_PIXEL_COUNT = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_THERMAL_IMAGING_SPOTMETER_ROI_PIXEL_COUNT.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_THERMAL_IMAGING_FFC_STATUS = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_THERMAL_IMAGING_FFC_STATUS.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_THERMAL_IMAGING_SHUTTER_LOCKOUT = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_THERMAL_IMAGING_SHUTTER_LOCKOUT.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_THERMAL_IMAGING_OVERTEMPERATURE_SHUTDOWN_IMMINENT = URI
            .create("channel-type:"
                    + CHANNEL_TYPE_BRICKLET_THERMAL_IMAGING_OVERTEMPERATURE_SHUTDOWN_IMMINENT.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_THERMAL_IMAGING = URI
            .create("thing-type:" + THING_TYPE_BRICKLET_THERMAL_IMAGING.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_THERMOCOUPLE_TEMPERATURE = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_THERMOCOUPLE_TEMPERATURE.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_THERMOCOUPLE_OVER_UNDER_VOLTAGE = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_THERMOCOUPLE_OVER_UNDER_VOLTAGE.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_THERMOCOUPLE_OPEN_CIRCUIT = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_THERMOCOUPLE_OPEN_CIRCUIT.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_THERMOCOUPLE = URI
            .create("thing-type:" + THING_TYPE_BRICKLET_THERMOCOUPLE.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_THERMOCOUPLE_V2_TEMPERATURE = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_THERMOCOUPLE_V2_TEMPERATURE.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_THERMOCOUPLE_V2_OVER_UNDER_VOLTAGE = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_THERMOCOUPLE_V2_OVER_UNDER_VOLTAGE.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_THERMOCOUPLE_V2_OPEN_CIRCUIT = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_THERMOCOUPLE_V2_OPEN_CIRCUIT.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_THERMOCOUPLE_V2 = URI
            .create("thing-type:" + THING_TYPE_BRICKLET_THERMOCOUPLE_V2.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_TILT_TILTED = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_TILT_TILTED.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_TILT_VIBRATING = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_TILT_VIBRATING.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_TILT = URI
            .create("thing-type:" + THING_TYPE_BRICKLET_TILT.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_UV_LIGHT_UV_LIGHT = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_UV_LIGHT_UV_LIGHT.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_UV_LIGHT = URI
            .create("thing-type:" + THING_TYPE_BRICKLET_UV_LIGHT.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_UV_LIGHT_V2_UVA = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_UV_LIGHT_V2_UVA.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_UV_LIGHT_V2_UVB = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_UV_LIGHT_V2_UVB.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_UV_LIGHT_V2_UVI = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_UV_LIGHT_V2_UVI.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_UV_LIGHT_V2 = URI
            .create("thing-type:" + THING_TYPE_BRICKLET_UV_LIGHT_V2.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_VOLTAGE_VOLTAGE = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_VOLTAGE_VOLTAGE.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_VOLTAGE_ANALOG_VALUE = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_VOLTAGE_ANALOG_VALUE.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_VOLTAGE = URI
            .create("thing-type:" + THING_TYPE_BRICKLET_VOLTAGE.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_VOLTAGE_CURRENT_VOLTAGE = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_VOLTAGE_CURRENT_VOLTAGE.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_VOLTAGE_CURRENT_CURRENT = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_VOLTAGE_CURRENT_CURRENT.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_VOLTAGE_CURRENT_POWER = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_VOLTAGE_CURRENT_POWER.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_VOLTAGE_CURRENT = URI
            .create("thing-type:" + THING_TYPE_BRICKLET_VOLTAGE_CURRENT.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_VOLTAGE_CURRENT_V2_VOLTAGE = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_VOLTAGE_CURRENT_V2_VOLTAGE.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_VOLTAGE_CURRENT_V2_CURRENT = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_VOLTAGE_CURRENT_V2_CURRENT.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_VOLTAGE_CURRENT_V2_POWER = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_VOLTAGE_CURRENT_V2_POWER.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_VOLTAGE_CURRENT_V2 = URI
            .create("thing-type:" + THING_TYPE_BRICKLET_VOLTAGE_CURRENT_V2.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_XMC1400_BREAKOUT_COUNT = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_XMC1400_BREAKOUT_COUNT.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_XMC1400_BREAKOUT_ADC_VALUE = URI
            .create("channel-type:" + CHANNEL_TYPE_BRICKLET_XMC1400_BREAKOUT_ADC_VALUE.toString());
    public static final URI CONFIG_DESCRIPTION_URI_BRICKLET_XMC1400_BREAKOUT = URI
            .create("thing-type:" + THING_TYPE_BRICKLET_XMC1400_BREAKOUT.toString());
    public static final URI CONFIG_DESCRIPTION_URI_OUTDOOR_WEATHER_SENSOR = URI
            .create("thing-type:" + THING_TYPE_OUTDOOR_WEATHER_SENSOR.toString());
    public static final URI CONFIG_DESCRIPTION_URI_OUTDOOR_WEATHER_SENSOR_TEMPERATURE = URI
            .create("channel-type:" + CHANNEL_TYPE_OUTDOOR_WEATHER_SENSOR_TEMPERATURE.toString());
    public static final URI CONFIG_DESCRIPTION_URI_OUTDOOR_WEATHER_SENSOR_HUMIDITY = URI
            .create("channel-type:" + CHANNEL_TYPE_OUTDOOR_WEATHER_SENSOR_HUMIDITY.toString());
    public static final URI CONFIG_DESCRIPTION_URI_OUTDOOR_WEATHER_SENSOR_LAST_CHANGE = URI
            .create("channel-type:" + CHANNEL_TYPE_OUTDOOR_WEATHER_SENSOR_LAST_CHANGE.toString());
    public static final URI CONFIG_DESCRIPTION_URI_OUTDOOR_WEATHER_STATION = URI
            .create("thing-type:" + THING_TYPE_OUTDOOR_WEATHER_STATION.toString());
    public static final URI CONFIG_DESCRIPTION_URI_OUTDOOR_WEATHER_STATION_TEMPERATURE = URI
            .create("channel-type:" + CHANNEL_TYPE_OUTDOOR_WEATHER_STATION_TEMPERATURE.toString());
    public static final URI CONFIG_DESCRIPTION_URI_OUTDOOR_WEATHER_STATION_HUMIDITY = URI
            .create("channel-type:" + CHANNEL_TYPE_OUTDOOR_WEATHER_STATION_HUMIDITY.toString());
    public static final URI CONFIG_DESCRIPTION_URI_OUTDOOR_WEATHER_STATION_WIND_SPEED = URI
            .create("channel-type:" + CHANNEL_TYPE_OUTDOOR_WEATHER_STATION_WIND_SPEED.toString());
    public static final URI CONFIG_DESCRIPTION_URI_OUTDOOR_WEATHER_STATION_GUST_SPEED = URI
            .create("channel-type:" + CHANNEL_TYPE_OUTDOOR_WEATHER_STATION_GUST_SPEED.toString());
    public static final URI CONFIG_DESCRIPTION_URI_OUTDOOR_WEATHER_STATION_RAIN_FALL = URI
            .create("channel-type:" + CHANNEL_TYPE_OUTDOOR_WEATHER_STATION_RAIN_FALL.toString());
    public static final URI CONFIG_DESCRIPTION_URI_OUTDOOR_WEATHER_STATION_WIND_DIRECTION = URI
            .create("channel-type:" + CHANNEL_TYPE_OUTDOOR_WEATHER_STATION_WIND_DIRECTION.toString());
    public static final URI CONFIG_DESCRIPTION_URI_OUTDOOR_WEATHER_STATION_BATTERY_LOW = URI
            .create("channel-type:" + CHANNEL_TYPE_OUTDOOR_WEATHER_STATION_BATTERY_LOW.toString());
    public static final URI CONFIG_DESCRIPTION_URI_OUTDOOR_WEATHER_STATION_LAST_CHANGE = URI
            .create("channel-type:" + CHANNEL_TYPE_OUTDOOR_WEATHER_STATION_LAST_CHANGE.toString());
    public static final URI CONFIG_DESCRIPTION_URI_REMOTE_SOCKET_TYPE_A = URI
            .create("thing-type:" + THING_TYPE_REMOTE_SOCKET_TYPE_A.toString());
    public static final URI CONFIG_DESCRIPTION_URI_REMOTE_SOCKET_TYPE_A_COMMAND = URI
            .create("channel-type:" + CHANNEL_TYPE_REMOTE_SOCKET_TYPE_A_COMMAND.toString());
    public static final URI CONFIG_DESCRIPTION_URI_REMOTE_SOCKET_TYPE_B = URI
            .create("thing-type:" + THING_TYPE_REMOTE_SOCKET_TYPE_B.toString());
    public static final URI CONFIG_DESCRIPTION_URI_REMOTE_SOCKET_TYPE_B_COMMAND = URI
            .create("channel-type:" + CHANNEL_TYPE_REMOTE_SOCKET_TYPE_B_COMMAND.toString());
    public static final URI CONFIG_DESCRIPTION_URI_REMOTE_SOCKET_TYPE_C = URI
            .create("thing-type:" + THING_TYPE_REMOTE_SOCKET_TYPE_C.toString());
    public static final URI CONFIG_DESCRIPTION_URI_REMOTE_SOCKET_TYPE_C_COMMAND = URI
            .create("channel-type:" + CHANNEL_TYPE_REMOTE_SOCKET_TYPE_C_COMMAND.toString());
    public static final URI CONFIG_DESCRIPTION_URI_REMOTE_DIMMER_TYPE_B = URI
            .create("thing-type:" + THING_TYPE_REMOTE_DIMMER_TYPE_B.toString());
    public static final URI CONFIG_DESCRIPTION_URI_REMOTE_DIMMER_TYPE_B_VALUE = URI
            .create("channel-type:" + CHANNEL_TYPE_REMOTE_DIMMER_TYPE_B_VALUE.toString());

    public static final Map<URI, ThingTypeUID> SUPPORTED_CONFIG_DESCRIPTIONS;

    static {
        SUPPORTED_CONFIG_DESCRIPTIONS = new HashMap<>();
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICK_DAEMON, THING_TYPE_BRICK_DAEMON);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICK_DC_CURRENT_VELOCITY, THING_TYPE_BRICK_DC);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICK_DC, THING_TYPE_BRICK_DC);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICK_HAT_USB_VOLTAGE, THING_TYPE_BRICK_HAT);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICK_HAT_DC_VOLTAGE, THING_TYPE_BRICK_HAT);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICK_HAT_POWER_BRICKLETS, THING_TYPE_BRICK_HAT);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICK_HAT_SLEEP, THING_TYPE_BRICK_HAT);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICK_HAT, THING_TYPE_BRICK_HAT);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICK_HAT_ZERO_USB_VOLTAGE, THING_TYPE_BRICK_HAT_ZERO);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICK_HAT_ZERO, THING_TYPE_BRICK_HAT_ZERO);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICK_IMU_ORIENTATION, THING_TYPE_BRICK_IMU);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICK_IMU_QUATERNION, THING_TYPE_BRICK_IMU);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICK_IMU_ACCELERATION, THING_TYPE_BRICK_IMU);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICK_IMU_MAGNETIC_FIELD, THING_TYPE_BRICK_IMU);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICK_IMU_ANGULAR_VELOCITY, THING_TYPE_BRICK_IMU);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICK_IMU_ENABLE_LEDS, THING_TYPE_BRICK_IMU);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICK_IMU, THING_TYPE_BRICK_IMU);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICK_IMU_V2_ACCELERATION, THING_TYPE_BRICK_IMU_V2);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICK_IMU_V2_MAGNETIC_FIELD, THING_TYPE_BRICK_IMU_V2);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICK_IMU_V2_ANGULAR_VELOCITY,
                THING_TYPE_BRICK_IMU_V2);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICK_IMU_V2_ORIENTATION, THING_TYPE_BRICK_IMU_V2);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICK_IMU_V2_QUATERNION, THING_TYPE_BRICK_IMU_V2);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICK_IMU_V2_LINEAR_ACCELERATION,
                THING_TYPE_BRICK_IMU_V2);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICK_IMU_V2_GRAVITY_VECTOR, THING_TYPE_BRICK_IMU_V2);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICK_IMU_V2_TEMPERATURE, THING_TYPE_BRICK_IMU_V2);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICK_IMU_V2_ENABLE_LEDS, THING_TYPE_BRICK_IMU_V2);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICK_IMU_V2, THING_TYPE_BRICK_IMU_V2);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICK_MASTER_STACK_VOLTAGE, THING_TYPE_BRICK_MASTER);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICK_MASTER_USB_VOLTAGE, THING_TYPE_BRICK_MASTER);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICK_MASTER_STACK_CURRENT, THING_TYPE_BRICK_MASTER);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICK_MASTER_BRICKLETS_ENABLED,
                THING_TYPE_BRICK_MASTER);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICK_MASTER, THING_TYPE_BRICK_MASTER);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICK_RED, THING_TYPE_BRICK_RED);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICK_SERVO, THING_TYPE_BRICK_SERVO);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICK_SILENT_STEPPER_CURRENT_VELOCITY,
                THING_TYPE_BRICK_SILENT_STEPPER);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICK_SILENT_STEPPER_CURRENT_POSITION,
                THING_TYPE_BRICK_SILENT_STEPPER);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICK_SILENT_STEPPER_REMAINING_STEPS,
                THING_TYPE_BRICK_SILENT_STEPPER);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICK_SILENT_STEPPER_STACK_VOLTAGE,
                THING_TYPE_BRICK_SILENT_STEPPER);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICK_SILENT_STEPPER_EXTERNAL_VOLTAGE,
                THING_TYPE_BRICK_SILENT_STEPPER);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICK_SILENT_STEPPER_CURRENT_CONSUMPTION,
                THING_TYPE_BRICK_SILENT_STEPPER);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICK_SILENT_STEPPER_STATE,
                THING_TYPE_BRICK_SILENT_STEPPER);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICK_SILENT_STEPPER, THING_TYPE_BRICK_SILENT_STEPPER);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICK_STEPPER_CURRENT_VELOCITY,
                THING_TYPE_BRICK_STEPPER);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICK_STEPPER_CURRENT_POSITION,
                THING_TYPE_BRICK_STEPPER);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICK_STEPPER_REMAINING_STEPS,
                THING_TYPE_BRICK_STEPPER);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICK_STEPPER_STACK_VOLTAGE, THING_TYPE_BRICK_STEPPER);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICK_STEPPER_EXTERNAL_VOLTAGE,
                THING_TYPE_BRICK_STEPPER);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICK_STEPPER_CURRENT_CONSUMPTION,
                THING_TYPE_BRICK_STEPPER);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICK_STEPPER_STATE, THING_TYPE_BRICK_STEPPER);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICK_STEPPER, THING_TYPE_BRICK_STEPPER);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_ACCELEROMETER_ACCELERATION,
                THING_TYPE_BRICKLET_ACCELEROMETER);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_ACCELEROMETER_LED,
                THING_TYPE_BRICKLET_ACCELEROMETER);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_ACCELEROMETER_TEMPERATURE,
                THING_TYPE_BRICKLET_ACCELEROMETER);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_ACCELEROMETER,
                THING_TYPE_BRICKLET_ACCELEROMETER);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_ACCELEROMETER_V2_ACCELERATION,
                THING_TYPE_BRICKLET_ACCELEROMETER_V2);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_ACCELEROMETER_V2,
                THING_TYPE_BRICKLET_ACCELEROMETER_V2);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_AIR_QUALITY_HUMIDITY,
                THING_TYPE_BRICKLET_AIR_QUALITY);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_AIR_QUALITY_TEMPERATURE,
                THING_TYPE_BRICKLET_AIR_QUALITY);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_AIR_QUALITY_AIR_PRESSURE,
                THING_TYPE_BRICKLET_AIR_QUALITY);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_AIR_QUALITY_IAQ_INDEX,
                THING_TYPE_BRICKLET_AIR_QUALITY);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_AIR_QUALITY_IAQ_INDEX_ACCURACY,
                THING_TYPE_BRICKLET_AIR_QUALITY);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_AIR_QUALITY, THING_TYPE_BRICKLET_AIR_QUALITY);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_AMBIENT_LIGHT_ILLUMINANCE,
                THING_TYPE_BRICKLET_AMBIENT_LIGHT);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_AMBIENT_LIGHT_ANALOG_VALUE,
                THING_TYPE_BRICKLET_AMBIENT_LIGHT);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_AMBIENT_LIGHT,
                THING_TYPE_BRICKLET_AMBIENT_LIGHT);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_AMBIENT_LIGHT_V2_ILLUMINANCE,
                THING_TYPE_BRICKLET_AMBIENT_LIGHT_V2);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_AMBIENT_LIGHT_V2,
                THING_TYPE_BRICKLET_AMBIENT_LIGHT_V2);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_AMBIENT_LIGHT_V3_ILLUMINANCE,
                THING_TYPE_BRICKLET_AMBIENT_LIGHT_V3);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_AMBIENT_LIGHT_V3,
                THING_TYPE_BRICKLET_AMBIENT_LIGHT_V3);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_ANALOG_IN_VOLTAGE,
                THING_TYPE_BRICKLET_ANALOG_IN);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_ANALOG_IN_ANALOG_VALUE,
                THING_TYPE_BRICKLET_ANALOG_IN);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_ANALOG_IN, THING_TYPE_BRICKLET_ANALOG_IN);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_ANALOG_IN_V2_VOLTAGE,
                THING_TYPE_BRICKLET_ANALOG_IN_V2);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_ANALOG_IN_V2_ANALOG_VALUE,
                THING_TYPE_BRICKLET_ANALOG_IN_V2);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_ANALOG_IN_V2,
                THING_TYPE_BRICKLET_ANALOG_IN_V2);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_ANALOG_IN_V3_VOLTAGE,
                THING_TYPE_BRICKLET_ANALOG_IN_V3);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_ANALOG_IN_V3,
                THING_TYPE_BRICKLET_ANALOG_IN_V3);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_ANALOG_OUT_VOLTAGE,
                THING_TYPE_BRICKLET_ANALOG_OUT);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_ANALOG_OUT_MODE,
                THING_TYPE_BRICKLET_ANALOG_OUT);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_ANALOG_OUT, THING_TYPE_BRICKLET_ANALOG_OUT);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_ANALOG_OUT_V2_INPUT_VOLTAGE,
                THING_TYPE_BRICKLET_ANALOG_OUT_V2);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_ANALOG_OUT_V2_OUTPUT_VOLTAGE,
                THING_TYPE_BRICKLET_ANALOG_OUT_V2);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_ANALOG_OUT_V2,
                THING_TYPE_BRICKLET_ANALOG_OUT_V2);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_ANALOG_OUT_V3_INPUT_VOLTAGE,
                THING_TYPE_BRICKLET_ANALOG_OUT_V3);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_ANALOG_OUT_V3_OUTPUT_VOLTAGE,
                THING_TYPE_BRICKLET_ANALOG_OUT_V3);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_ANALOG_OUT_V3,
                THING_TYPE_BRICKLET_ANALOG_OUT_V3);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_BAROMETER_AIR_PRESSURE,
                THING_TYPE_BRICKLET_BAROMETER);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_BAROMETER_ALTITUDE,
                THING_TYPE_BRICKLET_BAROMETER);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_BAROMETER, THING_TYPE_BRICKLET_BAROMETER);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_BAROMETER_V2_AIR_PRESSURE,
                THING_TYPE_BRICKLET_BAROMETER_V2);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_BAROMETER_V2_ALTITUDE,
                THING_TYPE_BRICKLET_BAROMETER_V2);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_BAROMETER_V2_TEMPERATURE,
                THING_TYPE_BRICKLET_BAROMETER_V2);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_BAROMETER_V2,
                THING_TYPE_BRICKLET_BAROMETER_V2);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_CAN_WRITE_ERROR_LEVEL,
                THING_TYPE_BRICKLET_CAN);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_CAN_READ_ERROR_LEVEL,
                THING_TYPE_BRICKLET_CAN);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_CAN_TRANSCEIVER_DISABLED,
                THING_TYPE_BRICKLET_CAN);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_CAN_WRITE_TIMEOUT_COUNT,
                THING_TYPE_BRICKLET_CAN);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_CAN_READ_REGISTER_OVERFLOW_COUNT,
                THING_TYPE_BRICKLET_CAN);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_CAN_READ_BUFFER_OVERFLOW_COUNT,
                THING_TYPE_BRICKLET_CAN);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_CAN, THING_TYPE_BRICKLET_CAN);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_CAN_V2, THING_TYPE_BRICKLET_CAN_V2);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_CO2_CO2_CONCENTRATION,
                THING_TYPE_BRICKLET_CO2);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_CO2, THING_TYPE_BRICKLET_CO2);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_CO2_V2_CO2_CONCENTRATION,
                THING_TYPE_BRICKLET_CO2_V2);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_CO2_V2_TEMPERATURE,
                THING_TYPE_BRICKLET_CO2_V2);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_CO2_V2_HUMIDITY, THING_TYPE_BRICKLET_CO2_V2);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_CO2_V2_AIR_PRESSURE,
                THING_TYPE_BRICKLET_CO2_V2);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_CO2_V2, THING_TYPE_BRICKLET_CO2_V2);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_COLOR_COLOR, THING_TYPE_BRICKLET_COLOR);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_COLOR_ILLUMINANCE, THING_TYPE_BRICKLET_COLOR);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_COLOR_COLOR_TEMPERATURE,
                THING_TYPE_BRICKLET_COLOR);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_COLOR_LIGHT, THING_TYPE_BRICKLET_COLOR);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_COLOR, THING_TYPE_BRICKLET_COLOR);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_COLOR_V2_COLOR, THING_TYPE_BRICKLET_COLOR_V2);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_COLOR_V2_ILLUMINANCE,
                THING_TYPE_BRICKLET_COLOR_V2);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_COLOR_V2_COLOR_TEMPERATURE,
                THING_TYPE_BRICKLET_COLOR_V2);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_COLOR_V2_LIGHT, THING_TYPE_BRICKLET_COLOR_V2);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_COLOR_V2, THING_TYPE_BRICKLET_COLOR_V2);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_COMPASS_HEADING, THING_TYPE_BRICKLET_COMPASS);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_COMPASS_MAGNETIC_FLUX_DENSITY,
                THING_TYPE_BRICKLET_COMPASS);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_COMPASS, THING_TYPE_BRICKLET_COMPASS);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_CURRENT12_CURRENT,
                THING_TYPE_BRICKLET_CURRENT12);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_CURRENT12_OVER_CURRENT,
                THING_TYPE_BRICKLET_CURRENT12);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_CURRENT12_ANALOG_VALUE,
                THING_TYPE_BRICKLET_CURRENT12);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_CURRENT12, THING_TYPE_BRICKLET_CURRENT12);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_CURRENT25_CURRENT,
                THING_TYPE_BRICKLET_CURRENT25);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_CURRENT25_OVER_CURRENT,
                THING_TYPE_BRICKLET_CURRENT25);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_CURRENT25_ANALOG_VALUE,
                THING_TYPE_BRICKLET_CURRENT25);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_CURRENT25, THING_TYPE_BRICKLET_CURRENT25);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_DISTANCE_IR_DISTANCE,
                THING_TYPE_BRICKLET_DISTANCE_IR);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_DISTANCE_IR_ANALOG_VALUE,
                THING_TYPE_BRICKLET_DISTANCE_IR);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_DISTANCE_IR, THING_TYPE_BRICKLET_DISTANCE_IR);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_DISTANCE_IR_V2_DISTANCE,
                THING_TYPE_BRICKLET_DISTANCE_IR_V2);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_DISTANCE_IR_V2_ANALOG_VALUE,
                THING_TYPE_BRICKLET_DISTANCE_IR_V2);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_DISTANCE_IR_V2,
                THING_TYPE_BRICKLET_DISTANCE_IR_V2);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_DISTANCE_US_DISTANCE,
                THING_TYPE_BRICKLET_DISTANCE_US);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_DISTANCE_US, THING_TYPE_BRICKLET_DISTANCE_US);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_DISTANCE_US_V2_DISTANCE,
                THING_TYPE_BRICKLET_DISTANCE_US_V2);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_DISTANCE_US_V2,
                THING_TYPE_BRICKLET_DISTANCE_US_V2);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_DMX_OVERRUN_ERROR_COUNT,
                THING_TYPE_BRICKLET_DMX);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_DMX_FRAMING_ERROR_COUNT,
                THING_TYPE_BRICKLET_DMX);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_DMX, THING_TYPE_BRICKLET_DMX);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_DUAL_BUTTON_LEFT_LED,
                THING_TYPE_BRICKLET_DUAL_BUTTON);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_DUAL_BUTTON_RIGHT_LED,
                THING_TYPE_BRICKLET_DUAL_BUTTON);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_DUAL_BUTTON, THING_TYPE_BRICKLET_DUAL_BUTTON);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_DUAL_BUTTON_V2_LEFT_LED,
                THING_TYPE_BRICKLET_DUAL_BUTTON_V2);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_DUAL_BUTTON_V2_RIGHT_LED,
                THING_TYPE_BRICKLET_DUAL_BUTTON_V2);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_DUAL_BUTTON_V2,
                THING_TYPE_BRICKLET_DUAL_BUTTON_V2);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_DUAL_RELAY_RELAY,
                THING_TYPE_BRICKLET_DUAL_RELAY);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_DUAL_RELAY_MONOFLOP,
                THING_TYPE_BRICKLET_DUAL_RELAY);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_DUAL_RELAY, THING_TYPE_BRICKLET_DUAL_RELAY);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_DUST_DETECTOR_DUST_DENSITY,
                THING_TYPE_BRICKLET_DUST_DETECTOR);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_DUST_DETECTOR,
                THING_TYPE_BRICKLET_DUST_DETECTOR);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_E_PAPER_296X128_DRAW_STATUS,
                THING_TYPE_BRICKLET_E_PAPER_296X128);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_E_PAPER_296X128,
                THING_TYPE_BRICKLET_E_PAPER_296X128);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_ENERGY_MONITOR_VOLTAGE,
                THING_TYPE_BRICKLET_ENERGY_MONITOR);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_ENERGY_MONITOR_CURRENT,
                THING_TYPE_BRICKLET_ENERGY_MONITOR);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_ENERGY_MONITOR_ENERGY,
                THING_TYPE_BRICKLET_ENERGY_MONITOR);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_ENERGY_MONITOR_REALPOWER,
                THING_TYPE_BRICKLET_ENERGY_MONITOR);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_ENERGY_MONITOR_APPPOWER,
                THING_TYPE_BRICKLET_ENERGY_MONITOR);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_ENERGY_MONITOR_REACPOWER,
                THING_TYPE_BRICKLET_ENERGY_MONITOR);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_ENERGY_MONITOR_FACTOR,
                THING_TYPE_BRICKLET_ENERGY_MONITOR);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_ENERGY_MONITOR_FREQUENCY,
                THING_TYPE_BRICKLET_ENERGY_MONITOR);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_ENERGY_MONITOR_RESET,
                THING_TYPE_BRICKLET_ENERGY_MONITOR);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_ENERGY_MONITOR,
                THING_TYPE_BRICKLET_ENERGY_MONITOR);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_GPS_COORDINATES, THING_TYPE_BRICKLET_GPS);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_GPS_FIX, THING_TYPE_BRICKLET_GPS);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_GPS_SATELLITES_IN_VIEW,
                THING_TYPE_BRICKLET_GPS);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_GPS_SATELLITES_USED, THING_TYPE_BRICKLET_GPS);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_GPS_ALTITUDE, THING_TYPE_BRICKLET_GPS);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_GPS_GEOIDAL_SEPARATION,
                THING_TYPE_BRICKLET_GPS);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_GPS_COURSE, THING_TYPE_BRICKLET_GPS);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_GPS_SPEED, THING_TYPE_BRICKLET_GPS);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_GPS_DATE_TIME, THING_TYPE_BRICKLET_GPS);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_GPS_RESTART, THING_TYPE_BRICKLET_GPS);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_GPS, THING_TYPE_BRICKLET_GPS);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_GPS_V2_COORDINATES,
                THING_TYPE_BRICKLET_GPS_V2);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_GPS_V2_FIX, THING_TYPE_BRICKLET_GPS_V2);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_GPS_V2_SATELLITES_IN_VIEW,
                THING_TYPE_BRICKLET_GPS_V2);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_GPS_V2_ALTITUDE, THING_TYPE_BRICKLET_GPS_V2);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_GPS_V2_GEOIDAL_SEPARATION,
                THING_TYPE_BRICKLET_GPS_V2);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_GPS_V2_COURSE, THING_TYPE_BRICKLET_GPS_V2);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_GPS_V2_SPEED, THING_TYPE_BRICKLET_GPS_V2);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_GPS_V2_DATE_TIME, THING_TYPE_BRICKLET_GPS_V2);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_GPS_V2_RESTART, THING_TYPE_BRICKLET_GPS_V2);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_GPS_V2, THING_TYPE_BRICKLET_GPS_V2);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_HALL_EFFECT_EDGE_COUNT,
                THING_TYPE_BRICKLET_HALL_EFFECT);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_HALL_EFFECT_MAGNETIC_FIELD_DETECTED,
                THING_TYPE_BRICKLET_HALL_EFFECT);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_HALL_EFFECT, THING_TYPE_BRICKLET_HALL_EFFECT);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_HALL_EFFECT_V2_COUNTER,
                THING_TYPE_BRICKLET_HALL_EFFECT_V2);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_HALL_EFFECT_V2_MAGNETIC_FLUX_DENSITY,
                THING_TYPE_BRICKLET_HALL_EFFECT_V2);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_HALL_EFFECT_V2,
                THING_TYPE_BRICKLET_HALL_EFFECT_V2);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_HUMIDITY_HUMIDITY,
                THING_TYPE_BRICKLET_HUMIDITY);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_HUMIDITY_ANALOG_VALUE,
                THING_TYPE_BRICKLET_HUMIDITY);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_HUMIDITY, THING_TYPE_BRICKLET_HUMIDITY);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_HUMIDITY_V2_HUMIDITY,
                THING_TYPE_BRICKLET_HUMIDITY_V2);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_HUMIDITY_V2_TEMPERATURE,
                THING_TYPE_BRICKLET_HUMIDITY_V2);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_HUMIDITY_V2_HEATER,
                THING_TYPE_BRICKLET_HUMIDITY_V2);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_HUMIDITY_V2, THING_TYPE_BRICKLET_HUMIDITY_V2);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_INDUSTRIAL_ANALOG_OUT_ENABLED,
                THING_TYPE_BRICKLET_INDUSTRIAL_ANALOG_OUT);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_INDUSTRIAL_ANALOG_OUT_VOLTAGE,
                THING_TYPE_BRICKLET_INDUSTRIAL_ANALOG_OUT);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_INDUSTRIAL_ANALOG_OUT_CURRENT,
                THING_TYPE_BRICKLET_INDUSTRIAL_ANALOG_OUT);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_INDUSTRIAL_ANALOG_OUT,
                THING_TYPE_BRICKLET_INDUSTRIAL_ANALOG_OUT);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_INDUSTRIAL_ANALOG_OUT_V2_ENABLED,
                THING_TYPE_BRICKLET_INDUSTRIAL_ANALOG_OUT_V2);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_INDUSTRIAL_ANALOG_OUT_V2_VOLTAGE,
                THING_TYPE_BRICKLET_INDUSTRIAL_ANALOG_OUT_V2);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_INDUSTRIAL_ANALOG_OUT_V2_CURRENT,
                THING_TYPE_BRICKLET_INDUSTRIAL_ANALOG_OUT_V2);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_INDUSTRIAL_ANALOG_OUT_V2,
                THING_TYPE_BRICKLET_INDUSTRIAL_ANALOG_OUT_V2);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_INDUSTRIAL_COUNTER_DUTY_CYCLE,
                THING_TYPE_BRICKLET_INDUSTRIAL_COUNTER);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_INDUSTRIAL_COUNTER_PERIOD,
                THING_TYPE_BRICKLET_INDUSTRIAL_COUNTER);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_INDUSTRIAL_COUNTER_FREQUENCY,
                THING_TYPE_BRICKLET_INDUSTRIAL_COUNTER);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_INDUSTRIAL_COUNTER_VALUE,
                THING_TYPE_BRICKLET_INDUSTRIAL_COUNTER);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_INDUSTRIAL_COUNTER_COUNTER,
                THING_TYPE_BRICKLET_INDUSTRIAL_COUNTER);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_INDUSTRIAL_COUNTER,
                THING_TYPE_BRICKLET_INDUSTRIAL_COUNTER);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_INDUSTRIAL_DIGITAL_IN_4_INPUT_PIN,
                THING_TYPE_BRICKLET_INDUSTRIAL_DIGITAL_IN_4);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_INDUSTRIAL_DIGITAL_IN_4_EDGE_COUNT,
                THING_TYPE_BRICKLET_INDUSTRIAL_DIGITAL_IN_4);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_INDUSTRIAL_DIGITAL_IN_4,
                THING_TYPE_BRICKLET_INDUSTRIAL_DIGITAL_IN_4);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_INDUSTRIAL_DIGITAL_IN_4_V2_VALUE,
                THING_TYPE_BRICKLET_INDUSTRIAL_DIGITAL_IN_4_V2);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_INDUSTRIAL_DIGITAL_IN_4_V2_EDGE_COUNT,
                THING_TYPE_BRICKLET_INDUSTRIAL_DIGITAL_IN_4_V2);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_INDUSTRIAL_DIGITAL_IN_4_V2,
                THING_TYPE_BRICKLET_INDUSTRIAL_DIGITAL_IN_4_V2);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_INDUSTRIAL_DIGITAL_OUT_4_OUTPUT_PIN,
                THING_TYPE_BRICKLET_INDUSTRIAL_DIGITAL_OUT_4);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_INDUSTRIAL_DIGITAL_OUT_4_MONOFLOP,
                THING_TYPE_BRICKLET_INDUSTRIAL_DIGITAL_OUT_4);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_INDUSTRIAL_DIGITAL_OUT_4,
                THING_TYPE_BRICKLET_INDUSTRIAL_DIGITAL_OUT_4);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_INDUSTRIAL_DIGITAL_OUT_4_V2_OUTPUT_PIN,
                THING_TYPE_BRICKLET_INDUSTRIAL_DIGITAL_OUT_4_V2);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_INDUSTRIAL_DIGITAL_OUT_4_V2_MONOFLOP,
                THING_TYPE_BRICKLET_INDUSTRIAL_DIGITAL_OUT_4_V2);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_INDUSTRIAL_DIGITAL_OUT_4_V2,
                THING_TYPE_BRICKLET_INDUSTRIAL_DIGITAL_OUT_4_V2);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_INDUSTRIAL_DUAL_0_20MA_CURRENT,
                THING_TYPE_BRICKLET_INDUSTRIAL_DUAL_0_20MA);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_INDUSTRIAL_DUAL_0_20MA,
                THING_TYPE_BRICKLET_INDUSTRIAL_DUAL_0_20MA);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_INDUSTRIAL_DUAL_0_20MA_V2_CURRENT,
                THING_TYPE_BRICKLET_INDUSTRIAL_DUAL_0_20MA_V2);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_INDUSTRIAL_DUAL_0_20MA_V2,
                THING_TYPE_BRICKLET_INDUSTRIAL_DUAL_0_20MA_V2);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_INDUSTRIAL_DUAL_ANALOG_IN_VOLTAGE,
                THING_TYPE_BRICKLET_INDUSTRIAL_DUAL_ANALOG_IN);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_INDUSTRIAL_DUAL_ANALOG_IN,
                THING_TYPE_BRICKLET_INDUSTRIAL_DUAL_ANALOG_IN);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_INDUSTRIAL_DUAL_ANALOG_IN_V2_VOLTAGE,
                THING_TYPE_BRICKLET_INDUSTRIAL_DUAL_ANALOG_IN_V2);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_INDUSTRIAL_DUAL_ANALOG_IN_V2,
                THING_TYPE_BRICKLET_INDUSTRIAL_DUAL_ANALOG_IN_V2);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_INDUSTRIAL_DUAL_RELAY_RELAY,
                THING_TYPE_BRICKLET_INDUSTRIAL_DUAL_RELAY);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_INDUSTRIAL_DUAL_RELAY_MONOFLOP,
                THING_TYPE_BRICKLET_INDUSTRIAL_DUAL_RELAY);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_INDUSTRIAL_DUAL_RELAY,
                THING_TYPE_BRICKLET_INDUSTRIAL_DUAL_RELAY);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_INDUSTRIAL_QUAD_RELAY_RELAY,
                THING_TYPE_BRICKLET_INDUSTRIAL_QUAD_RELAY);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_INDUSTRIAL_QUAD_RELAY_MONOFLOP,
                THING_TYPE_BRICKLET_INDUSTRIAL_QUAD_RELAY);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_INDUSTRIAL_QUAD_RELAY,
                THING_TYPE_BRICKLET_INDUSTRIAL_QUAD_RELAY);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_INDUSTRIAL_QUAD_RELAY_V2_RELAY,
                THING_TYPE_BRICKLET_INDUSTRIAL_QUAD_RELAY_V2);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_INDUSTRIAL_QUAD_RELAY_V2_MONOFLOP,
                THING_TYPE_BRICKLET_INDUSTRIAL_QUAD_RELAY_V2);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_INDUSTRIAL_QUAD_RELAY_V2,
                THING_TYPE_BRICKLET_INDUSTRIAL_QUAD_RELAY_V2);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_IO16_INPUT_PIN, THING_TYPE_BRICKLET_IO16);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_IO16_OUTPUT_PIN, THING_TYPE_BRICKLET_IO16);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_IO16_MONOFLOP, THING_TYPE_BRICKLET_IO16);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_IO16_EDGE_COUNT, THING_TYPE_BRICKLET_IO16);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_IO16, THING_TYPE_BRICKLET_IO16);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_IO16_V2_INPUT_VALUE,
                THING_TYPE_BRICKLET_IO16_V2);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_IO16_V2_OUTPUT_PIN,
                THING_TYPE_BRICKLET_IO16_V2);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_IO16_V2_MONOFLOP,
                THING_TYPE_BRICKLET_IO16_V2);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_IO16_V2_EDGE_COUNT,
                THING_TYPE_BRICKLET_IO16_V2);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_IO16_V2, THING_TYPE_BRICKLET_IO16_V2);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_IO4_INPUT_PIN, THING_TYPE_BRICKLET_IO4);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_IO4_OUTPUT_PIN, THING_TYPE_BRICKLET_IO4);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_IO4_MONOFLOP, THING_TYPE_BRICKLET_IO4);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_IO4_EDGE_COUNT, THING_TYPE_BRICKLET_IO4);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_IO4, THING_TYPE_BRICKLET_IO4);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_IO4_V2_INPUT_VALUE,
                THING_TYPE_BRICKLET_IO4_V2);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_IO4_V2_OUTPUT_PIN,
                THING_TYPE_BRICKLET_IO4_V2);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_IO4_V2_MONOFLOP, THING_TYPE_BRICKLET_IO4_V2);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_IO4_V2_EDGE_COUNT,
                THING_TYPE_BRICKLET_IO4_V2);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_IO4_V2, THING_TYPE_BRICKLET_IO4_V2);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_ISOLATOR_MESSAGES_FROM_BRICK,
                THING_TYPE_BRICKLET_ISOLATOR);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_ISOLATOR_MESSAGES_FROM_BRICKLET,
                THING_TYPE_BRICKLET_ISOLATOR);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_ISOLATOR_CONNECTED_BRICKLET_DEVICE_NAME,
                THING_TYPE_BRICKLET_ISOLATOR);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_ISOLATOR_CONNECTED_BRICKLET_UID,
                THING_TYPE_BRICKLET_ISOLATOR);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_ISOLATOR, THING_TYPE_BRICKLET_ISOLATOR);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_JOYSTICK_POSITION,
                THING_TYPE_BRICKLET_JOYSTICK);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_JOYSTICK_ANALOG_VALUE_X,
                THING_TYPE_BRICKLET_JOYSTICK);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_JOYSTICK_ANALOG_VALUE_Y,
                THING_TYPE_BRICKLET_JOYSTICK);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_JOYSTICK, THING_TYPE_BRICKLET_JOYSTICK);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_JOYSTICK_V2_POSITION,
                THING_TYPE_BRICKLET_JOYSTICK_V2);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_JOYSTICK_V2, THING_TYPE_BRICKLET_JOYSTICK_V2);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_LASER_RANGE_FINDER_DISTANCE,
                THING_TYPE_BRICKLET_LASER_RANGE_FINDER);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_LASER_RANGE_FINDER_VELOCITY,
                THING_TYPE_BRICKLET_LASER_RANGE_FINDER);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_LASER_RANGE_FINDER_ENABLE_LASER,
                THING_TYPE_BRICKLET_LASER_RANGE_FINDER);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_LASER_RANGE_FINDER,
                THING_TYPE_BRICKLET_LASER_RANGE_FINDER);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_LASER_RANGE_FINDER_V2_DISTANCE,
                THING_TYPE_BRICKLET_LASER_RANGE_FINDER_V2);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_LASER_RANGE_FINDER_V2_VELOCITY,
                THING_TYPE_BRICKLET_LASER_RANGE_FINDER_V2);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_LASER_RANGE_FINDER_V2_ENABLE_LASER,
                THING_TYPE_BRICKLET_LASER_RANGE_FINDER_V2);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_LASER_RANGE_FINDER_V2,
                THING_TYPE_BRICKLET_LASER_RANGE_FINDER_V2);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_LCD_128X64_TEXT,
                THING_TYPE_BRICKLET_LCD_128X64);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_LCD_128X64_CLEAR_DISPLAY,
                THING_TYPE_BRICKLET_LCD_128X64);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_LCD_128X64_DRAW_BUFFERED_FRAME,
                THING_TYPE_BRICKLET_LCD_128X64);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_LCD_128X64_BACKLIGHT,
                THING_TYPE_BRICKLET_LCD_128X64);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_LCD_128X64_GUI_TAB_SELECTED,
                THING_TYPE_BRICKLET_LCD_128X64);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_LCD_128X64_GUI_SLIDER,
                THING_TYPE_BRICKLET_LCD_128X64);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_LCD_128X64, THING_TYPE_BRICKLET_LCD_128X64);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_LCD_16X2_TEXT, THING_TYPE_BRICKLET_LCD_16X2);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_LCD_16X2_CLEAR_DISPLAY,
                THING_TYPE_BRICKLET_LCD_16X2);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_LCD_16X2_BACKLIGHT,
                THING_TYPE_BRICKLET_LCD_16X2);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_LCD_16X2, THING_TYPE_BRICKLET_LCD_16X2);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_LCD_20X4_TEXT, THING_TYPE_BRICKLET_LCD_20X4);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_LCD_20X4_CLEAR_DISPLAY,
                THING_TYPE_BRICKLET_LCD_20X4);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_LCD_20X4_BACKLIGHT,
                THING_TYPE_BRICKLET_LCD_20X4);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_LCD_20X4, THING_TYPE_BRICKLET_LCD_20X4);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_LED_STRIP_LED_VALUES,
                THING_TYPE_BRICKLET_LED_STRIP);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_LED_STRIP, THING_TYPE_BRICKLET_LED_STRIP);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_LED_STRIP_V2_LED_VALUES,
                THING_TYPE_BRICKLET_LED_STRIP_V2);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_LED_STRIP_V2,
                THING_TYPE_BRICKLET_LED_STRIP_V2);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_LINE_REFLECTIVITY, THING_TYPE_BRICKLET_LINE);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_LINE, THING_TYPE_BRICKLET_LINE);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_LINEAR_POTI_POSITION,
                THING_TYPE_BRICKLET_LINEAR_POTI);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_LINEAR_POTI_ANALOG_VALUE,
                THING_TYPE_BRICKLET_LINEAR_POTI);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_LINEAR_POTI, THING_TYPE_BRICKLET_LINEAR_POTI);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_LINEAR_POTI_V2_POSITION,
                THING_TYPE_BRICKLET_LINEAR_POTI_V2);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_LINEAR_POTI_V2,
                THING_TYPE_BRICKLET_LINEAR_POTI_V2);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_LOAD_CELL_WEIGHT,
                THING_TYPE_BRICKLET_LOAD_CELL);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_LOAD_CELL_TARE,
                THING_TYPE_BRICKLET_LOAD_CELL);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_LOAD_CELL_LED, THING_TYPE_BRICKLET_LOAD_CELL);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_LOAD_CELL, THING_TYPE_BRICKLET_LOAD_CELL);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_LOAD_CELL_V2_WEIGHT,
                THING_TYPE_BRICKLET_LOAD_CELL_V2);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_LOAD_CELL_V2_TARE,
                THING_TYPE_BRICKLET_LOAD_CELL_V2);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_LOAD_CELL_V2,
                THING_TYPE_BRICKLET_LOAD_CELL_V2);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_MOISTURE_MOISTURE,
                THING_TYPE_BRICKLET_MOISTURE);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_MOISTURE, THING_TYPE_BRICKLET_MOISTURE);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_MOTION_DETECTOR,
                THING_TYPE_BRICKLET_MOTION_DETECTOR);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_MOTION_DETECTOR_V2_INDICATOR,
                THING_TYPE_BRICKLET_MOTION_DETECTOR_V2);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_MOTION_DETECTOR_V2,
                THING_TYPE_BRICKLET_MOTION_DETECTOR_V2);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_MOTORIZED_LINEAR_POTI_POSITION,
                THING_TYPE_BRICKLET_MOTORIZED_LINEAR_POTI);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_MOTORIZED_LINEAR_POTI_MOTOR_POSITION,
                THING_TYPE_BRICKLET_MOTORIZED_LINEAR_POTI);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_MOTORIZED_LINEAR_POTI,
                THING_TYPE_BRICKLET_MOTORIZED_LINEAR_POTI);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_MULTI_TOUCH_ELECTRODE,
                THING_TYPE_BRICKLET_MULTI_TOUCH);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_MULTI_TOUCH_RECALIBRATE,
                THING_TYPE_BRICKLET_MULTI_TOUCH);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_MULTI_TOUCH, THING_TYPE_BRICKLET_MULTI_TOUCH);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_MULTI_TOUCH_V2_ELECTRODE,
                THING_TYPE_BRICKLET_MULTI_TOUCH_V2);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_MULTI_TOUCH_V2_RECALIBRATE,
                THING_TYPE_BRICKLET_MULTI_TOUCH_V2);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_MULTI_TOUCH_V2,
                THING_TYPE_BRICKLET_MULTI_TOUCH_V2);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_NFC_STATE, THING_TYPE_BRICKLET_NFC);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_NFC, THING_TYPE_BRICKLET_NFC);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_NFC_RFID_STATE, THING_TYPE_BRICKLET_NFC_RFID);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_NFC_RFID, THING_TYPE_BRICKLET_NFC_RFID);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_OLED_128X64_TEXT,
                THING_TYPE_BRICKLET_OLED_128X64);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_OLED_128X64_CLEAR_DISPLAY,
                THING_TYPE_BRICKLET_OLED_128X64);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_OLED_128X64, THING_TYPE_BRICKLET_OLED_128X64);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_OLED_128X64_V2_TEXT,
                THING_TYPE_BRICKLET_OLED_128X64_V2);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_OLED_128X64_V2_CLEAR_DISPLAY,
                THING_TYPE_BRICKLET_OLED_128X64_V2);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_OLED_128X64_V2_DRAW_BUFFERED_FRAME,
                THING_TYPE_BRICKLET_OLED_128X64_V2);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_OLED_128X64_V2,
                THING_TYPE_BRICKLET_OLED_128X64_V2);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_OLED_64X48_TEXT,
                THING_TYPE_BRICKLET_OLED_64X48);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_OLED_64X48_CLEAR_DISPLAY,
                THING_TYPE_BRICKLET_OLED_64X48);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_OLED_64X48, THING_TYPE_BRICKLET_OLED_64X48);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_ONE_WIRE, THING_TYPE_BRICKLET_ONE_WIRE);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_OUTDOOR_WEATHER_SENSOR_IDENTIFIERS,
                THING_TYPE_BRICKLET_OUTDOOR_WEATHER);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_OUTDOOR_WEATHER_STATION_IDENTIFIERS,
                THING_TYPE_BRICKLET_OUTDOOR_WEATHER);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_OUTDOOR_WEATHER,
                THING_TYPE_BRICKLET_OUTDOOR_WEATHER);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_PARTICULATE_MATTER_PM10_CONCENTRATION,
                THING_TYPE_BRICKLET_PARTICULATE_MATTER);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_PARTICULATE_MATTER_PM25_CONCENTRATION,
                THING_TYPE_BRICKLET_PARTICULATE_MATTER);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_PARTICULATE_MATTER_PM100_CONCENTRATION,
                THING_TYPE_BRICKLET_PARTICULATE_MATTER);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_PARTICULATE_MATTER_PART_COUNT_3,
                THING_TYPE_BRICKLET_PARTICULATE_MATTER);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_PARTICULATE_MATTER_PART_COUNT_5,
                THING_TYPE_BRICKLET_PARTICULATE_MATTER);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_PARTICULATE_MATTER_PART_COUNT_10,
                THING_TYPE_BRICKLET_PARTICULATE_MATTER);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_PARTICULATE_MATTER_PART_COUNT_25,
                THING_TYPE_BRICKLET_PARTICULATE_MATTER);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_PARTICULATE_MATTER_PART_COUNT_50,
                THING_TYPE_BRICKLET_PARTICULATE_MATTER);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_PARTICULATE_MATTER_PART_COUNT_100,
                THING_TYPE_BRICKLET_PARTICULATE_MATTER);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_PARTICULATE_MATTER_SENSOR_ENABLED,
                THING_TYPE_BRICKLET_PARTICULATE_MATTER);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_PARTICULATE_MATTER,
                THING_TYPE_BRICKLET_PARTICULATE_MATTER);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_PIEZO_BUZZER_BEEP,
                THING_TYPE_BRICKLET_PIEZO_BUZZER);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_PIEZO_BUZZER_MORSE_CODE,
                THING_TYPE_BRICKLET_PIEZO_BUZZER);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_PIEZO_BUZZER,
                THING_TYPE_BRICKLET_PIEZO_BUZZER);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_PIEZO_SPEAKER,
                THING_TYPE_BRICKLET_PIEZO_SPEAKER);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_PIEZO_SPEAKER_V2_BEEP,
                THING_TYPE_BRICKLET_PIEZO_SPEAKER_V2);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_PIEZO_SPEAKER_V2_ALARM,
                THING_TYPE_BRICKLET_PIEZO_SPEAKER_V2);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_PIEZO_SPEAKER_V2_VOLUME,
                THING_TYPE_BRICKLET_PIEZO_SPEAKER_V2);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_PIEZO_SPEAKER_V2_BEEP_FREQUENCY,
                THING_TYPE_BRICKLET_PIEZO_SPEAKER_V2);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_PIEZO_SPEAKER_V2,
                THING_TYPE_BRICKLET_PIEZO_SPEAKER_V2);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_PTC_TEMPERATURE, THING_TYPE_BRICKLET_PTC);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_PTC_RESISTANCE, THING_TYPE_BRICKLET_PTC);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_PTC_SENSOR_CONNECTED,
                THING_TYPE_BRICKLET_PTC);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_PTC, THING_TYPE_BRICKLET_PTC);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_PTC_V2_TEMPERATURE,
                THING_TYPE_BRICKLET_PTC_V2);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_PTC_V2_RESISTANCE,
                THING_TYPE_BRICKLET_PTC_V2);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_PTC_V2_SENSOR_CONNECTED,
                THING_TYPE_BRICKLET_PTC_V2);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_PTC_V2, THING_TYPE_BRICKLET_PTC_V2);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_REAL_TIME_CLOCK_DATE_TIME,
                THING_TYPE_BRICKLET_REAL_TIME_CLOCK);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_REAL_TIME_CLOCK_TIMESTAMP,
                THING_TYPE_BRICKLET_REAL_TIME_CLOCK);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_REAL_TIME_CLOCK,
                THING_TYPE_BRICKLET_REAL_TIME_CLOCK);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_REAL_TIME_CLOCK_V2_DATE_TIME,
                THING_TYPE_BRICKLET_REAL_TIME_CLOCK_V2);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_REAL_TIME_CLOCK_V2_TIMESTAMP,
                THING_TYPE_BRICKLET_REAL_TIME_CLOCK_V2);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_REAL_TIME_CLOCK_V2,
                THING_TYPE_BRICKLET_REAL_TIME_CLOCK_V2);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_REMOTE_SWITCH,
                THING_TYPE_BRICKLET_REMOTE_SWITCH);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_REMOTE_SWITCH_V2,
                THING_TYPE_BRICKLET_REMOTE_SWITCH_V2);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_RGB_LED_BUTTON_COLOR,
                THING_TYPE_BRICKLET_RGB_LED_BUTTON);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_RGB_LED_BUTTON,
                THING_TYPE_BRICKLET_RGB_LED_BUTTON);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_RGB_LED_COLOR, THING_TYPE_BRICKLET_RGB_LED);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_RGB_LED, THING_TYPE_BRICKLET_RGB_LED);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_RGB_LED_MATRIX_LED_VALUES,
                THING_TYPE_BRICKLET_RGB_LED_MATRIX);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_RGB_LED_MATRIX,
                THING_TYPE_BRICKLET_RGB_LED_MATRIX);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_RGB_LED_V2_COLOR,
                THING_TYPE_BRICKLET_RGB_LED_V2);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_RGB_LED_V2, THING_TYPE_BRICKLET_RGB_LED_V2);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_ROTARY_ENCODER_COUNT,
                THING_TYPE_BRICKLET_ROTARY_ENCODER);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_ROTARY_ENCODER_RESET_COUNTER,
                THING_TYPE_BRICKLET_ROTARY_ENCODER);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_ROTARY_ENCODER,
                THING_TYPE_BRICKLET_ROTARY_ENCODER);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_ROTARY_ENCODER_V2_COUNT,
                THING_TYPE_BRICKLET_ROTARY_ENCODER_V2);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_ROTARY_ENCODER_V2_RESET_COUNTER,
                THING_TYPE_BRICKLET_ROTARY_ENCODER_V2);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_ROTARY_ENCODER_V2,
                THING_TYPE_BRICKLET_ROTARY_ENCODER_V2);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_ROTARY_POTI_POSITION,
                THING_TYPE_BRICKLET_ROTARY_POTI);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_ROTARY_POTI_ANALOG_VALUE,
                THING_TYPE_BRICKLET_ROTARY_POTI);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_ROTARY_POTI, THING_TYPE_BRICKLET_ROTARY_POTI);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_ROTARY_POTI_V2_POSITION,
                THING_TYPE_BRICKLET_ROTARY_POTI_V2);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_ROTARY_POTI_V2,
                THING_TYPE_BRICKLET_ROTARY_POTI_V2);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_RS232, THING_TYPE_BRICKLET_RS232);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_RS232_V2_OVERRUN_ERROR_COUNT,
                THING_TYPE_BRICKLET_RS232_V2);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_RS232_V2_PARITY_ERROR_COUNT,
                THING_TYPE_BRICKLET_RS232_V2);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_RS232_V2_SEND_BUFFER_USED,
                THING_TYPE_BRICKLET_RS232_V2);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_RS232_V2_RECEIVE_BUFFER_USED,
                THING_TYPE_BRICKLET_RS232_V2);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_RS232_V2, THING_TYPE_BRICKLET_RS232_V2);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_RS485_OVERRUN_ERROR_COUNT,
                THING_TYPE_BRICKLET_RS485);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_RS485_PARITY_ERROR_COUNT,
                THING_TYPE_BRICKLET_RS485);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_RS485_MODBUS_ERROR,
                THING_TYPE_BRICKLET_RS485);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_RS485_SEND_BUFFER_USED,
                THING_TYPE_BRICKLET_RS485);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_RS485_RECEIVE_BUFFER_USED,
                THING_TYPE_BRICKLET_RS485);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_RS485, THING_TYPE_BRICKLET_RS485);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_SEGMENT_DISPLAY_4X7_BRIGHTNESS,
                THING_TYPE_BRICKLET_SEGMENT_DISPLAY_4X7);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_SEGMENT_DISPLAY_4X7_SEGMENTS,
                THING_TYPE_BRICKLET_SEGMENT_DISPLAY_4X7);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_SEGMENT_DISPLAY_4X7_COLON,
                THING_TYPE_BRICKLET_SEGMENT_DISPLAY_4X7);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_SEGMENT_DISPLAY_4X7_TEXT,
                THING_TYPE_BRICKLET_SEGMENT_DISPLAY_4X7);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_SEGMENT_DISPLAY_4X7,
                THING_TYPE_BRICKLET_SEGMENT_DISPLAY_4X7);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_SEGMENT_DISPLAY_4X7_V2_BRIGHTNESS,
                THING_TYPE_BRICKLET_SEGMENT_DISPLAY_4X7_V2);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_SEGMENT_DISPLAY_4X7_V2_SEGMENTS,
                THING_TYPE_BRICKLET_SEGMENT_DISPLAY_4X7_V2);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_SEGMENT_DISPLAY_4X7_V2_COLON_UPPER,
                THING_TYPE_BRICKLET_SEGMENT_DISPLAY_4X7_V2);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_SEGMENT_DISPLAY_4X7_V2_COLON_LOWER,
                THING_TYPE_BRICKLET_SEGMENT_DISPLAY_4X7_V2);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_SEGMENT_DISPLAY_4X7_V2_TICK,
                THING_TYPE_BRICKLET_SEGMENT_DISPLAY_4X7_V2);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_SEGMENT_DISPLAY_4X7_V2_TEXT,
                THING_TYPE_BRICKLET_SEGMENT_DISPLAY_4X7_V2);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_SEGMENT_DISPLAY_4X7_V2,
                THING_TYPE_BRICKLET_SEGMENT_DISPLAY_4X7_V2);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_SOLID_STATE_RELAY_RELAY,
                THING_TYPE_BRICKLET_SOLID_STATE_RELAY);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_SOLID_STATE_RELAY_MONOFLOP,
                THING_TYPE_BRICKLET_SOLID_STATE_RELAY);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_SOLID_STATE_RELAY,
                THING_TYPE_BRICKLET_SOLID_STATE_RELAY);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_SOLID_STATE_RELAY_V2_RELAY,
                THING_TYPE_BRICKLET_SOLID_STATE_RELAY_V2);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_SOLID_STATE_RELAY_V2_MONOFLOP,
                THING_TYPE_BRICKLET_SOLID_STATE_RELAY_V2);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_SOLID_STATE_RELAY_V2,
                THING_TYPE_BRICKLET_SOLID_STATE_RELAY_V2);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_SOUND_INTENSITY_INTENSITY,
                THING_TYPE_BRICKLET_SOUND_INTENSITY);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_SOUND_INTENSITY,
                THING_TYPE_BRICKLET_SOUND_INTENSITY);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_SOUND_PRESSURE_LEVEL_DECIBEL,
                THING_TYPE_BRICKLET_SOUND_PRESSURE_LEVEL);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_SOUND_PRESSURE_LEVEL,
                THING_TYPE_BRICKLET_SOUND_PRESSURE_LEVEL);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_TEMPERATURE_TEMPERATURE,
                THING_TYPE_BRICKLET_TEMPERATURE);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_TEMPERATURE, THING_TYPE_BRICKLET_TEMPERATURE);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_TEMPERATURE_IR_AMBIENT_TEMPERATURE,
                THING_TYPE_BRICKLET_TEMPERATURE_IR);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_TEMPERATURE_IR_OBJECT_TEMPERATURE,
                THING_TYPE_BRICKLET_TEMPERATURE_IR);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_TEMPERATURE_IR,
                THING_TYPE_BRICKLET_TEMPERATURE_IR);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_TEMPERATURE_IR_V2_AMBIENT_TEMPERATURE,
                THING_TYPE_BRICKLET_TEMPERATURE_IR_V2);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_TEMPERATURE_IR_V2_OBJECT_TEMPERATURE,
                THING_TYPE_BRICKLET_TEMPERATURE_IR_V2);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_TEMPERATURE_IR_V2,
                THING_TYPE_BRICKLET_TEMPERATURE_IR_V2);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_TEMPERATURE_V2_TEMPERATURE,
                THING_TYPE_BRICKLET_TEMPERATURE_V2);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_TEMPERATURE_V2_HEATER,
                THING_TYPE_BRICKLET_TEMPERATURE_V2);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_TEMPERATURE_V2,
                THING_TYPE_BRICKLET_TEMPERATURE_V2);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_THERMAL_IMAGING_HIGH_CONTRAST_IMAGE,
                THING_TYPE_BRICKLET_THERMAL_IMAGING);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_THERMAL_IMAGING_TEMPERATURE_IMAGE,
                THING_TYPE_BRICKLET_THERMAL_IMAGING);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_THERMAL_IMAGING_TEMPERATURE,
                THING_TYPE_BRICKLET_THERMAL_IMAGING);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_THERMAL_IMAGING_SPOTMETER_ROI_PIXEL_COUNT,
                THING_TYPE_BRICKLET_THERMAL_IMAGING);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_THERMAL_IMAGING_FFC_STATUS,
                THING_TYPE_BRICKLET_THERMAL_IMAGING);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_THERMAL_IMAGING_SHUTTER_LOCKOUT,
                THING_TYPE_BRICKLET_THERMAL_IMAGING);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(
                CONFIG_DESCRIPTION_URI_BRICKLET_THERMAL_IMAGING_OVERTEMPERATURE_SHUTDOWN_IMMINENT,
                THING_TYPE_BRICKLET_THERMAL_IMAGING);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_THERMAL_IMAGING,
                THING_TYPE_BRICKLET_THERMAL_IMAGING);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_THERMOCOUPLE_TEMPERATURE,
                THING_TYPE_BRICKLET_THERMOCOUPLE);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_THERMOCOUPLE_OVER_UNDER_VOLTAGE,
                THING_TYPE_BRICKLET_THERMOCOUPLE);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_THERMOCOUPLE_OPEN_CIRCUIT,
                THING_TYPE_BRICKLET_THERMOCOUPLE);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_THERMOCOUPLE,
                THING_TYPE_BRICKLET_THERMOCOUPLE);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_THERMOCOUPLE_V2_TEMPERATURE,
                THING_TYPE_BRICKLET_THERMOCOUPLE_V2);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_THERMOCOUPLE_V2_OVER_UNDER_VOLTAGE,
                THING_TYPE_BRICKLET_THERMOCOUPLE_V2);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_THERMOCOUPLE_V2_OPEN_CIRCUIT,
                THING_TYPE_BRICKLET_THERMOCOUPLE_V2);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_THERMOCOUPLE_V2,
                THING_TYPE_BRICKLET_THERMOCOUPLE_V2);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_TILT_TILTED, THING_TYPE_BRICKLET_TILT);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_TILT_VIBRATING, THING_TYPE_BRICKLET_TILT);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_TILT, THING_TYPE_BRICKLET_TILT);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_UV_LIGHT_UV_LIGHT,
                THING_TYPE_BRICKLET_UV_LIGHT);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_UV_LIGHT, THING_TYPE_BRICKLET_UV_LIGHT);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_UV_LIGHT_V2_UVA,
                THING_TYPE_BRICKLET_UV_LIGHT_V2);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_UV_LIGHT_V2_UVB,
                THING_TYPE_BRICKLET_UV_LIGHT_V2);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_UV_LIGHT_V2_UVI,
                THING_TYPE_BRICKLET_UV_LIGHT_V2);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_UV_LIGHT_V2, THING_TYPE_BRICKLET_UV_LIGHT_V2);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_VOLTAGE_VOLTAGE, THING_TYPE_BRICKLET_VOLTAGE);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_VOLTAGE_ANALOG_VALUE,
                THING_TYPE_BRICKLET_VOLTAGE);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_VOLTAGE, THING_TYPE_BRICKLET_VOLTAGE);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_VOLTAGE_CURRENT_VOLTAGE,
                THING_TYPE_BRICKLET_VOLTAGE_CURRENT);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_VOLTAGE_CURRENT_CURRENT,
                THING_TYPE_BRICKLET_VOLTAGE_CURRENT);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_VOLTAGE_CURRENT_POWER,
                THING_TYPE_BRICKLET_VOLTAGE_CURRENT);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_VOLTAGE_CURRENT,
                THING_TYPE_BRICKLET_VOLTAGE_CURRENT);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_VOLTAGE_CURRENT_V2_VOLTAGE,
                THING_TYPE_BRICKLET_VOLTAGE_CURRENT_V2);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_VOLTAGE_CURRENT_V2_CURRENT,
                THING_TYPE_BRICKLET_VOLTAGE_CURRENT_V2);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_VOLTAGE_CURRENT_V2_POWER,
                THING_TYPE_BRICKLET_VOLTAGE_CURRENT_V2);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_VOLTAGE_CURRENT_V2,
                THING_TYPE_BRICKLET_VOLTAGE_CURRENT_V2);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_XMC1400_BREAKOUT_COUNT,
                THING_TYPE_BRICKLET_XMC1400_BREAKOUT);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_XMC1400_BREAKOUT_ADC_VALUE,
                THING_TYPE_BRICKLET_XMC1400_BREAKOUT);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_BRICKLET_XMC1400_BREAKOUT,
                THING_TYPE_BRICKLET_XMC1400_BREAKOUT);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_OUTDOOR_WEATHER_SENSOR,
                THING_TYPE_OUTDOOR_WEATHER_SENSOR);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_OUTDOOR_WEATHER_SENSOR_TEMPERATURE,
                THING_TYPE_OUTDOOR_WEATHER_SENSOR);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_OUTDOOR_WEATHER_SENSOR_HUMIDITY,
                THING_TYPE_OUTDOOR_WEATHER_SENSOR);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_OUTDOOR_WEATHER_SENSOR_LAST_CHANGE,
                THING_TYPE_OUTDOOR_WEATHER_SENSOR);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_OUTDOOR_WEATHER_STATION,
                THING_TYPE_OUTDOOR_WEATHER_STATION);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_OUTDOOR_WEATHER_STATION_TEMPERATURE,
                THING_TYPE_OUTDOOR_WEATHER_STATION);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_OUTDOOR_WEATHER_STATION_HUMIDITY,
                THING_TYPE_OUTDOOR_WEATHER_STATION);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_OUTDOOR_WEATHER_STATION_WIND_SPEED,
                THING_TYPE_OUTDOOR_WEATHER_STATION);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_OUTDOOR_WEATHER_STATION_GUST_SPEED,
                THING_TYPE_OUTDOOR_WEATHER_STATION);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_OUTDOOR_WEATHER_STATION_RAIN_FALL,
                THING_TYPE_OUTDOOR_WEATHER_STATION);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_OUTDOOR_WEATHER_STATION_WIND_DIRECTION,
                THING_TYPE_OUTDOOR_WEATHER_STATION);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_OUTDOOR_WEATHER_STATION_BATTERY_LOW,
                THING_TYPE_OUTDOOR_WEATHER_STATION);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_OUTDOOR_WEATHER_STATION_LAST_CHANGE,
                THING_TYPE_OUTDOOR_WEATHER_STATION);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_REMOTE_SOCKET_TYPE_A, THING_TYPE_REMOTE_SOCKET_TYPE_A);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_REMOTE_SOCKET_TYPE_A_COMMAND,
                THING_TYPE_REMOTE_SOCKET_TYPE_A);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_REMOTE_SOCKET_TYPE_B, THING_TYPE_REMOTE_SOCKET_TYPE_B);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_REMOTE_SOCKET_TYPE_B_COMMAND,
                THING_TYPE_REMOTE_SOCKET_TYPE_B);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_REMOTE_SOCKET_TYPE_C, THING_TYPE_REMOTE_SOCKET_TYPE_C);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_REMOTE_SOCKET_TYPE_C_COMMAND,
                THING_TYPE_REMOTE_SOCKET_TYPE_C);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_REMOTE_DIMMER_TYPE_B, THING_TYPE_REMOTE_DIMMER_TYPE_B);
        SUPPORTED_CONFIG_DESCRIPTIONS.put(CONFIG_DESCRIPTION_URI_REMOTE_DIMMER_TYPE_B_VALUE,
                THING_TYPE_REMOTE_DIMMER_TYPE_B);
    }
}
